<?php

namespace APP\Controllers;

use App\Models\ClientHome;
use App\Models\ClientLocation;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;

require '../config/env.php';
class ClientHomeController
{
    public function getbusinessType(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        // $domain = $params['domain'];
        $domain = $this->extractDomain($params['domain']);
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $businessType['businessType'] = $getClientDetails['bkenable'];

        if (is_numeric($businessType['businessType'])) {
            $responseData = [
                "status" => true,
                "data" => $businessType,
                "message" => "Provided Successfully",
                "response_code" => 200,
            ];

            $response->getBody()->write(json_encode($responseData));
            return $response;
        } else {

            $responseData = [
                "status" => false,
                "message" => "Business Type  is Empty",
                "response_code" => 400,
            ];

            $response->getBody()->write(json_encode($responseData));
            return $response;
        }
    }

    public function extractDomain($url)
    {

        // Remove protocol (http/https), www., and slashes

        $url = str_replace(array('http://', 'https://', 'www.'), '', $url);



        // Parse the URL and extract the host

        $parsedUrl = parse_url($url);

        $domain = isset($parsedUrl['path']) ? $parsedUrl['path'] : '';



        // Extract the domain name

        //  $parts = explode('.', $host);

        // $domain = implode('.', array_slice($parts, -2));

        return $domain;
    }


    public function getBannerSection(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = ["status" => false, "message" => "Domain Name is Empty", "response_code" => 400,];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        # 1 - Enabled Banner Section
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $getLandingPageConfig = $home->getLandingPageConfig();
        $result = array();
        $bannerDealCss=array();
        $getBannerDealCss=$home->getBannerDealCss();
        
        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $black_background="#000000";

        if(isset($getBannerDealCss->id))
        {
            $bannerDealCss['foregroundColor']=(isset($getBannerDealCss->foreground_color) && !empty($getBannerDealCss->foreground_color)) 
                                                                        ? $getBannerDealCss->foreground_color 
                                                                        : $black_background;
        }
        if ($getLandingPageConfig->banner == 1) {
            $getbannerContents = $home->getbannerContents();
            if (!empty($getbannerContents)) {
               
                foreach ($getbannerContents as $key => $getbanner) {
                    $homePageDetails['banner'][$key]['title']       = $getbanner->title;
                    $homePageDetails['banner'][$key]['subTitle']    = $getbanner->subTitle;
                    $homePageDetails['banner'][$key]['description'] = $getbanner->description;

                    $homePageDetails['banner'][$key]['button1Name'] = $getbanner->button1Name;
                    $homePageDetails['banner'][$key]['button1NameUrl'] = $getbanner->button1NameUrl;
                    $homePageDetails['banner'][$key]['button2Name'] = $getbanner->button2Name;
                    $homePageDetails['banner'][$key]['button2NameUrl'] = $getbanner->button2NameUrl;

                    $homePageDetails['banner'][$key]['bgImageSort'] = $getbanner->bgImageSort;
                    $homePageDetails['banner'][$key]['status']      = $getbanner->status;
                    $homePageDetails['banner'][$key]['pipPosition'] = $getbanner->pipPosition;

                    $homePageDetails['banner'][$key]['bgImage']     = $_ENV['FUSION_BUCKET_URL']['BannerImages'] . $getClientDetails['client_id'] . "/" . $getbanner->bgImage;
                    $homePageDetails['banner'][$key]['pipImage']    = $_ENV['FUSION_BUCKET_URL']['PIPImages'] . $getClientDetails['client_id'] . "/" . $getbanner->pipImage;
                    $homePageDetails['banner'][$key]['orderNowLink'] = $_ENV["SOCIAL"]["FK"] . "/" . $getClientDetails['client_menu_path'] . "/menu";

                    $homePageDetails['banner'][$key]['title_font_weight'] = 
                    (!empty($getbanner->title_font_weight) ? $getbanner->title_font_weight : 'normal');
                
                    $homePageDetails['banner'][$key]['title_font_size'] = 
                        (!empty($getbanner->title_font_size) ? $getbanner->title_font_size : '20px');
                    
                    $homePageDetails['banner'][$key]['subtitle_font_weight'] = 
                        (!empty($getbanner->subtitle_font_weight) ? $getbanner->subtitle_font_weight : 'normal');
                    
                    $homePageDetails['banner'][$key]['subtitle_font_size'] = 
                        (!empty($getbanner->subtitle_font_size) ? $getbanner->subtitle_font_size : '20px');
                    
                    $homePageDetails['banner'][$key]['description_font_weight'] = 
                        (!empty($getbanner->description_font_weight) ? $getbanner->description_font_weight : 'normal');
                    
                    $homePageDetails['banner'][$key]['description_font_size'] = 
                        (!empty($getbanner->description_font_size) ? $getbanner->description_font_size : '20px');
                
                }
            } else {
                $homePageDetails['banner'] = '';
                $homePageDetails['offerbanner'] = '';
             
                $homePageDetails['bannerDealCss']=$bannerDealCss;

                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'Banner Contents is Empty';

                $response->getBody()->write(json_encode($result));
                return $response;
            }

            $getofferbanners = $home->getofferbanner();
            if (!empty($getofferbanners)) {
                foreach ($getofferbanners as $key => $getoffer) {
                    $getoffer  = json_decode($getoffer->banner, true);
                    $homePageDetails['offerbanner'][$key] = $getoffer;
                }
            } else {
                $homePageDetails['offerbanner'] = '';
            }

           
        }
        $homePageDetails['bannerDealCss']=$bannerDealCss;
        $getAllowBar = $home->getAllowBar();
        $connection_close=$home->connectionClose();
        if (!empty($getAllowBar)) {
            $homePageDetails['allowBar'] = $getAllowBar;
        } else {
            $homePageDetails['allowBar'] = '';
        }

        $result['status'] = true;
        $result['data']   = $homePageDetails;
        $result['response_code'] = 200;
        $result['message'] = 'Home Banner Details Provided';
        $response->getBody()->write(json_encode($result));
        return $response;
    }



    public function getMealDeal(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        $result = array();
        # 1 - Enabled mealDeal Section
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $getLandingPageConfig = $home->getLandingPageConfig();
        $client_id = $home->client_id;

        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';

        $white_background="#ffffff";
        $black_background="#000000";
        
        if ($getLandingPageConfig->mealDeal == 1) {

            $getMealDealContent = $home->getMealDealContent();
            if (!empty($getMealDealContent)) {
                $homePageDetails['MealDealContent']['title']       = $getMealDealContent->title;
                $homePageDetails['MealDealContent']['subTitle']    = $getMealDealContent->subTitle;
                $homePageDetails['MealDealContent']['description'] = $getMealDealContent->description;
                $homePageDetails['MealDealContent']['buttonName']  = $getMealDealContent->buttonName;
                $homePageDetails['MealDealContent']['orderNowLink'] = $_ENV["SOCIAL"]["FK"] . "/" . $getClientDetails['client_menu_path'] . "/menu";
                $homePageDetails['MealDealContent']['status']      = $getMealDealContent->status;
                $homePageDetails['MealDealCss']['foregroundColor']=	(isset($getMealDealContent->foreground_color) && !empty($getMealDealContent->foreground_color)) 
                                                                        ? $getMealDealContent->foreground_color 
                                                                        : $black_background;;
                $homePageDetails['MealDealCss']['backgroundColor']=(isset($getMealDealContent->background_color) && !empty($getMealDealContent->background_color)) 
                                                                        ? $getMealDealContent->background_color 
                                                                        : $white_background;

                $result['status'] = true;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 200;
                $result['message'] = 'MealDeal Contents Provided';
            } else {
                $homePageDetails['MealDealContent'] = '';
                $homePageDetails['MealDealCss']='';
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'MealDeal Contents is Empty';
            }

            $getMealDealItems = $home->getMealDealItems($client_id);
            if (!empty($getMealDealItems)) {
                $oneBasedDay  = date('N');
                $getMealDealItems = json_decode(json_encode($getMealDealItems), true);
                foreach ($getMealDealItems as $key => $getMealDeal) {
                    $currentTime = strtotime(date('h:i A'));
                    # item available function based on category,sub category and item working times 
                    $categoryTime    = $getMealDeal["categoryTime" . $oneBasedDay];
                    $subCategoryTime = $getMealDeal["subCategoryTime" . $oneBasedDay];
                    $itemTime  = $getMealDeal["itemTime" . $oneBasedDay];
                    $available = $home->checkAvailableItem($categoryTime, $subCategoryTime, $itemTime, $currentTime);

                    # New menu price functionalities
                    $itemPrice      = $getMealDeal['itemPrice'];
                    $increaseType   = $getMealDeal['fkPriceType'];
                    $percentageType = $getMealDeal['fkPercentageType'];
                    $extraPrice     = $getMealDeal['fkPrice'];
                    $priceEnable    = $getMealDeal['fkPriceStatus'];
                    $priceMode      = $getMealDeal['fkPriceMode'];
                    $price = $home->getItemPriceValue($itemPrice, $increaseType, $percentageType, $extraPrice, $priceEnable, $priceMode, $currentTime);

                    $getMealDeal['itemImage'] = $getMealDeal['itemImage'] ? $_ENV['FUSION_BUCKET_URL']['itemImage'] . $getMealDeal['itemImage'] : $getMealDeal['itemImage'];
                    $homePageDetails['MealDeal']['items'][$key]['categoryId']             = $getMealDeal['categoryId'];
                    $homePageDetails['MealDeal']['items'][$key]['categoryName']           = $getMealDeal['categoryName'];
                    $homePageDetails['MealDeal']['items'][$key]['categoryAnotherName']    = $getMealDeal['categoryAnotherName'];
                    $homePageDetails['MealDeal']['items'][$key]['categoryAllowOffer']     = $getMealDeal['categoryAllowOffer'];
                    $homePageDetails['MealDeal']['items'][$key]['categoryAllowGift']      = $getMealDeal['categoryAllowGift'];
                    $homePageDetails['MealDeal']['items'][$key]['subCategoryId']          = $getMealDeal['subCategoryId'];
                    $homePageDetails['MealDeal']['items'][$key]['subCategoryName']        = $getMealDeal['subCategoryName'];
                    $homePageDetails['MealDeal']['items'][$key]['subCategoryAnotherName'] = $getMealDeal['subCategoryAnotherName'];
                    $homePageDetails['MealDeal']['items'][$key]['subCategoryDesc']        = $getMealDeal['subCategoryDesc'];
                    $homePageDetails['MealDeal']['items'][$key]['subCategoryAllowOffer']  = $getMealDeal['subCategoryAllowOffer'];
                    $homePageDetails['MealDeal']['items'][$key]['subCategoryAllowGift']   = $getMealDeal['subCategoryAllowGift'];
                    $homePageDetails['MealDeal']['items'][$key]['itemId']                 = $getMealDeal['itemId'];
                    $homePageDetails['MealDeal']['items'][$key]['itemImage']              = $getMealDeal['itemImage'];
                    $homePageDetails['MealDeal']['items'][$key]['itemName']               = $getMealDeal['itemName'];
                    $homePageDetails['MealDeal']['items'][$key]['itemAnotherName']        = $getMealDeal['itemAnotherName'];
                    $homePageDetails['MealDeal']['items'][$key]['itemDesc']               = $getMealDeal['itemDesc'];
                    $homePageDetails['MealDeal']['items'][$key]['available']              = $available;
                    $homePageDetails['MealDeal']['items'][$key]['price']                  = $price;
                    $homePageDetails['MealDeal']['items'][$key]['itemAddon']              = $getMealDeal['itemAddon'];
                    $homePageDetails['MealDeal']['items'][$key]['itemFreeAddon']          = $getMealDeal['itemFreeAddon'];
                    $homePageDetails['MealDeal']['items'][$key]['itemAllowOffer']         = $getMealDeal['itemAllowOffer'];
                    $homePageDetails['MealDeal']['items'][$key]['itemAllowGift']          = $getMealDeal['itemAllowGift'];

                    $result['status'] = true;
                    $result['data']   = $homePageDetails;
                    $result['response_code'] = 200;
                    $result['message'] = 'MealDeal Items Provided';
                }
            } else {
                $homePageDetails['MealDeal'] = array();
              
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'MealDeal Contents is Empty';
            }
        } else {
            $homePageDetails['MealDeal'] = array();
            $homePageDetails['MealDealCss']=array();
            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'MealDeal Config Disabled';
        }
        $home->connectionClose();
        $response->getBody()->write(json_encode($result));
        return $response;
    }



    public function getAboutUs(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $getLandingPageConfig = $home->getLandingPageConfig();
        if (!empty($getLandingPageConfig)) {
            $getLandingPageConfig  = json_decode(json_encode($getLandingPageConfig), true);
        }

        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $white_background="#ffffff";
        $black_background="#000000";

        # 1 - Enabled aboutUs Section
        if ($getLandingPageConfig['aboutUs'] == 1) {
            $getAboutUs = $home->getAboutUs();

            if (!empty($getAboutUs)) {
                $homePageDetails['AboutUs']['title'] = $getAboutUs->title;
                $homePageDetails['AboutUs']['subTitle'] = $getAboutUs->subTitle;
                $homePageDetails['AboutUs']['description'] = $getAboutUs->description;
                $homePageDetails['AboutUs']['imageName'] = $_ENV['FUSION_BUCKET_URL']['AboutUs'] . $getClientDetails['client_id'] . "/" . $getAboutUs->imageName;
                $homePageDetails['AboutUs']['status'] = $getAboutUs->status;
                $homePageDetails['AboutUsCss']['foregroundColor'] = (isset($getAboutUs->foreground_color) && !empty($getAboutUs->foreground_color)) 
                                                                        ? $getAboutUs->foreground_color 
                                                                        : $black_background;
                $homePageDetails['AboutUsCss']['backgroundColor'] =(isset($getAboutUs->background_color) && !empty($getAboutUs->background_color)) 
                                                                    ? $getAboutUs->background_color 
                                                                    : $white_background; 

                $result['status'] = true;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 200;
                $result['message'] = 'AboutUs Content Provided';
            } else {

                $homePageDetails['AboutUs'] = array();
                $homePageDetails['AboutUsCss']=array();
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'AboutUs Contents is Empty';
            }
        } else {

            $homePageDetails['AboutUs'] = array();
            $homePageDetails['AboutUsCss']=array();
            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'AboutUs Config Disabled';
        }
        $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($result));
        return $response;
    }



    public function getSignUp(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);


        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $getLandingPageConfig = $home->getLandingPageConfig();
        if (!empty($getLandingPageConfig)) {
            $getLandingPageConfig  = json_decode(json_encode($getLandingPageConfig), true);
        }

        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $white_background="#ffffff";
        $black_background="#000000";

        # 1 - Enabled signUp Section
        if ($getLandingPageConfig['signUp'] == 1) {
            $getSignUp = $home->getSignUp();
            if (!empty($getSignUp)) {
                $homePageDetails['signUp']['title'] = $getSignUp->title;
                $homePageDetails['signUp']['subTitle'] = $getSignUp->subTitle;
                $homePageDetails['signUp']['description'] = $getSignUp->description;
                $homePageDetails['signUp']['bgImageName'] = $_ENV['FUSION_BUCKET_URL']['Signup'] . $getClientDetails['client_id'] . "/" . $getSignUp->bgImageName;
                $homePageDetails['signUp']['status'] = $getSignUp->status;
                $homePageDetails['signUpCss']['foregroundColor'] = (isset($getSignUp->foreground_color) && !empty($getSignUp->foreground_color)) 
                                                                        ? $getSignUp->foreground_color 
                                                                        : $black_background;
                $homePageDetails['signUpCss']['backgroundColor'] = (isset($getSignUp->background_color) && !empty($getSignUp->background_color)) 
                                                                        ? $getSignUp->background_color 
                                                                        : $white_background;;

                $result['status'] = true;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 200;
                $result['message'] = 'SignUp Content Provided';
            } else {
                $homePageDetails['signUp'] = array();
                $result['status'] = false;
                $homePageDetails['signUpCss']=array();
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'SignUp Content Empty';
                
            }
        } else {
            $homePageDetails['signUp'] = array();
            $homePageDetails['signUpCss']=array();
            $result['status'] = false;
            
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'SignUp Config Disabled';
        }
        $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($result));
        return $response;
    }


    public function getGallery(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $getLandingPageConfig = $home->getLandingPageConfig();
        if (!empty($getLandingPageConfig)) {
            $getLandingPageConfig  = json_decode(json_encode($getLandingPageConfig), true);
        }

        
        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $white_background="#ffffff";
        $black_background="#000000";
        
        # 1 - Enabled gallery Section
        if ($getLandingPageConfig['gallery'] == 1) {

            $getGalleryContent = $home->getGalleryContent();
            if (!empty($getGalleryContent)) {

                $homePageDetails['galleryContent']['title'] = $getGalleryContent->title;
                $homePageDetails['galleryContent']['subTitle'] = $getGalleryContent->subTitle;
                $homePageDetails['galleryContent']['description'] = $getGalleryContent->description;

                $homePageDetails['galleryContentCss']['foregroundColor'] =(isset($getGalleryContent->foreground_color) && !empty($getGalleryContent->foreground_color)) 
                                                                        ? $getGalleryContent->foreground_color 
                                                                        : $black_background;
                $homePageDetails['galleryContentCss']['backgroundColor'] =(isset($getGalleryContent->background_color) && !empty($getGalleryContent->background_color)) 
                                                                            ? $getGalleryContent->background_color 
                                                                            : $white_background; ;

                $result['status'] = true;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 200;
                $result['message'] = 'gallery Content Provided';
            } else {
                $homePageDetails['galleryContent'] = array();
                $homePageDetails['galleryContentCss']= array();
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'signUp Content Empty';
            }

            $getGalleryImages = $home->getGalleryImages();

            if (!empty($getGalleryImages)) {

                foreach ($getGalleryImages as $key => $image) {
                    $homePageDetails['gallery']['image'][$key]['imageLink'] = $_ENV['FUSION_BUCKET_URL']['GalleryImages'] . $getClientDetails['client_id'] . "/" . $image->galleryImage;
                }

                $result['status'] = true;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 200;
                $result['message'] = 'gallery Images Provided';
            } else {
                $homePageDetails['gallery'] = array();
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'gallery Content Empty';
            }
        } else {

            $homePageDetails['gallery'] = array();
            $homePageDetails['galleryContent'] = array();
            $homePageDetails['galleryContentCss']= array();
            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'gallery Config Disabled';
        }
        $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($result));
        return $response;
    }


    public function getBookTable(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $getLandingPageConfig = $home->getLandingPageConfig();
        if (!empty($getLandingPageConfig)) {
            $getLandingPageConfig  = json_decode(json_encode($getLandingPageConfig), true);
        }

        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $white_background="#ffffff";
        $black_background="#000000";
        
		

        # 1 - Enabled bookTable Section
        if ($getLandingPageConfig['bookTable'] == 1) {
            $getBookContent = $home->getBookContent();
            if (!empty($getBookContent)) {
                $homePageDetails['bookContent']['title'] = $getBookContent->title;
                $homePageDetails['bookContent']['subTitle'] = $getBookContent->subTitle;
                $homePageDetails['bookContent']['description']  = $getBookContent->description;
                $homePageDetails['bookContent']['headingName1'] = $getBookContent->headingName1;
                $homePageDetails['bookContent']['headingName2'] = $getBookContent->headingName2;
                $homePageDetails['bookContent']['buttonName']   = $getBookContent->buttonName;
                $homePageDetails['bookContent']['imageName']    = $_ENV['FUSION_BUCKET_URL']['BookTable'] . $getClientDetails['client_id'] . "/" . $getBookContent->imageName;


                $homePageDetails['bookContentCss']['foregroundColor'] =(isset($getBookContent->foreground_color) && !empty($getBookContent->foreground_color)) 
                                                                        ? $getBookContent->foreground_color 
                                                                        : $black_background;
                $homePageDetails['bookContentCss']['backgroundColor']  = (isset($getBookContent->background_color) && !empty($getBookContent->background_color)) 
                                                                        ? $getBookContent->background_color 
                                                                        : $white_background;;


                $result['status'] = true;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 200;
                $result['message'] = 'Book Content  Provided';
            } else {
                $homePageDetails['bookContentCss']=array();
              
                $homePageDetails['bookContent'] = array();
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'Book Content Empty';
            }
        } else {
            $homePageDetails['bookContent'] = array();
            $homePageDetails['bookContentCss']=array();
            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'Book Config Disabled';
        }
        $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($result));
        return $response;
    }


    public function getReview(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = [
            'domain' => $inputData['domain'] ?? '',
        ];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        $limit = 0;
        if (isset($inputData['limit'])) {
            $limit = $inputData['limit'];
        }

        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $getLandingPageConfig = $home->getLandingPageConfig();
        if (!empty($getLandingPageConfig)) {
            $getLandingPageConfig  = json_decode(json_encode($getLandingPageConfig), true);
        }

        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $white_background="#ffffff";
        $black_background="#000000";

        # 1 - Enabled review Section
        if ($getLandingPageConfig['review'] == 1) {
            $getReviewContent = $home->getReviewContent();
            if (!empty($getReviewContent)) {
                $homePageDetails['reviewContent']['subTitle'] = $getReviewContent->subTitle;
                $homePageDetails['reviewContent']['description'] = $getReviewContent->description;

                $homePageDetails['reviewContentCss']['foregroundColor'] =(isset($getReviewContent->foreground_color) && !empty($getReviewContent->foreground_color)) 
                                                                                ? $getReviewContent->foreground_color 
                                                                                : $black_background;;
                $homePageDetails['reviewContentCss']['backgroundColor'] = (isset($getReviewContent->background_color) && !empty($getReviewContent->background_color)) 
                                                                                ? $getReviewContent->background_color 
                                                                                : $white_background;
               
            } else {
                $homePageDetails['reviewContent'] = array();
                $homePageDetails['reviewContentCss']= array();
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'Review Content  Empty';
            }

            $getFeedbacks = $home->getFeedback();

            if (!empty($getFeedbacks)) {
                foreach ($getFeedbacks as $key => $getFeedback) {
                    $homePageDetails['Feedback']['review'][$key]['id'] = $getFeedback->id;
                    $homePageDetails['Feedback']['review'][$key]['name'] = $getFeedback->name;
                    $homePageDetails['Feedback']['review'][$key]['comment'] = $getFeedback->comment;
                    $homePageDetails['Feedback']['review'][$key]['rate'] = $getFeedback->rate == "" ? 5 : intval($getFeedback->rate);
                    $homePageDetails['Feedback']['review'][$key]['date'] = $formattedDate = date("d/m/Y", strtotime($getFeedback->datetime));
                    if ($key + 1 == $limit) {
                        break;
                    }
                }
            } else {
                $homePageDetails['Feedback'] = array();
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'Feedback Content Empty';
            }

            $result['status'] = true;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 200;
            $result['message'] = 'Review Content Provided';
        } else {

            $homePageDetails['reviewContent'] = array();
            $homePageDetails['reviewContentCss']= array();
            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'Review Config  Disabled';
        }
        $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($result));
        return $response;
    }

    public function getfeedback(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        // $domain = $params['domain'];
        $domain = $this->extractDomain($params['domain']);
        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $getLandingPageConfig = $home->getLandingPageConfig();
        if (!empty($getLandingPageConfig)) {
            $getLandingPageConfig  = json_decode(json_encode($getLandingPageConfig), true);
        }

        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $white_background="#ffffff";
        $black_background="#000000";

        # 1 - Enabled feedback Section
        if ($getLandingPageConfig['feedback'] == 1) {
            $getFeedbackContent = $home->getFeedbackContent();
            

            if (!empty($getFeedbackContent)) {
                $homePageDetails['FeedbackContent']['subTitle'] = $getFeedbackContent->subTitle;
                $homePageDetails['FeedbackContent']['image'] = $_ENV['FUSION_BUCKET_URL']['Feedback'] . $getClientDetails['client_id'] . "/" . $getFeedbackContent->image;

                
                $homePageDetails['FeedbackContentCss']['foregroundColor'] = (isset($getFeedbackContent->foreground_color) && !empty($getFeedbackContent->foreground_color)) 
                                                                                ? $getFeedbackContent->foreground_color 
                                                                                : $black_background;;
                $homePageDetails['FeedbackContentCss']['backgroundColor'] =(isset($getFeedbackContent->background_color) && !empty($getFeedbackContent->background_color)) 
                                                                                ? $getFeedbackContent->background_color 
                                                                                : $white_background;


                $result['status'] = true;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 200;
                $result['message'] = 'Feedback Content  Provided';
            } else {
                $homePageDetails['FeedbackContent'] = array();
                $homePageDetails['FeedbackContentCss'] = array();
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'Feedback Content  Empty';
            }
        } else {
            $homePageDetails['Feedback'] = array();
            $homePageDetails['FeedbackContentCss'] = array();
            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'Feedback Config Disabled';
        }
        $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($result));
        return $response;
    }

    public function index(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);


        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        
        $homePageDetails['businessType'] = $getClientDetails['bkenable'];
        //$orderButton_link=isset($getClientDetails->client_menu_path)?("/".$getClientDetails->client_menu_path."/menu"):'';
        $bookNowButton_link=isset( $getClientDetails['client_menu_path'])?("/". $getClientDetails['client_menu_path']."/tablebook"):'';
      
        $homePageDetails['currency'] = $home->getLocation();

        $getLandingPageConfig = $home->getLandingPageConfig($domain);
        $getLandingPageConfig = json_decode(json_encode($getLandingPageConfig), true);

        $getStyle = $home->getStyle($domain);
        $getTheme = isset($getStyle['theme']) ? json_decode($getStyle['theme']) : '';
        $homePageDetails['theme']['background'] = isset($getTheme->background) ? $getTheme->background : '';
        $homePageDetails['theme']['color']      = isset($getTheme->color) ? $getTheme->color : '';

        if ($getLandingPageConfig) {
            $homePageDetails['pageConfig'] = $getLandingPageConfig;
        }

        $getContacts = $home->getContacts();
        $getButtonStatus = $home->getButtonStatus();
        $getButtonStatus  = json_decode(json_encode($getButtonStatus), true);
        $footerforegroundColor ="";
        $footerbackgroundColor ="";
        $homePageDetails['header']['navbar']['backgroundColor'] ="";
        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $black_background="#000000"; 
        $white_background="#ffffff";
        $button_foreground="#ffffff";
        
        if(!empty($getButtonStatus))
        {
            $homePageDetails['header']['button']['cartButtonStatus'] = $getButtonStatus['cartButtonStatus'];
            $homePageDetails['header']['button']['orderNowButtonStatus'] = $getButtonStatus['orderNowButtonStatus'];
            $homePageDetails['header']['button']['contactUsButtonStatus'] = $getButtonStatus['contactUsButtonStatus'];
            $homePageDetails['header']['button']['subscriptionButtonStatus'] = $getButtonStatus['subscriptionButtonStatus'];
            // isset()?:
            $homePageDetails['header']['buttonCss']['cartButtonForegroundColor'] = (isset($getButtonStatus['cartButtonForegroundColor']) && !empty($getButtonStatus['cartButtonForegroundColor'])) 
                                                                                        ? $getButtonStatus['cartButtonForegroundColor'] 
                                                                                        : $theme_foreground;
            $homePageDetails['header']['buttonCss']['orderNowButtonForegroundColor'] = (isset($getButtonStatus['orderNowButtonForegroundColor']) && !empty($getButtonStatus['orderNowButtonForegroundColor'])) 
                                                                                            ? $getButtonStatus['orderNowButtonForegroundColor'] 
                                                                                            : $theme_foreground;
            $getButtonStatus['orderNowButtonForegroundColor'];
            $homePageDetails['header']['buttonCss']['contactUsButtonForegroundColor'] = (isset($getButtonStatus['contactUsButtonForegroundColor']) && !empty($getButtonStatus['contactUsButtonForegroundColor'])) 
                                                                                            ? $getButtonStatus['contactUsButtonForegroundColor'] 
                                                                                            : $theme_foreground;
            $homePageDetails['header']['buttonCss']['subscriptionButtonForegroundColor'] =(isset($getButtonStatus['subscriptionButtonForegroundColor']) && !empty($getButtonStatus['subscriptionButtonForegroundColor'])) 
                                                                                            ? $getButtonStatus['subscriptionButtonForegroundColor'] 
                                                                                            : $theme_foreground;

            $homePageDetails['header']['buttonCss']['cartButtonBackgroundColor'] = (isset($getButtonStatus['cartButtonBackgroundColor']) && !empty($getButtonStatus['cartButtonBackgroundColor'])) 
                                                                                        ? $getButtonStatus['cartButtonBackgroundColor'] 
                                                                                        : $theme_background;
            $homePageDetails['header']['buttonCss']['orderNowButtonBackgroundColor'] = (isset($getButtonStatus['orderNowButtonBackgroundColor']) && !empty($getButtonStatus['orderNowButtonBackgroundColor'])) 
                                                                                        ? $getButtonStatus['orderNowButtonBackgroundColor'] 
                                                                                        : $theme_background;
            $homePageDetails['header']['buttonCss']['contactUsButtonBackgroundColor'] = (isset($getButtonStatus['contactUsButtonBackgroundColor']) && !empty($getButtonStatus['contactUsButtonBackgroundColor'])) 
                                                                                        ? $getButtonStatus['contactUsButtonBackgroundColor'] 
                                                                                        : $theme_background;
            $homePageDetails['header']['buttonCss']['subscriptionButtonBackgroundColor'] = (isset($getButtonStatus['subscriptionButtonBackgroundColor']) && !empty($getButtonStatus['subscriptionButtonBackgroundColor'])) 
                                                                                                ? $getButtonStatus['subscriptionButtonBackgroundColor'] 
                                                                                                : $theme_background;

            $homePageDetails['header']['buttonText']['cartButton'] = $getButtonStatus['cartButtonText'];
            $homePageDetails['header']['buttonText']['orderNowButton'] = $getButtonStatus['orderNowButtonText'];
            $homePageDetails['header']['buttonText']['contactUsButton'] = $getButtonStatus['contactUsButtonText'];
            $homePageDetails['header']['buttonText']['subscriptionButton'] = $getButtonStatus['subscriptionButtonText'];

            $orderButton_link=$getButtonStatus['orderNowButtonLink'];
            if(empty($getButtonStatus['orderNowButtonLink']))
            {
                $trimmed = $getClientDetails['client_menu_path'];   
                $orderButton_link="/".$trimmed."/menu";
            }
            
            

            $homePageDetails['header']['buttonLink']['cartButton'] = $getButtonStatus['cartButtonLink'];
            $homePageDetails['header']['buttonLink']['orderNowButton'] = $orderButton_link;
            $homePageDetails['header']['buttonLink']['contactUsButton'] = $getButtonStatus['contactUsButtonLink'];
            $homePageDetails['header']['buttonLink']['subscriptionButton'] = $getButtonStatus['subscriptionButtonLink'];

            $homePageDetails['header']['navbar']['foregroundColor'] = (isset($getButtonStatus['navbarForegroundColor']) && !empty($getButtonStatus['navbarForegroundColor'])) 
                                                                        ? $getButtonStatus['navbarForegroundColor'] 
                                                                        : $black_background;; ;
            $homePageDetails['header']['navbar']['backgroundColor'] = (isset($getButtonStatus['navbarBackgroundColor']) && !empty($getButtonStatus['navbarBackgroundColor'])) 
                                                                        ? $getButtonStatus['navbarBackgroundColor'] 
                                                                        : $white_background;;
           
            $footerforegroundColor =(isset($getButtonStatus['footerForegroundColor']) && !empty($getButtonStatus['footerForegroundColor'])) 
                                        ? $getButtonStatus['footerForegroundColor'] 
                                        : $white_background;;
            $footerbackgroundColor = (isset($getButtonStatus['footerBackgroundColor']) && !empty($getButtonStatus['footerBackgroundColor'])) 
                                        ? $getButtonStatus['footerBackgroundColor'] 
                                        : $black_background;;
        }else{
            $homePageDetails['header']['button']['cartButtonStatus'] = '';
            $homePageDetails['header']['button']['orderNowButtonStatus'] = '';
            $homePageDetails['header']['button']['contactUsButtonStatus'] = '';
            $homePageDetails['header']['button']['subscriptionButtonStatus'] = '';


            $homePageDetails['header']['buttonCss']['cartButtonForegroundColor'] = "";
            $homePageDetails['header']['buttonCss']['orderNowButtonForegroundColor'] = "";
            $homePageDetails['header']['buttonCss']['contactUsButtonForegroundColor'] = "";
            $homePageDetails['header']['buttonCss']['subscriptionButtonForegroundColor'] = "";

            $homePageDetails['header']['buttonCss']['cartButtonBackgroundColor'] = "";
            $homePageDetails['header']['buttonCss']['orderNowButtonBackgroundColor'] = "";
            $homePageDetails['header']['buttonCss']['contactUsButtonBackgroundColor'] = "";
            $homePageDetails['header']['buttonCss']['subscriptionButtonBackgroundColor'] = "";

            $homePageDetails['header']['buttonText']['cartButton'] = "";
            $homePageDetails['header']['buttonText']['orderNowButton'] = "";
            $homePageDetails['header']['buttonText']['contactUsButton'] = "";
            $homePageDetails['header']['buttonText']['subscriptionButton'] = "";


            $homePageDetails['header']['buttonLink']['cartButton'] = "";
            $homePageDetails['header']['buttonLink']['orderNowButton'] = "";
            $homePageDetails['header']['buttonLink']['contactUsButton'] = "";
            $homePageDetails['header']['buttonLink']['subscriptionButton'] = "";

            $homePageDetails['header']['navbar']['foregroundColor'] ="";
            $homePageDetails['header']['navbar']['backgroundColor'] ="";
        }
        if ($getLandingPageConfig['additional_button'] == 1) 
        {
            $getAdditionalButtonContents=$home->getAdditionalButtons();

            if(count($getAdditionalButtonContents)>0)
            {
                foreach ($getAdditionalButtonContents as $key => $value) 
                {
                    $AdditionalButton_arr[]=
                    [
                        'label'=>$value->label,
                        'link'=>$value->link,
                        'background_color'=>(isset($value->background_color) && !empty($value->background_color)) 
                                            ? $value->background_color 
                                            : $theme_background,
                        'foreground_color'=>(isset($value->foreground_color) && !empty($value->foreground_color)) 
                        ? $value->foreground_color 
                        : $theme_foreground,
                        'sort'=>$value->sort,
                    ];  
                }
                $homePageDetails['header']['AdditionalButton']=$AdditionalButton_arr;
              
            }
            else
            {
                $homePageDetails['header']['AdditionalButton'] = array();
            }
        }
        else
        {
            $homePageDetails['header']['AdditionalButton'] = array();
        }
        if (!empty($getContacts)) {

            //-----------------------header
            $getContacts  = json_decode(json_encode($getContacts), true);
            $homePageDetails['header']['b2cLogo'] = $getClientDetails['logo']
                ? $_ENV['FUSION_BUCKET_CLIENT'] . $getClientDetails['logo']
                : $_ENV['FUSION_BUCKET_CLIENT'] . "logo192.png";
            $homePageDetails['header']['logoImage']    = $_ENV["FUSION_BUCKET_CLIENT"] . $getContacts['image'];
            $homePageDetails['header']['businessName'] = $getContacts['name'];
            $homePageDetails['header']['orderNowLink'] = $_ENV["SOCIAL"]["FK"] . "/" . $getClientDetails['client_menu_path'] . "/menu";
            $homePageDetails['header']['bookNowLink']=$bookNowButton_link;
            //-----------------------footer
            $homePageDetails['footer']['contactus']['path'] = $getClientDetails['client_menu_path'];
            $homePageDetails['footer']['contactus']['name'] = $getContacts['name'];
            $homePageDetails['footer']['contactus']['address1'] = $getContacts['address1'];
            $homePageDetails['footer']['contactus']['address2'] = $getContacts['address2'];
            $homePageDetails['footer']['contactus']['city']     = $getContacts['city'];
            $homePageDetails['footer']['contactus']['state']    = $getContacts['state'];
            $homePageDetails['footer']['contactus']['pincode']  = $getContacts['pincode'];
            $homePageDetails['footer']['contactus']['country']  = $getContacts['country'];
            $homePageDetails['footer']['contactus']['mobile']   = $getContacts['mobile'];
            $homePageDetails['footer']['contactus']['phone']    = $getContacts['phone'];
            $homePageDetails['footer']['contactus']['email']    = $getContacts['email'];
            $homePageDetails['footer']['location']['link']      = $getContacts['link'];

          
            $homePageDetails['footer']['footerCss']['foregroundColor'] = $footerforegroundColor;
            $homePageDetails['footer']['footerCss']['backgroundColor'] = $footerbackgroundColor;

            $currentDate = date('Y-m-d');
            $startOfWeek = strtotime('this week', strtotime($currentDate));
            $endOfWeek   = strtotime('next week', strtotime($currentDate));
            $shiftDate   = strtotime(date('d-m-Y', $startOfWeek) . " " . "08:00");

            $openingHours = array();
            while ($shiftDate < $endOfWeek) {
                $time = array();
                $day = date('l', $shiftDate);
                $time[$day]['collection'] = $home->getAboutBusinessTime($domain, 1, $shiftDate);
                $time[$day]['delivery']   = $home->getAboutBusinessTime($domain, 0, $shiftDate);
                array_push($openingHours, $time);
                $shiftDate = strtotime('+1 day', $shiftDate);
            }

            $homePageDetails['footer']['opening_hours'] = $openingHours;
            $getFoodHygiene = $home->getFoodHygiene();

            if ($getFoodHygiene->image1 != '1' && $getFoodHygiene->image1 != '0'     && $getFoodHygiene->image1 != '') {
                $homePageDetails['footer']['food_hygiene'] = $_ENV["FUSION_BUCKET_CLIENT"] . $getFoodHygiene->image1;
            }
        }

        $getShiftDays = $home->getDays();
        $getShiftDays = json_decode(json_encode($getShiftDays), true);
        if ($getShiftDays) {
            $days = array($getShiftDays);
            $homePageDetails['footer']['getDays'] = $days;
        }

        $getSocialUrl = $home->getSocialUrl();
       
        if (
            $getSocialUrl->ios != "" ||
            $getSocialUrl->android != "" ||
            $getSocialUrl->app != ""
        ) {
            $homePageDetails['appLink']['iosLink'] = $getSocialUrl->ios;
            $homePageDetails['appLink']['AndroidLink'] = $getSocialUrl->android;
            $homePageDetails['appLink']['oneLinkUrl'] = $getSocialUrl->app;
        } else {
            $homePageDetails['appLink'] = "";
        }
        $app_banner_image=false;
        if((int)$getClientDetails['client_id']==71 || (int)$getClientDetails['client_id']==4419)
        {
            $getLandingPageLayout=$home->getLandingPageLayout();
           
        }
        $getFontConfig=$home->getFontConfig();
        $landing_page_layout='';
        if(isset($getLandingPageLayout->id))
        {
            $landing_page_layout=$getLandingPageLayout->layout_name;
        }

        if (isset($getLandingPageConfig['font']) && $getLandingPageConfig['font'] == 1) 
        {
            
         

            if(isset($getFontConfig->id))
            {
                
                $homePageDetails['header']['font']['font_family_name']=$getFontConfig->font_family_name;
                $homePageDetails['header']['font']['font_family_size']=$getFontConfig->font_family_size;
                $homePageDetails['header']['font']['font_family_weight']=$getFontConfig->font_family_weight;
                $homePageDetails['header']['font']['font_family_url']=$getFontConfig->font_family_url;
              
                $font_layout='landing_page';
                if((int)$getFontConfig->font_apply_to==1)
                {
                    $font_layout="overall_layout";
                }
                $homePageDetails['header']['font']['font_layout']=$font_layout;

            }
            else
            {
                $homePageDetails['header']['font']['font_family_name']='"Atkinson Hyperlegible Next", serif';
                $homePageDetails['header']['font']['font_family_size']="100";
                $homePageDetails['header']['font']['font_family_weight']="100";
                $homePageDetails['header']['font']['font_family_url']='<link rel="preconnect" href="https://fonts.googleapis.com"><link rel="preconnect" href="https://fonts.gstatic.com" crossorigin><link href="https://fonts.googleapis.com/css2?family=Actor&family=Atkinson+Hyperlegible+Next:ital,wght@0,200..800;1,200..800&family=PT+Sans:ital,wght@0,400;0,700;1,400;1,700&family=Playwrite+IT+Moderna:wght@100..400&family=Sigmar&family=Style+Script&display=swap" rel="stylesheet">';
            }
        }
        else
        {
            $homePageDetails['header']['font']['font_family_name']='"Atkinson Hyperlegible Next", serif';
            $homePageDetails['header']['font']['font_family_size']="100";
            $homePageDetails['header']['font']['font_family_weight']="100";
            $homePageDetails['header']['font']['font_family_url']='<link rel="preconnect" href="https://fonts.googleapis.com"><link rel="preconnect" href="https://fonts.gstatic.com" crossorigin><link href="https://fonts.googleapis.com/css2?family=Actor&family=Atkinson+Hyperlegible+Next:ital,wght@0,200..800;1,200..800&family=PT+Sans:ital,wght@0,400;0,700;1,400;1,700&family=Playwrite+IT+Moderna:wght@100..400&family=Sigmar&family=Style+Script&display=swap" rel="stylesheet">';
        }


        
        $homePageDetails['layout_name']=$landing_page_layout;
		
        $get_app_banner_image=$home->getAppBannerDetails($domain,$getClientDetails['client_id']);
        $homePageDetails['appBannerImage'] =$get_app_banner_image;
       
        $connection_close=$home->connectionClose();
        $responseData = [
            "status" => true,
            "data" => $homePageDetails,
            "response_code" => 200,
        ];
        $response->getBody()->write(json_encode($responseData));
        return $response;
    }

    public function getSocialLink(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $errorMessage = "";
        $successMessage = [];
        $params = [
            'domain' => $inputData['domain'] ?? '',
        ];

        # required fields error
        $errors = [];
        foreach ($params as $key => $value) {
            if (empty($value)) {
                $errors[] = ucfirst($key) . ' is required';
            }
        }

        if (empty($errors)) {
            $domain = $params['domain'];
            $home = new ClientHome($domain);
            $getSocialUrl = $home->getSocialUrl();
            if (
                (isset($getSocialUrl->facebook) && $getSocialUrl->facebook != "") ||
                (isset($getSocialUrl->twitter) && $getSocialUrl->twitter != "") ||
                (isset($getSocialUrl->google) && $getSocialUrl->google != "") ||
                (isset($getSocialUrl->livechat) && $getSocialUrl->livechat != "") ||
                (isset($getSocialUrl->youtube) && $getSocialUrl->youtube != "") ||
                (isset($getSocialUrl->instagram) && $getSocialUrl->instagram != "")
            ) {
                $successMessage['social']['facebook'] = isset($getSocialUrl->facebook) ? $getSocialUrl->facebook : "";
                $successMessage['social']['twitter'] = isset($getSocialUrl->twitter) ? $getSocialUrl->twitter : "";
                $successMessage['social']['google'] =  isset($getSocialUrl->google) ? $getSocialUrl->google : "";
                $successMessage['social']['livechat'] = isset($getSocialUrl->livechat) ? $getSocialUrl->livechat : "";
                $successMessage['social']['youtube'] = isset($getSocialUrl->youtube) ? $getSocialUrl->youtube : "";
                $successMessage['social']['instagram'] = isset($getSocialUrl->instagram) ? $getSocialUrl->instagram : "";
            } else {
                $successMessage['social'] = "";
            }
            if (
                $getSocialUrl->ios != "" ||
                $getSocialUrl->android != "" ||
                $getSocialUrl->app != ""
            ) {
                $successMessage['app']['ios'] = $getSocialUrl->ios;
                $successMessage['app']['android'] = $getSocialUrl->android;
                $successMessage['app']['oneLinkUrl'] = $getSocialUrl->app;
            } else {
                $successMessage['app'] = "";
            }
        } else {
            $errorMessage = implode('. ', $errors);
        }

        # final error / success message
        if ($errorMessage == "") {
            $responseData = [
                "status" => true,
                "message" => $successMessage,
                "response_code" => 200,
            ];
        } else {
            $responseData = [
                "status" => false,
                "message" => $errorMessage,
                "response_code" => 400,
            ];
        }
        $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($responseData));
        return $response;
    }

    public function getMenuImage(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $errorMessage = "";
        $successMessage = [];
        $params = [
            'domain' => $inputData['domain'] ?? '',
        ];

        # required fields error
        $errors = [];
        foreach ($params as $key => $value) {
            if (empty($value)) {
                $errors[] = ucfirst($key) . ' is required';
            }
        }

        if (empty($errors)) {
            $domain = $params['domain'];
            $home = new ClientHome($domain);
            $getMenuImage = $home->getMenuImage();

            if (empty($getMenuImage)) {
                $successMessage = "";
            } else {
                foreach ($getMenuImage as $key => $menu) {
                    $successMessage[$key]['menu'] = $_ENV['FUSION_BUCKET_URL']['itemImage'] . "" . $menu->imagename;
                }
            }
        } else {
            $errorMessage = implode('. ', $errors);
        }

        # final error / success message
        if ($errorMessage == "") {
            $responseData = [
                "status" => true,
                "message" => $successMessage,
                "response_code" => 200,
            ];
        } else {
            $responseData = [
                "status" => false,
                "message" => $errorMessage,
                "response_code" => 400,
            ];
        }
        $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($responseData));
        return $response;
    }

    public function checkDomainWithPath(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $errorMessage = "";
        $successMessage = false;
        $params = [
            'domain' => $inputData['domain'] ?? '',
            'path' => $inputData['path'] ?? '',
        ];

        # required fields error
        $errors = [];
        foreach ($params as $key => $value) {
            if (empty($value)) {
                $errors[] = ucfirst($key) . ' is required';
            }
        }

        if (empty($errors)) {
            $domain = $params['domain'];
            $path = $params['path'];
            $home = new ClientHome($domain);
            $getClientDetails = $home->getCidAndPath($domain);

            if ($getClientDetails["path"] == $path) {
                $successMessage =  true;
            } else {
                $successMessage = false;
            }
        } else {
            $errorMessage = implode('. ', $errors);
        }

        # final error / success message
        if ($errorMessage == "" && $successMessage != false) {
            $responseData = [
                "message" => $successMessage,
                "response_code" => 200,
                "status" => true,
            ];
        } else {
            $responseData = [
                "status" => false,
                "message" => $errorMessage,
                "response_code" => 400,
            ];
        }
        $response->getBody()->write(json_encode($responseData));
        return $response;
    }

    public function gettablegallery(Request $request, Response $response, $args){
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $getLandingPageConfig = $home->getLandingPageConfig();
        $getTablegallery = $home->getTableGalleryByStatus($getLandingPageConfig->tablegallery);
        $Tabledata =[];
        foreach($getTablegallery as $getdata){
            $Tabledata[] = [
                "id" =>  $getdata->id,
                "img" => ($getdata->full_img == 0 || $getdata->full_img == '') ? "https://fusionbucket.co.uk/TableGalleryImages/" .$getClientDetails['client_id']."/".$getdata->img :  "https://crm.fusiontesting.co.uk/control/design/".$getdata->img,
               
                "full_img" =>$getdata->full_img,
                "status" =>$getdata->status,
                "created_at" => $getdata->created_at,
                "updated_at" => $getdata->updated_at
            ];
        }
       
        $getTableOffer = $home->getTableOffer();
        $getMenuImg = $home->getMenuimgdata();
        $Menuimg = [];
        foreach($getMenuImg as $getmenu){
            $Menuimg[] =[
                "id" => $getmenu->id,
                "imagename" => "https://fusioneposfiles.s3-accelerate.amazonaws.com/img/menu/".$getmenu->imagename
            ];
        }
        $getTablePage = $home->getTablePagedata();
        $getresttime  = $home->select_rest_timings();
        $count = 0;
        $today = $today = date('l');
        if ($today === $getresttime->day1) {
            $timeSlots = explode(',', $getresttime->times1);
            $count = count($timeSlots);
        } 

        if (!empty($getLandingPageConfig)) {
            $getLandingPageConfig  = json_decode(json_encode($getLandingPageConfig), true);
        }
        // print_r($getLandingPageConfig);die;
        $Data= [
            "bookingstatus" => $getLandingPageConfig['bookTable'] ?? '',
            "tablegallery" => $Tabledata ?? '',
            "sco"=>$getTablePage['6'] ?? '',
            "flatoffer" => $getTableOffer->offer ?? '',
            "menuimg"=>$Menuimg ?? '',
            "tablebookingcount" =>$count. " Slots Available from " . date('h:i A') . " today"
        ];
        $responseData = [
            "status" => true,
            "message" => "Table Details",
            "Data" => $Data,
            "response_code" => 200,
        ];

        // $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($responseData));
        return $response;
    }

    
    public function getPromotionSection(Request $request, Response $response, $args)
    {

        $black_background="#000000";
        $white_background="#ffffff";
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = [
                "status" => false,
                "message" => "Domain Name is Empty",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
      
        $client_id=$getClientDetails['client_id'];
        $getLandingPageConfig = $home->getLandingPageConfig();
        if (!empty($getLandingPageConfig)) {
            $getLandingPageConfig  = json_decode(json_encode($getLandingPageConfig), true);
        }

        # 1 - Enabled aboutUs Section
        if ($getLandingPageConfig['promotion'] == 1) {
            $getPromotion = $home->getPromotionContent();

            if (!empty($getPromotion)) {
                $homePageDetails['Promotion']['banner'] ="https://fusionbucket.co.uk/promotion/$client_id/$getPromotion->promotion";
            
                 $homePageDetails['PromotionCss']['foregroundColor'] = (isset($getPromotion->foreground_color) && !empty($getPromotion->foreground_color)) 
                                                                        ? $getPromotion->foreground_color 
                                                                        : $black_background;; 

                $homePageDetails['PromotionCss']['backgroundColor'] = (isset($getPromotion->background_color) && !empty($getPromotion->background_color)) 
                                                                        ? $getPromotion->background_color 
                                                                        : $white_background;; 

                $result['status'] = true;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 200;
                $result['message'] = 'Promotion Content Provided';
            } else {

                $homePageDetails['Promotion'] = array();
                $homePageDetails['PromotionCss']=array();
                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'Promotion Contents is Empty';
            }
        } else {

            $homePageDetails['Promotion'] = array();
            $homePageDetails['PromotionCss']=array();
            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'Promotion Config Disabled';
        }
        $connection_close=$home->connectionClose();
        $response->getBody()->write(json_encode($result));
        return $response;
    }

    public function getOurBranchSection(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = ["status" => false, "message" => "Domain Name is Empty", "response_code" => 400,];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        # 1 - Enabled Banner Section
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $client_id=$getClientDetails['client_id'];
        $getLandingPageConfig = $home->getLandingPageConfig();
        $result = array();
        $bannerDealCss=array();
        $getOurBranchCss=$home->getOurBranchConfig();
        $ourBranchCss=array();
        

        $getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
        
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $white_background="#ffffff";
        $black_background="#000000";


        if(isset($getOurBranchCss->id))
        {
            $ourBranchCss['foregroundColor']=(isset($getOurBranchCss->foreground_color) && !empty($getOurBranchCss->foreground_color)) 
                                                ? $getOurBranchCss->foreground_color 
                                                : $black_background;;
            $ourBranchCss['backgroundColor']=(isset($getOurBranchCss->background_color) && !empty($getOurBranchCss->background_color)) 
                                                ? $getOurBranchCss->background_color 
                                                : $white_background;;;
        }
       
        if ($getLandingPageConfig->our_branch == 1) {
            $getOurBranchContents=$home->getOurBranchConfig();

            if(isset($getOurBranchContents->id))
            {
                $homePageDetails['OurBranch']['details']["title"]=$getOurBranchContents->title;
                $homePageDetails['OurBranch']['details']["subtitle"]=$getOurBranchContents->subtitle;
                $homePageDetails['OurBranch']['details']["description"]=$getOurBranchContents->description;
                $homePageDetails['OurBranch']['details']["layout_type"]=$getOurBranchContents->layout_type;
            }
            else
            {
                $homePageDetails['OurBranch']['details']="";
               
            }


            $getOurBranchDetailsContents = $home->getOurBranchDetailsConfig();
            if (count($getOurBranchDetailsContents)>0) {
               
                $ourBranchContent=array();
                foreach ($getOurBranchDetailsContents as $key => $getOurBranch) {
                    $ourBranchContent[]=[
                        'banner_image'=>"https://fusionbucket.co.uk/our_branch/$client_id/".$getOurBranch->banner_image,
                        'button_name'=> $getOurBranch->button_name,
                        'target_link'=>$getOurBranch->target_link,
                        'sort'=>$getOurBranch->sort
                    ];
            

                    
                }
                $homePageDetails['OurBranch']['banners']=$ourBranchContent;
            } else {
                $homePageDetails['OurBranch'] = '';

             
                $homePageDetails['OurBranchCss']=$ourBranchCss;

                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'Our Branch is Empty';

                $response->getBody()->write(json_encode($result));
                return $response;
            }

            
           
        }
        else
        {
            $homePageDetails['OurBranch'] = '';

             
            $homePageDetails['OurBranchCss']='';

            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'Our Branch is disabled';

            $response->getBody()->write(json_encode($result));
            return $response;
        }
        $homePageDetails['OurBranchCss']=$ourBranchCss;
      
        $connection_close=$home->connectionClose();
      
        $result['status'] = true;
        $result['data']   = $homePageDetails;
        $result['response_code'] = 200;
        $result['message'] = 'Our Branch Details Provided';
        $response->getBody()->write(json_encode($result));
        return $response;       
    }


    public function getGalleryGridSection(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = ["status" => false, "message" => "Domain Name is Empty", "response_code" => 400,];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        # 1 - Enabled Banner Section
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $client_id=$getClientDetails['client_id'];
        $getLandingPageConfig = $home->getLandingPageConfig();
        $result = array();
        
        $getGalleryGridCss=$home->getGalleryGridConfig();
        $GalleryGridCss=array();

        
		$getTablestyle=$home->getStyleColor();
        $getTablestyle_background=$getTablestyle->theme;
        $theme_color=(json_decode($getTablestyle_background,true));
         
        $theme_background=isset($theme_color['background'])?$theme_color['background']:'';
        $theme_foreground=isset($theme_color['color'])?$theme_color['color']:'';
        $white_background="#ffffff";
        $black_background="#000000";  
         

        if(isset($getGalleryGridCss->id))
        {
            $GalleryGridCss['foregroundColor']=(isset($getGalleryGridCss->foreground_color) && !empty($getGalleryGridCss->foreground_color)) 
                                                ? $getGalleryGridCss->foreground_color 
                                                : $black_background;
            $GalleryGridCss['backgroundColor']=(isset($getGalleryGridCss->background_color) && !empty($getGalleryGridCss->background_color)) 
                                                ? $getGalleryGridCss->background_color 
                                                : $white_background;
        }
       
        if ($getLandingPageConfig->gallery_grid_menu == 1) {
            $getGalleryGridContents=$home->getGalleryGridConfig();

            if(isset($getGalleryGridContents->id))
            {
                $homePageDetails['galleryGrid']['details']["title"]=$getGalleryGridContents->title;
                $homePageDetails['galleryGrid']['details']["subtitle"]=$getGalleryGridContents->subtitle;
                $homePageDetails['galleryGrid']['details']["description"]=$getGalleryGridContents->description;
                $homePageDetails['galleryGrid']['details']["layout_type"]=$getGalleryGridContents->layout_type;
            }
            else
            {
                $homePageDetails['galleryGrid']['details']="";
              
            }


            $getGalleryGridDetailsContents = $home->getGalleryGridDetails();
            if (count($getGalleryGridDetailsContents)>0) {
               
                $GalleryGridContent=array();
                foreach ($getGalleryGridDetailsContents as $key => $getGalleryGrid) {
                    $GalleryGridContent[]=[
                        'banner_image'=>"https://fusionbucket.co.uk/gallery_grid_menu/$client_id/".$getGalleryGrid->banner_image,
                        'sort'=>$getGalleryGrid->sort
                    ];
            

                    
                }
                $homePageDetails['galleryGrid']['banners']=$GalleryGridContent;
            } else {
                $homePageDetails['galleryGrid'] = '';

             
                $homePageDetails['galleryGridCss']=$GalleryGridCss;

                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'Gallery Grid  is Empty';

                $response->getBody()->write(json_encode($result));
                return $response;
            }

            
           
        }
        else
        {
            $homePageDetails['galleryGrid'] = '';

             
            $homePageDetails['galleryGridCss']='';

            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'Gallery Grid is disabled';

            $response->getBody()->write(json_encode($result));
            return $response;
        }
        $homePageDetails['GalleryGridCss']=$GalleryGridCss;
      
        $connection_close=$home->connectionClose();
      
        $result['status'] = true;
        $result['data']   = $homePageDetails;
        $result['response_code'] = 200;
        $result['message'] = 'Gallery Grid Details Provided';
        $response->getBody()->write(json_encode($result));
        return $response;      
    } 

    public function getAdditionalButtonSection(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);
        $params = ['domain' => $inputData['domain'] ?? '',];
        $domain = $this->extractDomain($params['domain']);

        if (empty($domain)) {
            $responseData = ["status" => false, "message" => "Domain Name is Empty", "response_code" => 400,];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

        # 1 - Enabled Banner Section
        $home = new ClientHome($domain);
        $getClientDetails = $home->getCidAndPath($domain);
        $client_id=$getClientDetails['client_id'];
        $getLandingPageConfig = $home->getLandingPageConfig();
        $result = array();
        
        
        $AdditionalButton_arr=array();
       
       
        if ($getLandingPageConfig->additional_button == 1) 
        {
            $getAdditionalButtonContents=$home->getAdditionalButtons();

            if(count($getAdditionalButtonContents)>0)
            {
                foreach ($getAdditionalButtonContents as $key => $value) 
                {
                    $AdditionalButton_arr[]=
                    [
                        'label'=>$value->label,
                        'link'=>$value->link,
                        'background_color'=>$value->background_color,
                        'foreground_color'=>$value->foreground_color,
                        'sort'=>$value->sort,
                    ];  
                }
                $homePageDetails['AdditionalButton']=$AdditionalButton_arr;
                $result['status'] = true;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 200;
                $result['message'] = 'Additional Button Details Provided';
                $response->getBody()->write(json_encode($result));
                return $response;
            }
            else
            {
                $homePageDetails['AdditionalButton'] = '';

             
                $homePageDetails['AdditionalButtonCss']='';

                $result['status'] = false;
                $result['data']   = $homePageDetails;
                $result['response_code'] = 400;
                $result['message'] = 'Additional Button is empty';

                $response->getBody()->write(json_encode($result));
                return $response;
            }

        }
        else
        {
            $homePageDetails['AdditionalButton'] = '';

             
            $homePageDetails['AdditionalButtonCss']='';

            $result['status'] = false;
            $result['data']   = $homePageDetails;
            $result['response_code'] = 400;
            $result['message'] = 'Additional Button is disabled';

            $response->getBody()->write(json_encode($result));
            return $response;   
        }
     
    }
}
