<?php
namespace App\Controllers;
use App\Models\Feedback;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;

class FeedbackController{
    public function commonFeedback(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$params = [
			'userAgent' => $inputData['userAgent'] ?? '',
			'comment' => $inputData['comment'] ?? '',
           
		];
		$errors = [];
		foreach ($params as $key => $value) {
			if (empty($value) && $value!="0") {
				$errors[] = ucfirst($key) . ' is required';
			}
		}
		if (!empty($errors)) {
			$responseData = [
				"status" => false, 
				"message" => implode('. ', $errors),
                "response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}
        $data = array();

        
        $data['email']     = isset($inputData['email']) ? $inputData['email'] : '';
        $data['userAgent'] = $params['userAgent'];
        $data['path']      = isset($inputData['path']) ? $inputData['path'] : '';
        $data['comment']   = $params['comment'];

        $data['hostName']   = isset($inputData['hostName']) ? $inputData['hostName'] : '';

        $feedback = new Feedback();
        $insertFeedback = $feedback->insertCommonFeedback($data);

        $responseData = [
            "status" => true, 
            "data" => $insertFeedback,
            "response_code" => 200,
        ];
        $response->getBody()->write(json_encode($responseData));
        return $response;
	}

    public function getCommonFeedback(Request $request, Response $response, $args)
    {
        $feedback = new Feedback();
        $getcommonfeedback = $feedback->getcommonfeedback();

        $feedData = array();
        if(isset($getcommonfeedback) && !empty($getcommonfeedback))
        {
              $feedData['id'] = isset($getcommonfeedback->id) ? $getcommonfeedback->id : '';
              $feedData['email'] = isset($getcommonfeedback->email) ? $getcommonfeedback->email : '';
              $feedData['userAgent'] = isset($getcommonfeedback->userAgent) ? $getcommonfeedback->userAgent : '';
              $feedData['path'] = isset($getcommonfeedback->path) ? $getcommonfeedback->path : '';
              $feedData['comment'] = isset($getcommonfeedback->comment) ? $getcommonfeedback->comment : '';
              $feedData['status'] = isset($getcommonfeedback->status) ? $getcommonfeedback->status : '0';
        }
        else
        {
            $responseData = [
				"status" => false, 
				"message" => 'Feedback List is Empty',
                "response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
        }

        $responseData = [
            "status" => true, 
            "data" => $feedData,
            "response_code" => 200,
        ];
        $response->getBody()->write(json_encode($responseData));
        return $response;
    }

    public function getFeedbackData(Request $request, Response $response, $args)
    {
        $inputData = json_decode(file_get_contents('php://input'), true);

        $params = [
            'domain' => $inputData['domain'] ?? '',
            'name' => $inputData['name'] ?? '',
            'email' => $inputData['email'] ?? '',
            'feedback' => $inputData['feedback'] ?? '',
            'rate' => $inputData['rate'] ?? '',
            'subject' => $inputData['subject'] ?? ''
        ];
        if($params['domain'] == ''|| $params['rate'] == '' || $params['name'] == '' || $params['email'] == '' || $params['feedback'] == '')
        {
            $responseData = [
                "status" => false,
                "message" => 'All Fields ara Mandatory',
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }
        
        if(!filter_var($params['email'], FILTER_VALIDATE_EMAIL))
        {
            $responseData = [
                "status" => false,
                "message" => 'Email is Not Valid',
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

         $feedback = new Feedback();
         $submitFeedback = $feedback->insertFeedbackData($params);
         if($submitFeedback == true)
         {
            $responseData = [
                "status" => true,
                "message" => "Feedback Inserted Successfully",
                "response_code" => 200,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
         } else {
            $responseData = [
                "status" => false,
                "message" => "Feedback Not Inserted Successfully",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
         }
    }
}