<?php 
namespace App\Controllers;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;
use App\Models\RestaurantPage;

class FilterController{
    public function getRestaurantList(Request $request, Response $response, $args)
	{
		$restaurant = new RestaurantPage();
		$current_time = time();
		$inputData = json_decode(file_get_contents('php://input'), true);

		if(isset($inputData['order_mode']) && $inputData['order_mode'] != "") 
			$orderMode = $inputData['order_mode'];
		else
			$orderMode = "1";

		if(isset($inputData['order_time']) && $inputData['order_time'] != "") 
			$orderTime = strtotime($inputData['order_time']);
		else
			$orderTime = $current_time;
			
		if(isset($inputData['customer_id']) && $inputData['customer_id'] != "0") 
			$customerId = $inputData['customer_id'];
		else
			$customerId = '';

		if(isset($inputData['post_code']) && $inputData['post_code'] != "")
		{
			$PostcodeController = new PostcodeController();
			$restaurantResponse = array();
			$getPostCodeDetail = $PostcodeController->getPostCodeDetail($inputData['post_code']);
			$getPostCodeDetail = json_decode($getPostCodeDetail);
			if(!empty($getPostCodeDetail))
			{
				if($getPostCodeDetail->status)
				{
					$latitude = $getPostCodeDetail->latitude;
					$longitude = $getPostCodeDetail->longitude;
					$location = array('latitude' => $latitude,'longitude' => $longitude);
					$location = json_decode(json_encode($location), FALSE);

					$favouriteLists = 0;
					$getClientList = $restaurant->getClientList($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists);
					
					if(!empty($getClientList['restaurantList'])) {
                        if(!isset($inputData['filter']) && !isset($inputData['cuisines']) && !isset($inputData['offerBanner']) && !isset($inputData['search'])){
                            $restaurantResponse['restaurantList'] = $getClientList['restaurantList'];
                            $restaurantResponse['offerBannerDetails'] = $getClientList['offerBannerDetails'];
                            $restaurantResponse['getAllActiveCuisine'] = $getClientList['getAllActiveCuisine'];
        
                            $responseData = [
                                "status" => true, 
                                "message" => "Client List",
                                "data" => $restaurantResponse,
                                "response_code" => 200,
                            ];
                            $response->getBody()->write(json_encode($responseData));
                            return $response;
                        }else if(isset($inputData['filter']) && $inputData['filter'] != "" && !isset($inputData['cuisines'])){
                            if($inputData['filter'] == 1){
								// offers
								$details = array();
								foreach($getClientList['restaurantList'] as $rec){
									$res['record'] = $rec;
									$res['offer'] = $rec['restaurant']['offers'];	
									array_push($details,$res);
								}
								$offer_id = 0;
								$offerRecord = $restaurant->getOfferBannerTypes($offer_id);
								
								$offer = array();
								foreach($offerRecord as $data){
									$type = $data->offer_type_name;
									array_push($offer,$type);
								}
								$commonOffer['restaurantList'] = array();
								foreach ($details as $req) {
									if (count(array_intersect($offer, $req['offer'])) > 0) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($commonOffer['restaurantList'], $restaurantData);
										}
									}
								}
							
								if(!empty($commonOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $commonOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
                            }else if($inputData['filter'] == 2){
								// Free Delivery
								$details = array();
								foreach($getClientList['restaurantList'] as $rec){
									$res['record'] = $rec;
									$res['offerDelivery'] = $rec['restaurant']['offers'];	
									array_push($details,$res);
								}
								$deliveryId = 4;
								$offerDelivery = $restaurant->getOfferType($deliveryId);
								$freeDelivery = array($offerDelivery->offer_type_name);
							
								$commonfreeDelivery['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (count(array_intersect($freeDelivery, $req['offerDelivery'])) > 0) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($commonfreeDelivery['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($commonfreeDelivery['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $commonfreeDelivery,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
                            }else if($inputData['filter'] == 3){
								// rating
								$details = array();
								foreach($getClientList['restaurantList'] as $rec){
									$res['record'] = $rec;
									$res['rating'] = $rec['restaurant']['rating'];	
									array_push($details,$res);
								}
								$starRating['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $required){
									$rating = $required['rating']->rate;
									if($rating >= 4){
										$restaurantData = $required['record'];
										if (!empty($restaurantData)) {
											array_push($starRating['restaurantList'],$restaurantData);
										}
									}
								}

								if(!empty($starRating['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $starRating,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
                            }else if($inputData['filter'] == 4){
								// status open
								$details = array();
								foreach($getClientList['restaurantList'] as $rec){
									$res['record'] = $rec;
									$res['restaurantStatus'] = $rec['restaurant']['restaurantStatus'];	
									array_push($details,$res);
								}
								$status['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $data){
									$sts = $data['restaurantStatus']['status'];
									if($sts == 0){
										$restaurantData = $data['record'];
										if (!empty($restaurantData)) {
											array_push($status['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($status['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $status,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
                            }else if($inputData['filter'] == 5){
								// collection
								$mode = 1;
                               	$records = $restaurant->getClientList($latitude,$longitude,$mode,$orderTime,$customerId,$favouriteLists);
								$details = array();
								foreach($records['restaurantList'] as $rec){
									array_push($details,$rec);
								}
								$collection['restaurantList'] = $details;
								if(!empty($collection['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $collection,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
							}else if($inputData['filter'] == 6){
								// new client
								$responseData = [
									"status" => true, 
									"message" => "Client List",
									"data" => json_decode('{}'),
									"response_code" => 200,
								];
								$response->getBody()->write(json_encode($responseData));
								return $response;
                            }else if($inputData['filter'] == 7){
								// halal
								$details = array();
								foreach($getClientList['restaurantList'] as $rec){
									$res['record'] = $rec;
									$res['dietary'] = $rec['restaurant']['dietary'];	
									array_push($details,$res);
								}
								$dietaryId = 2;
								$dietaryRecord = $restaurant->getDietariesTypes($dietaryId);
								$dietary = array($dietaryRecord->dietaries_name);
								
								$commonDietary['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (count(array_intersect($dietary, $req['dietary'])) > 0) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($commonDietary['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($commonDietary['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $commonDietary,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
                            }
                            
                        }else if(isset($inputData['cuisines']) && $inputData['cuisines'] != "" && !isset($inputData['filter'])){
							$cuisine = $inputData['cuisines'];
							$cuisineArray = trim($cuisine, "[]");
							$cuisinelist = json_decode("[$cuisineArray]", true);

							$details = array();
							foreach($getClientList['restaurantList'] as $rec){
								$res['restaurant'] = $rec;
								$res['cuisineId'] = $rec['restaurant']['cuisineId'];	
								array_push($details,$res);
							}
							
							$commonCuisineId['restaurantList'] = array();
							$existingRestaurantIds = array();
							foreach ($details as $req) {
								$cuisineId = array_map('intval', $req['cuisineId']);

								// Check if all IDs in $cuisineArray are present in the cuisine IDs of the restaurant
								if (count(array_intersect($cuisinelist, $cuisineId)) === count($cuisinelist)) {
									$restaurantRecord = $req['restaurant'];
									$restaurantId = $restaurantRecord['restaurant']['clientId'];

									// Check if the restaurant ID already exists to avoid duplicates
									if (!in_array($restaurantId, $existingRestaurantIds)) {
										array_push($commonCuisineId['restaurantList'], $restaurantRecord);
										$existingRestaurantIds[] = $restaurantId;
									}
								}
							}
							if(!empty($commonCuisineId['restaurantList'])){
								$responseData = [
									"status" => true, 
									"message" => "Client List",
									"data" => $commonCuisineId,
									"response_code" => 200,
								];
								$response->getBody()->write(json_encode($responseData));
								return $response;
							}else{
								$responseData = [
									"status" => false, 
									"message" => "Empty client List",
									"data" => json_decode('{}'),
									"response_code" => 400,
								];
								$response->getBody()->write(json_encode($responseData));
								return $response;
							}
							
						}else if(isset($inputData['offerBanner']) && $inputData['offerBanner'] != "" && !isset($inputData['filter']) && !isset($inputData['cuisines'])){
							$offer = $inputData['offerBanner'];
							$details = array();
								foreach($getClientList['restaurantList'] as $rec){
									$res['record'] = $rec;
									$res['offers'] = $rec['restaurant']['offers'];	
									array_push($details,$res);
								}
							if($inputData['offerBanner'] == 1){
								// bogof
								$id = $inputData['offerBanner'];
								$offerBogof = $restaurant->getOfferType($id);
								$bogof = $offerBogof->offer_type_name;
								
								$bogofOffer['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (in_array($bogof, $req['offers'])) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($bogofOffer['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($bogofOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $bogofOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
								
							}else if($inputData['offerBanner'] == 2){
								// mealDeal
								$id = $inputData['offerBanner'];
								$offermealDeal = $restaurant->getOfferType($id);
								$mealDeal = $offermealDeal->offer_type_name;
								
								$offermealDealOffer['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (in_array($mealDeal, $req['offers'])) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($offermealDealOffer['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($offermealDealOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $offermealDealOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
							}else if($inputData['offerBanner'] == 3){
								// freeGift
								$id = $inputData['offerBanner'];
								$offerfreeGift = $restaurant->getOfferType($id);
								$freeGift = $offerfreeGift->offer_type_name;
								
								$freeGiftOffer['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (in_array($freeGift, $req['offers'])) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($freeGiftOffer['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($freeGiftOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $freeGiftOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
							}else if($inputData['offerBanner'] == 4){
								// freeDelivery
								$id = $inputData['offerBanner'];
								$offerfreeDelivery = $restaurant->getOfferType($id);
								$freeDelivery = $offerfreeDelivery->offer_type_name;
								
								$freeDeliveryOffer['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (in_array($freeDelivery, $req['offers'])) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($freeDeliveryOffer['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($freeDeliveryOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $freeDeliveryOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
							}else if($inputData['offerBanner'] == 5){
								// useCode
								$id = $inputData['offerBanner'];
								$offeruseCode = $restaurant->getOfferType($id);
								$useCode = $offeruseCode->offer_type_name;
								
								$useCodeOffer['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (in_array($useCode, $req['offers'])) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($useCodeOffer['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($useCodeOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $useCodeOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
							}else if($inputData['offerBanner'] == 6){
								// noCode
								$id = $inputData['offerBanner'];
								$offernoCode = $restaurant->getOfferType($id);
								$noCode = $offernoCode->offer_type_name;
								
								$noCodeOffer['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (in_array($noCode, $req['offers'])) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($noCodeOffer['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($noCodeOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $noCodeOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
							}else if($inputData['offerBanner'] == 7){
								// loyalty
								$id = $inputData['offerBanner'];
								$offerloyalty = $restaurant->getOfferType($id);
								$loyalty = $offerloyalty->offer_type_name;
								
								$loyaltyOffer['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (in_array($loyalty, $req['offers'])) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($loyaltyOffer['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($loyaltyOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $loyaltyOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
							}else if($inputData['offerBanner'] == 8){
								// voucher
								$id = $inputData['offerBanner'];
								$offervoucher = $restaurant->getOfferType($id);
								$voucher = $offervoucher->offer_type_name;
								
								$voucherOffer['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (in_array($voucher, $req['offers'])) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($voucherOffer['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($voucherOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $voucherOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
							}else if($inputData['offerBanner'] == 9){
								// promo
								$id = $inputData['offerBanner'];
								$offerpromo = $restaurant->getOfferType($id);
								$promo = $offerpromo->offer_type_name;
								
								$promoOffer['restaurantList'] = array();
								$restaurantData = array();
								foreach($details as $req){
									if (in_array($promo, $req['offers'])) {
										$restaurantData = $req['record'];
										if (!empty($restaurantData)) {
											array_push($promoOffer['restaurantList'],$restaurantData);
										}
									}
								}
								
								if(!empty($promoOffer['restaurantList'])){
									$responseData = [
										"status" => true, 
										"message" => "Client List",
										"data" => $promoOffer,
										"response_code" => 200,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}else{
									$responseData = [
										"status" => false, 
										"message" => "Empty client List",
										"data" => json_decode('{}'),
										"response_code" => 400,
									];
									$response->getBody()->write(json_encode($responseData));
									return $response;
								}
							}
						}else if(isset($inputData['search']) && $inputData['search'] != "" && !isset($inputData['filter']) && !isset($inputData['cuisines']) && !isset($inputData['offerBanner'])){
							$searchValue = $inputData['search'];
							$details = array();
							$res = array();
							foreach($getClientList['restaurantList'] as $rec){
								$res['record'] = $rec;
								$res['offers'] = $rec['restaurant']['offers'];	
								array_push($details,$res);
							}
							$results[] = array();
								
							foreach ($details as $record) {
								$restaurant = $record['record']['restaurant'];
								$jsonRestaurant = strtolower(json_encode($restaurant));
								
								if (strpos($jsonRestaurant, strtolower($searchValue)) !== false) {
									$results[] = $record['record'];
								}
							}
							$results = array_values(array_filter($results, function($item) {
								return !empty($item);
							}));

							
								
							if(!empty($results)){
								$responseData = [
									"status" => true, 
									"message" => "Client List",
									"data" => [
										"restaurantList" => $results,
									],
									"response_code" => 200,
								];
								$response->getBody()->write(json_encode($responseData));
								return $response;
							}else{
								$responseData = [
									"status" => false, 
									"message" => "Empty client List",
									"data" => json_decode('{}'),
									"response_code" => 400,
								];
								$response->getBody()->write(json_encode($responseData));
								return $response;
							}
						}else{
							$responseData = [
								"status" => false, 
								"message" => "Some keys are not required.",
								"response_code" => 400,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
						}
	
					} else {
						$responseData = [
							"status" => false, 
							"message" => "Empty client List",
							"data" => json_decode('{}'),
							"response_code" => 400,
						];
						$response->getBody()->write(json_encode($responseData));
						return $response;
					}
				}
				else
				{
					$responseData = [
						"status" => false, 
						"message" => "Invalid PostCode",
						"response_code" => 400,
					];
					$response->getBody()->write(json_encode($responseData));
					return $response;
				}
			}
		}
		else
		{
			$responseData = [
				"status" => false, 
				"message" => "Postcode field is required",
				"response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}	
	}
    public function getFilterType(Request $request, Response $response, $args){
		
		$restaurant = new RestaurantPage();
		$current_time = time();
		$inputData = json_decode(file_get_contents('php://input'), true);

		if(isset($inputData['order_mode']) && $inputData['order_mode'] != "") 
			$orderMode = $inputData['order_mode'];
		else
			$orderMode = "1";

		if(isset($inputData['order_time']) && $inputData['order_time'] != "") 
			$orderTime = strtotime($inputData['order_time']);
		else
			$orderTime = $current_time;
			
		if(isset($inputData['customer_id']) && $inputData['customer_id'] != "0") 
			$customerId = $inputData['customer_id'];
		else
			$customerId = '';

		if(isset($inputData['post_code']) && $inputData['post_code'] != "")
		{
			$PostcodeController = new PostcodeController();
			$restaurantResponse = array();
			$getPostCodeDetail = $PostcodeController->getPostCodeDetail($inputData['post_code']);
			$getPostCodeDetail = json_decode($getPostCodeDetail);
			if(!empty($getPostCodeDetail))
			{
				if($getPostCodeDetail->status)
				{
					$latitude = $getPostCodeDetail->latitude;
					$longitude = $getPostCodeDetail->longitude;
					$location = array('latitude' => $latitude,'longitude' => $longitude);
					$location = json_decode(json_encode($location), FALSE);

					$favouriteLists = 0;
					$getClientList = $restaurant->getClientList($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists);
			
					if(!empty($getClientList['restaurantList'])) {

						$record['filters'] = 	array(array("id" => 1,"type" => "Special offers"),
											array("id" => 2,"type" => "Free Delivery"),
											array("id" => 3,"type" => "4+ stars"),
											array("id" => 4,"type" => "Open Now"),
											array("id" => 5,"type" => "Collection"),
											array("id" => 6,"type" => "New"),
											array("id" => 7,"type" => "Halal"));

						$data = $getClientList['getAllActiveCuisine'];
						$result = array();
						foreach($data as $res){
							$value['id'] = $res['id'];
							$value['name'] = $res['name'];
							$value['count'] = $res['count'];
							array_push($result,$value);
						}
						$record['getAllActiveCuisine'] = $result;
						$responseData = [
							"status" => true, 
							"message" => "Filter Type List",
							"data" => $record,
							"response_code" => 200,
						];
						$response->getBody()->write(json_encode($responseData));
						return $response;
					}
				}
				else
				{
					$responseData = [
						"status" => false, 
						"message" => "Invalid PostCode",
						"response_code" => 400,
					];
					$response->getBody()->write(json_encode($responseData));
					return $response;
				}
			}
		}	
	}
	
}
?>