<?php
namespace App\Controllers;

use App\Helpers\SendEposEmail;
use Twig\Environment;
use Twig\Loader\FilesystemLoader;
use App\Helpers\SendEmail;

require '../config/env.php';

class MailController
{
	protected $twig;
	public function __construct()
	{
		$loader = new FilesystemLoader(__DIR__ . '/../view/Templates');
		$this->twig = new Environment($loader, [
			'cache' => false,
		]);
	}

	public function sendSuccessInvoice($email, $data)
	{
		$from = $data['store_mail'];
		$fromName = $data['store'];
		$data['support'] = $data['store_mail'];
		$sendEmail = new SendEmail();
		$toMail = $email;
		$ccMail = array($data['store_mail']);
		$bccMail = array("chakkaravarthi@fusioninnovative.com");
		$mailSub = "Subscription Successful! Your Exclusive Discount Inside";
		$reply = $data['store_mail'];
		$replyName = $data['store'];
		$mailHtml = $this->twig->render('./webhook/successInvoice.twig', $data);
		$mail = $sendEmail->sendMail($toMail, $ccMail, $mailSub, $mailHtml, $reply, $replyName, $from, $fromName, $bccMail);

		$responseData = [
			"status" => true,
			"data" => $mail,
			"response_code" => 200,
		];

		return $responseData;
	}

	public function sendRemainderInvoice($email, $data)
	{
		$from = $data['store_mail'];
		$fromName = $data['store'];
		$data['support'] = $data['store_mail'];
		$sendEmail = new SendEmail();
		$toMail = $email;
		$ccMail = array($data['store_mail']);
		$bccMail = array("chakkaravarthi@fusioninnovative.com");
		$mailSub = "Subscription renewal reminder -" . $data['date'];
		$reply = $data['store_mail'];
		$replyName = $data['store'];
		$mailHtml = $this->twig->render('./webhook/remainderInvoice.twig', $data);
		$mail = $sendEmail->sendMail($toMail, $ccMail, $mailSub, $mailHtml, $reply, $replyName, $from, $fromName, $bccMail);

		$responseData = [
			"status" => true,
			"data" => $mail,
			"response_code" => 200,
		];
		return $responseData;
	}

	public function webhook($email, $data)
	{
		$sendEmail = new SendEposEmail();
		$toMail = $email;
		$ccMail = array();
		$mailSub = "FK Webhook connection";
		$reply = "support@fusionpos.uk";
		$replyName = "Fusion Kitchen";
		$mailHtml = $this->twig->render('webhook/webhook.twig', ['data' => $data]);
		$mail = $sendEmail->sendMail($toMail, $ccMail, $mailSub, $mailHtml, $reply, $replyName);

		$responseData = [
			"status" => true,
			"data" => $mail,
			"response_code" => 200,
		];
		return $responseData;
	}

	public function __destruct()
	{
		$this->twig = null;
	}
}
?>