<?php
namespace App\Controllers;
use App\Models\MenuClientAction;
use App\Models\MenuUpdateClientDB;
use App\Models\Menu;
use Exception;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;

class MenuClientActionController
{
	public function createCategory(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$cat['name'] = $inputData['name'] ?? '';
		$cat['client_id'] = $inputData['client_id'] ?? '';
		$cat['image'] = $inputData['image'] ?? 'dfgfd';
		$cat['options'] = $inputData['options'] ?? '0';
		$cat['coupon'] = $inputData['coupon'] ?? '0';
		$cat['icon'] = $inputData['icon'] ?? '0';
		$cat['working_days'] = $inputData['working'];
		$cat['order'] = $inputData['order'] ?? "0";
		$cat['offorder'] = $inputData['offorder'] ?? "0";
		$cat['status'] = $inputData['status'] ?? "0";
		$cat['background'] = $inputData['background'] ?? '0';
		$cat['forground'] = $inputData['forground'] ?? '0';
		$cat['aname'] = $inputData['aname'] ?? "";
		$cat['visible'] = $inputData['visible'] ?? '';
		$cat['offer'] = $inputData['offer'] ?? 0;
		$cat['allowoffer'] = $inputData['allowoffer'] ?? '0';
		$cat['allowgift'] = $inputData['allowgift'] ?? '0';
		$cat['mon_time'] = $inputData['mon_time'] ?? "";
		$cat['tue_time'] = $inputData['tue_time'] ?? "";
		$cat['wed_time'] = $inputData['wed_time'] ?? "";
		$cat['thu_time'] = $inputData['thu_time'] ?? "";
		$cat['fri_time'] = $inputData['fri_time'] ?? "";
		$cat['sat_time'] = $inputData['sat_time'] ?? "";
		$cat['sun_time'] = $inputData['sun_time'] ?? "";
		$cat['mealDealStatus'] = $inputData['mealDealStatus'] ?? '0';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}

		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->InsertCategory($cat);

		$responseData = [
			"status" => true,
			"message" => "Category Inserted Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function editCategory(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$cat['id'] = $inputData['id'] ?? '';
		$cat['name'] = $inputData['name'] ?? '';
		$cat['aname'] = $inputData['aname'] ?? '';
		$cat['client_id'] = $inputData['client_id'] ?? '';
		$cat['image'] = $inputData['image'] ?? '';
		$cat['icon'] = $inputData['icon'] ?? '';
		$cat['options'] = $inputData['options'] ?? '0';
		$cat['coupon'] = $inputData['coupon'] ?? '0';
		$cat['working_days'] = $inputData['working'];
		$cat['mon_time'] = $inputData['mon_time'] ?? "";
		$cat['tue_time'] = $inputData['tue_time'] ?? "";
		$cat['wed_time'] = $inputData['wed_time'] ?? "";
		$cat['thu_time'] = $inputData['thu_time'] ?? "";
		$cat['fri_time'] = $inputData['fri_time'] ?? "";
		$cat['sat_time'] = $inputData['sat_time'] ?? "";
		$cat['sun_time'] = $inputData['sun_time'] ?? "";
		$cat['status'] = $inputData['status'] ?? 0;
		$cat['order'] = $inputData['order'] ?? 0;
		$cat['offorder'] = $inputData['offorder'] ?? 0;
		$cat['forground'] = $inputData['forground'] ?? '0';
		$cat['visible'] = $inputData['visible'] ?? '';
		$cat['offer'] = $inputData['offer'] ?? 0;
		$cat['allowoffer'] = $inputData['allowoffer'] ?? 0;
		$cat['allowgift'] = $inputData['allowgift'] ?? 0;
		$cat['background'] = $inputData['background'] ?? '0';
		$cat['mealDealStatus'] = $inputData['mealDealStatus'] ?? '0';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}

		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->updateCategory($cat);

		$responseData = [
			"status" => true,
			"message" => "Category Updated Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function deleteCategory(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$cat['id'] = $inputData['id'] ?? '';
		$cat['client_id'] = $inputData['client_id'] ?? '';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}

		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->deleteCategory($cat);

		$responseData = [
			"status" => true,
			"message" => "Category Deleted Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function createSubCategery(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$subCat['catagery_id'] = $inputData['catagery_id'] ?? '';
		$subCat['name'] = $inputData['name'] ?? '';
		$subCat['description'] = $inputData['description'] ?? '';
		$subCat['options'] = $inputData['options'] ?? '0';
		$subCat['image'] = $inputData['image'] ?? '';
		$subCat['icon'] = $inputData['icon'] ?? '';
		$subCat['working_days'] = $inputData['working'] ?? '';
		$subCat['coupon'] = $inputData['coupon'] ?? '';
		$subCat['order'] = $inputData['order'] ?? 0;
		$subCat['status'] = $inputData['status'] ?? 0;
		$subCat['background'] = $inputData['background'] ?? '0';
		$subCat['forground'] = $inputData['forground'] ?? '0';
		$subCat['aname'] = $inputData['aname'] ?? '';
		$subCat['visible'] = $inputData['visible'] ?? '';
		$subCat['allowoffer'] = $inputData['allowoffer'] ?? 0;
		$subCat['allowgift'] = $inputData['allowgift'] ?? 0;
		$subCat['mon_time'] = $inputData['mon_time'] ?? "";
		$subCat['tue_time'] = $inputData['tue_time'] ?? "";
		$subCat['wed_time'] = $inputData['wed_time'] ?? "";
		$subCat['thu_time'] = $inputData['thu_time'] ?? "";
		$subCat['fri_time'] = $inputData['fri_time'] ?? "";
		$subCat['sat_time'] = $inputData['sat_time'] ?? "";
		$subCat['sun_time'] = $inputData['sun_time'] ?? "";
		$subCat['client_id'] = $inputData['client_id'] ?? 0;

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}
		
		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->insertSubcat($subCat);
		$responseData = [
			"status" => true,
			"message" => "Sub Catagery Inserted Successfully",
			"response_code" => 200,
		];
		$response->getBody()->write(json_encode($responseData));
		return $response;

	}

	public function createItems(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$item['client_id'] = $inputData['client_id'] ?? '';
		$item['sid'] = $inputData['sid'] ?? '';
		$item['name'] = $inputData['name'] ?? '';
		$item['code'] = $inputData['code'] ?? '';
		$item['description'] = $inputData['description'] ?? '';
		$item['product_price'] = $inputData['product_price'] ?? '';
		$item['price'] = $inputData['price'] ?? '';
		$item['delivery_price'] = $inputData['delivery_price'] ?? '';
		$item['collection_price'] = $inputData['collection_price'] ?? '';
		$item['instore_price'] = $inputData['instore_price'] ?? '';
		$item['deliveroo_price'] = $inputData['deliveroo_price'] ?? '';
		$item['justeat_price'] = $inputData['justeat_price'] ?? '';
		$item['uber_eat_price'] = $inputData['uber_eat_price'] ?? '';
		$item['coupon'] = $inputData['coupon'] ?? '';
		$item['working_days'] = $inputData['working_days'] ?? '';
		$item['image'] = $inputData['image'] ?? '';
		$item['icon'] = $inputData['icon'] ?? '';
		$item['multi_image'] = $inputData['multi_image'] ?? '';
		$item['options'] = $inputData['options'] ?? '0';
		$item['order'] = $inputData['order'] ?? 0;
		$item['status'] = $inputData['status'] ?? 0;
		$item['freeaddon'] = $inputData['freeaddon'] ?? 0;
		$item['addon'] = $inputData['addon'] ?? 0;
		$item['base'] = $inputData['base'] ?? 0;
		$item['drink'] = $inputData['drink'] ?? 0;
		$item['aname'] = $inputData['aname'] ?? '';
		$item['fmb_sts'] = $inputData['fmb_sts'] ?? '';
		$item['visible'] = $inputData['visible'] ?? '';
		$item['allowoffer'] = $inputData['allowoffer'] ?? 0;
		$item['allowgift'] = $inputData['allowgift'] ?? 0;
		$item['working_time1'] = $inputData['mon_time'] ?? '';
		$item['working_time2'] = $inputData['tue_time'] ?? '';
		$item['working_time3'] = $inputData['wed_time'] ?? '';
		$item['working_time4'] = $inputData['thu_time'] ?? '';
		$item['working_time5'] = $inputData['fri_time'] ?? '';
		$item['working_time6'] = $inputData['sat_time'] ?? '';
		$item['working_time7'] = $inputData['sun_time'] ?? '';
		$item['item_type'] = $inputData['item_type'] ?? '';
		$item['vat'] = $inputData['tax_rate'] ?? '';
		$item['printer'] = $inputData['printer'] ?? '';
		$item['background'] = $inputData['background'] ?? '0';
		$item['forground'] = $inputData['forground'] ?? '0';
		$item['emojiName'] = $inputData['emojiName'] ?? '';
		$item['type'] = $inputData['type'] ?? '';
		$item['age_restriction'] = $inputData['age_restriction'] ?? '';
		$newMenuClient = new MenuClientAction();

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}
		
		$stmt = $newMenuClient->insertItem($item);
		$responseData = [
			"status" => true,
			"message" => "Item Inserted Successfully",
			"response_code" => 200,
		];
		$response->getBody()->write(json_encode($responseData));
		return $response;
	}
	
	public function editItems(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$item['id'] = $inputData['id'] ?? '';
		$item['client_id'] = $inputData['client_id'] ?? '';
		$item['sid'] = $inputData['sid'] ?? '';
		$item['name'] = $inputData['name'] ?? '';
		$item['code'] = $inputData['code'] ?? '';
		$item['description'] = $inputData['description'] ?? '';
		$item['product_price'] = $inputData['product_price'] ?? '';
		$item['price'] = $inputData['price'] ?? '';
		$item['delivery_price'] = $inputData['delivery_price'] ?? '';
		$item['collection_price'] = $inputData['collection_price'] ?? '';
		$item['instore_price'] = $inputData['instore_price'] ?? '';
		$item['deliveroo_price'] = $inputData['deliveroo_price'] ?? '';
		$item['justeat_price'] = $inputData['justeat_price'] ?? '';
		$item['uber_eat_price'] = $inputData['uber_eat_price'] ?? '';
		$item['coupon'] = $inputData['coupon'] ?? '';
		$item['working_days'] = $inputData['working_days'] ?? '';
		$item['image'] = $inputData['image'] ?? '';
		$item['icon'] = $inputData['icon'] ?? '';
		$item['multi_image'] = $inputData['multi_image'] ?? '';
		$item['options'] = $inputData['options'] ?? '0';
		$item['order'] = $inputData['order'] ?? 0;
		$item['status'] = $inputData['status'] ?? 0;
		$item['freeaddon'] = $inputData['freeaddon'] ?? 0;
		$item['addon'] = $inputData['addon'] ?? 0;
		$item['base'] = $inputData['base'] ?? 0;
		$item['drink'] = $inputData['drink'] ?? 0;
		$item['aname'] = $inputData['aname'] ?? '';
		$item['visible'] = $inputData['visible'] ?? '';
		$item['allowoffer'] = $inputData['allowoffer'] ?? 0;
		$item['allowgift'] = $inputData['allowgift'] ?? 0;
		$item['working_time1'] = $inputData['mon_time'] ?? '';
		$item['working_time2'] = $inputData['tue_time'] ?? '';
		$item['working_time3'] = $inputData['wed_time'] ?? '';
		$item['working_time4'] = $inputData['thu_time'] ?? '';
		$item['working_time5'] = $inputData['fri_time'] ?? '';
		$item['working_time6'] = $inputData['sat_time'] ?? '';
		$item['working_time7'] = $inputData['sun_time'] ?? '';
		$item['item_type'] = $inputData['item_type'] ?? '';
		$item['vat'] = $inputData['tax_rate'] ?? '';
		$item['printer'] = $inputData['printer'] ?? '';
		$item['background'] = $inputData['background'] ?? '0';
		$item['forground'] = $inputData['forground'] ?? '0';
		$item['emojiName'] = $inputData['emojiName'] ?? '';
		$item['type'] = $inputData['type'] ?? '';
		$item['age_restriction'] = $inputData['age_restriction'] ?? '';
		$item['fmb_sts'] = $inputData['fmb_sts'] ?? '';
		$newMenuClient = new MenuClientAction();

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}
		
		$stmt = $newMenuClient->updateItem($item);
		$responseData = [
			"status" => true,
			"message" => "Item Updated Successfully",
			"response_code" => 200,
		];
		$response->getBody()->write(json_encode($responseData));
		return $response;
	}

	public function deleteItem(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$cat['id'] = $inputData['id'] ?? '';
		$cat['client_id'] = $inputData['client_id'] ?? '';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}

		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->deleteItem($cat);

		$responseData = [
			"status" => true,
			"message" => "Item Deleted Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function createAddon(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$addon['client_id'] = $inputData['client_id'] ?? 0;
		$addon['iid'] = $inputData['iid'] ?? 0;
		$addon['name'] = $inputData['name'] ?? '';
		$addon['icon'] = $inputData['icon'] ?? '';
		$addon['description'] = $inputData['description'] ?? '';
		$addon['limit'] = $inputData['limit'] ?? '';
		$addon['status'] = $inputData['status'] ?? '';
		$addon['sort'] = $inputData['sort'] ?? '';
		$addon['next'] = $inputData['next'] ?? '';
		$addon['aname'] = $inputData['aname'] ?? '';
		$addon['ne_ex'] = $inputData['ne_ex'] ?? '';
		$addon['Visible'] = $inputData['Visible'] ?? '';
		$addon['background'] = $inputData['background'] ?? '';
		$addon['forground'] = $inputData['forground'] ?? '';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}
		
		$newMenuClient = new MenuClientAction();
		$insertId = $newMenuClient->insertAddon($addon);
		$responseData = [
			"status" => true,
			"message" => "Addon Inserted Successfully",
			"data" => $insertId,
			"response_code" => 200,
		];
		$response->getBody()->write(json_encode($responseData));
		return $response;
	}

	public function editAddon(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$addon['id'] = $inputData['id'] ?? 0;
		$addon['client_id'] = $inputData['client_id'] ?? 0;
		$addon['iid'] = $inputData['iid'] ?? 0;
		$addon['name'] = $inputData['name'] ?? '';
		$addon['icon'] = $inputData['icon'] ?? '';
		$addon['description'] = $inputData['description'] ?? '';
		$addon['limit'] = $inputData['limit'] ?? '';
		$addon['status'] = $inputData['status'] ?? '';
		$addon['sort'] = $inputData['sort'] ?? '';
		$addon['next'] = $inputData['next'] ?? '';
		$addon['aname'] = $inputData['aname'] ?? '';
		$addon['ne_ex'] = $inputData['ne_ex'] ?? '';
		$addon['Visible'] = $inputData['Visible'] ?? '';
		$addon['background'] = $inputData['background'] ?? '';
		$addon['forground'] = $inputData['forground'] ?? '';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}
		
		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->updateAddon($addon);

		$responseData = [
			"status" => true,
			"message" => "Addon Updated Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function deleteAddon(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$cat['id'] = $inputData['id'] ?? '';
		$cat['client_id'] = $inputData['client_id'] ?? '';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}

		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->deleteAddon($cat);

		$responseData = [
			"status" => true,
			"message" => "Addon Deleted Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function createAddonItem(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$addonItem['client_id'] = $inputData['client_id'] ?? 0;
		$addonItem['name'] = $inputData['name'] ?? '';
		$addonItem['aname'] = $inputData['aname'] ?? '';
		$addonItem['aid'] = $inputData['aid'] ?? 0;
		$addonItem['price'] = $inputData['price'] ?? 0;
		$addonItem['order'] = $inputData['order'] ?? 0;
		$addonItem['next'] = $inputData['next'] ?? '';
		$addonItem['bold'] = $inputData['bold'] ?? '';
		$addonItem['status'] = $inputData['status'] ?? 1;
		$addonItem['type'] = $inputData['type'] ?? 'NONE';
		$addonItem['icon'] = $inputData['icon'] ?? '';
		$addonItem['sub_add_items'] = $inputData['sub_add_items'] ?? '';
		$addonItem['background'] = $inputData['background'] ?? '';
		$addonItem['forground'] = $inputData['forground'] ?? '';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}
		
		$newMenuClient = new MenuClientAction();
		$insertId = $newMenuClient->insertAddonItem($addonItem);
		$responseData = [
			"status" => true,
			"message" => "Addon Inserted Successfully",
			"data" => $insertId,
			"response_code" => 200,
		];
		$response->getBody()->write(json_encode($responseData));
		return $response;
	}

	public function editAddonItem(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$addonItem['id'] = $inputData['id'] ?? 0;
		$addonItem['client_id'] = $inputData['client_id'] ?? 0;
		$addonItem['name'] = $inputData['name'] ?? '';
		$addonItem['aname'] = $inputData['aname'] ?? '';
		$addonItem['aid'] = $inputData['aid'] ?? 0;
		$addonItem['price'] = $inputData['price'] ?? 0;
		$addonItem['order'] = $inputData['order'] ?? 0;
		$addonItem['next'] = $inputData['next'] ?? '';
		$addonItem['bold'] = $inputData['bold'] ?? '';
		$addonItem['status'] = $inputData['status'] ?? 1;
		$addonItem['type'] = $inputData['type'] ?? 'NONE';
		$addonItem['icon'] = $inputData['icon'] ?? '';
		$addonItem['sub_add_items'] = $inputData['sub_add_items'] ?? '';
		$addonItem['background'] = $inputData['background'] ?? '';
		$addonItem['forground'] = $inputData['forground'] ?? '';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}
		
		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->updateAddonItem($addonItem);

		$responseData = [
			"status" => true,
			"message" => "Addon Updated Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function deleteAddonItem(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$cat['id'] = $inputData['id'] ?? '';
		$cat['client_id'] = $inputData['client_id'] ?? '';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}

		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->deleteAddonItem($cat);

		$responseData = [
			"status" => true,
			"message" => "Addon Item Deleted Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getCategories(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;

		try {
			$categories = $newMenuClient->getCategories($client_id);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Categories fetched successfully",
				"data" => $categories,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch categories: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getSubCategories(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;

		try {
			$categories = $newMenuClient->getSubCategories($client_id);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Sub Categories fetched successfully",
				"data" => $categories,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch categories: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getCategoryById(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;
		$catId = $inputData['id'] ?? 0;

		try {
			$categories = $newMenuClient->getCategoryById($client_id, $catId);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Categories Details fetched successfully",
				"data" => $categories,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch categories details: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getSubgroupbyCat(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;

		try {
			$categories = $newMenuClient->getSubgroupbyCat($client_id);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Categories Details fetched successfully",
				"data" => $categories,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch categories details: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getSubCategoryById(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;
		$subcatId = $inputData['id'] ?? 0;

		try {
			$categories = $newMenuClient->getSubCategoryById($client_id, $subcatId);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Sub Categories Details fetched successfully",
				"data" => $categories,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Sub categories details: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}


	public function editSubCategory(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$subCat['id'] = $inputData['id'] ?? '0';
		$subCat['catagery_id'] = $inputData['catagery_id'] ?? '';
		$subCat['name'] = $inputData['name'] ?? '';
		$subCat['description'] = $inputData['description'] ?? '';
		$subCat['options'] = $inputData['options'] ?? '0';
		$subCat['image'] = $inputData['image'] ?? '';
		$subCat['icon'] = $inputData['icon'] ?? '';
		$subCat['working_days'] = $inputData['working'] ?? '';
		$subCat['coupon'] = $inputData['coupon'] ?? '';
		$subCat['order'] = $inputData['order'] ?? 0;
		$subCat['status'] = $inputData['status'] ?? 0;
		$subCat['background'] = $inputData['background'] ?? '0';
		$subCat['forground'] = $inputData['forground'] ?? '0';
		$subCat['aname'] = $inputData['aname'] ?? '';
		$subCat['visible'] = $inputData['visible'] ?? '';
		$subCat['allowoffer'] = $inputData['allowoffer'] ?? 0;
		$subCat['allowgift'] = $inputData['allowgift'] ?? 0;
		$subCat['mon_time'] = $inputData['mon_time'];
		$subCat['tue_time'] = $inputData['tue_time'];
		$subCat['wed_time'] = $inputData['wed_time'];
		$subCat['thu_time'] = $inputData['thu_time'];
		$subCat['fri_time'] = $inputData['fri_time'];
		$subCat['sat_time'] = $inputData['sat_time'];
		$subCat['sun_time'] = $inputData['sun_time'];
		$subCat['client_id'] = $inputData['client_id'] ?? 0;

		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->updateSubCategory($subCat);

		$responseData = [
			"status" => true,
			"message" => "Subcategory Updated Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function deleteSubCategory(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$cat['id'] = $inputData['id'] ?? '';
		$cat['client_id'] = $inputData['client_id'] ?? '';

		if (empty($inputData['client_id']))
		{
			$response->getBody()->write(json_encode([
                "status" => false,
                "message" => 'client_id is required',
                "response_code" => 400
            ]));

            return $response;
		}

		$newMenuClient = new MenuClientAction();
		$stmt = $newMenuClient->deleteSubCategory($cat);

		$responseData = [
			"status" => true,
			"message" => "SubCategory Deleted Successfully",
			"response_code" => 200,
		];

		$response->getBody()->write(json_encode($responseData));
		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getAllItems(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;

		try {
			$items = $newMenuClient->getAllItems($client_id);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Items fetched successfully",
				"data" => $items,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Items: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getItemsById(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;
		$id = $inputData['id'] ?? 0;

		try {
			$item = $newMenuClient->getItemsById($client_id, $id);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Items fetched successfully",
				"data" => $item,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Items: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getAllAddons(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;

		try {
			$addons = $newMenuClient->getAllAddons($client_id);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Addons fetched successfully",
				"data" => $addons,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Items: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getAddonById(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;
		$id = $inputData['id'] ?? 0;

		try {
			$addon = $newMenuClient->getAddonById($client_id, $id);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Addon fetched successfully",
				"data" => $addon,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Addon: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getAllAddonItemsByAddonId(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;
		$id = $inputData['id'] ?? 0;

		try {
			$addonItems = $newMenuClient->getAllAddonItemsByAddonId($client_id, $id);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Addon items fetched successfully",
				"data" => $addonItems,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Addon items: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getAllAddonItems(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;

		try {
			$addonItems = $newMenuClient->getAllAddonItems($client_id);
			
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Addon items fetched successfully",
				"data" => $addonItems,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Addon Items: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function getAddonItemById(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;
		$id = $inputData['id'] ?? 0;

		try {
			$addonItem = $newMenuClient->getAddonItemById($client_id, $id);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Addon item fetched successfully",
				"data" => $addonItem,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Addon item: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function updateStatus(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;
		$id = $inputData['id'] ?? 0;
		$status = $inputData['status'] ?? 0;
		$table = $inputData['table'] ?? null;

		try {
			$addonItem = $newMenuClient->updateStatus($client_id, $id, $status, $table);
			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Status updated successfully",
				"data" => $addonItem,
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to update the status: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function updatingAllMenu(Request $request, Response $response, $args)
	{
		$newMenuClient = new MenuClientAction();

		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;
		
		if (!$client_id) {
            $responseData = [
                "status" => false,
                "message" => "client_id is required field",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

		$catUpdate = new MenuUpdateClientDB($client_id);

		try {
			$categoryUpdate = $newMenuClient->getCategories($client_id);
			foreach ($categoryUpdate as $key => $value) {
				$cat = $catUpdate->categoryUpdate($value);
				$subCategoryUpdate = $newMenuClient->getSubCategoriesByCatId($value->id);
				foreach ($subCategoryUpdate as $key => $value) {
					$value->catagery_id = $cat->insert_id;
					$subCat = $catUpdate->subCategoryUpdate($value);
					$ItemsUpdate = $newMenuClient->getItemsBySubCatId($value->id);
					foreach ($ItemsUpdate as $key => $value) {
						$value->sid = $subCat->insert_id;
						$items = $catUpdate->itemUpdate($value);
					}
				}
			}

			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Date Moved successfully",
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Items: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}

	public function moveMenuToFK(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$client_id = $inputData['client_id'] ?? 0;

		if (!$client_id) {
            $responseData = [
                "status" => false,
                "message" => "client_id is required field",
                "response_code" => 400,
            ];
            $response->getBody()->write(json_encode($responseData));
            return $response;
        }

		$client_db_menu = new MenuUpdateClientDB($client_id);
		$newMenuClient = new MenuClientAction();

		try {
			// Categories
			$categories = $client_db_menu->getCategories();
			$newMenuClient->deleteCategoriesByClient($client_id);
			$records = json_decode(json_encode($categories), true);
			$newMenuClient->insertRecords('tbl_catagery', $records, $client_id);

			// Subcategories
			$subcategories = $client_db_menu->getSubCategories();
			$newMenuClient->deleteSubCategoriesByClient($client_id);
			$records = json_decode(json_encode($subcategories), true);
			$newMenuClient->insertRecords('tbl_subcatagery', $records, $client_id);

			// Addons
			$addons = $client_db_menu->getAddons();
			$newMenuClient->deleteAddonsByClient($client_id);
			$records = json_decode(json_encode($addons), true);
			$newMenuClient->insertRecords('tbl_addon', $records, $client_id);

			// Addon Items
			$addonItems = $client_db_menu->getAddonItems();
			$newMenuClient->deleteAddonItemsByClient($client_id);
			$records = json_decode(json_encode($addonItems), true);
			$newMenuClient->insertRecords('tbl_addon_items', $records, $client_id);

			// Items
			$items = $client_db_menu->getItems();
			$newMenuClient->deleteItemsByClient($client_id);
			$records = json_decode(json_encode($items), true);
			$newMenuClient->insertRecords('tbl_items', $records, $client_id);

			$response->getBody()->write(json_encode([
				"status" => true,
				"message" => "Data Moved successfully",
			]));
		} catch (Exception $e) {
			$response->getBody()->write(json_encode([
				"status" => false,
				"message" => "Failed to fetch Items: " . $e->getMessage(),
				"data" => []
			]));
		}

		return $response->withHeader('Content-Type', 'application/json');
	}
}