<?php
namespace App\Controllers;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;
use App\Controllers\PostcodeController;
use App\Controllers\PagesController;
use App\Models\Home;
use App\Models\RestaurantPage;
use App\Helpers\MailValidation;
use App\Helpers\SmsValidation;

class RestaurantController
{
	public function getRestaurant(Request $request, Response $response, $args)
	{
		$restaurant = new RestaurantPage();
		$current_time = time();
		$inputData = json_decode(file_get_contents('php://input'), true);

		if(isset($inputData['order_mode']) && $inputData['order_mode'] != "") 
			$orderMode = $inputData['order_mode'];
		else
			$orderMode = "1";

		if(isset($inputData['order_time']) && $inputData['order_time'] != "") 
			$orderTime = strtotime($inputData['order_time']);
		else
			$orderTime = $current_time;
			
		if(isset($inputData['favourite']) && $inputData['favourite'] == true) {
			# favourite client list datas
			if(isset($inputData['customer_id']) && $inputData['customer_id'] != "" && $inputData['customer_id'] != "0") {
				$customerId = $inputData['customer_id'];
			} else {
				$responseData = [
					"status" => false, 
					"message" => "Customer Id is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}

			# get favourite list 
			$favouriteLists = $restaurant->getFavouriteList($customerId);
			$latitude = 0;
			$longitude = 0;

			$source = "web";
			$getClientList = $restaurant->getClientList($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists,$source);

			if(!empty($getClientList['restaurantList'])) {
				$restaurantResponse['restaurantList'] = $getClientList['restaurantList'];
				$restaurantResponse['restaurantFilter'] = $getClientList['filter'];
				$restaurantResponse['hygieneRatingFilter'] = $getClientList['hygieneRatingFilter'];
				$restaurantResponse['offerFilters'] = $getClientList['offerFilters'];
				$restaurantResponse['dietaryFilter'] = $getClientList['dietaryFilter'];
				$restaurantResponse['offerBanners'] = $getClientList['offerBanners'];
				$restaurantResponse['getAllActiveCuisine'] = $getClientList['getAllActiveCuisine'];

				$responseData = [
					"status" => true, 
					"message" => "Client List",
					"data" => $restaurantResponse,
					"response_code" => 200,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;

			} else {
				$responseData = [
					"status" => false, 
					"message" => "Empty client List",
					"data" => [],
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		} else {
			if(isset($inputData['customer_id']) && $inputData['customer_id'] != "0") 
				$customerId = $inputData['customer_id'];
			else
				$customerId = '';

			if(isset($inputData['post_code']) && $inputData['post_code'] != "")
			{
				$PostcodeController = new PostcodeController();
				$restaurantResponse = array();
				$getPostCodeDetail = $PostcodeController->getPostCodeDetail($inputData['post_code']);
				$getPostCodeDetail = json_decode($getPostCodeDetail);
				if(!empty($getPostCodeDetail))
				{
					if($getPostCodeDetail->status)
					{
						$latitude = $getPostCodeDetail->latitude;
						$longitude = $getPostCodeDetail->longitude;
						$location = array('latitude' => $latitude,'longitude' => $longitude);
						$location = json_decode(json_encode($location), FALSE);

						$favouriteLists = 0;
						$source = "web";
						$getClientList = $restaurant->getClientList($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists,$source);
						
						if(!empty($getClientList['restaurantList'])) {
							$restaurantResponse['restaurantList'] = $getClientList['restaurantList'];
							$restaurantResponse['restaurantFilter'] = $getClientList['filter'];
							$restaurantResponse['hygieneRatingFilter'] = $getClientList['hygieneRatingFilter'];
							$restaurantResponse['offerFilters'] = $getClientList['offerFilters'];
							$restaurantResponse['dietaryFilter'] = $getClientList['dietaryFilter'];
							$restaurantResponse['offerBanners'] = $getClientList['offerBanners'];
							$restaurantResponse['getAllActiveCuisine'] = $getClientList['getAllActiveCuisine'];
	
							$responseData = [
								"status" => true, 
								"message" => "Client List",
								"data" => $restaurantResponse,
								"response_code" => 200,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
	
						} else {
							$responseData = [
								"status" => false, 
								"message" => "Empty client List",
								"data" => $restaurantResponse,
								"response_code" => 400,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
						}
					}
					else
					{
						$responseData = [
							"status" => false, 
							"message" => "Invalid PostCode",
							"response_code" => 400,
						];
						$response->getBody()->write(json_encode($responseData));
						return $response;
					}
				}
			}
			else
			{
				$responseData = [
					"status" => false, 
					"message" => "Postcode field is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		}
	}

	public function getRestaurantDatas(Request $request, Response $response, $args) 
	{
		$restaurant = new RestaurantPage();
		$current_time = time();
		$inputData = json_decode(file_get_contents('php://input'), true);

		if(isset($inputData['order_mode']) && $inputData['order_mode'] != "") 
			$orderMode = $inputData['order_mode'];
		else
			$orderMode = "1";

		if(isset($inputData['order_time']) && $inputData['order_time'] != "") 
			$orderTime = strtotime($inputData['order_time']);
		else
			$orderTime = $current_time;

		$limit = $inputData['limit'] ?? 1;

			
		if(isset($inputData['favourite']) && $inputData['favourite'] == true) {
			# favourite client list datas
			if(isset($inputData['customer_id']) && $inputData['customer_id'] != "" && $inputData['customer_id'] != "0") {
				$customerId = $inputData['customer_id'];
			} else {
				$responseData = [
					"status" => false, 
					"message" => "Customer Id is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}

			# get favourite list 
			$favouriteLists = $restaurant->getFavouriteList($customerId);
			$latitude = 0;
			$longitude = 0;

			$getClientList = $restaurant->getClientListWithLimit($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists,$limit);

			if(!empty($getClientList['restaurantList'])) {
				$responseData = [
					"status" => true, 
					"message" => "Client List",
					"data" => $getClientList,
					"response_code" => 200,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;

			} else {
				$responseData = [
					"status" => false, 
					"message" => "Empty client List",
					"data" => [],
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		} else {
			if(isset($inputData['customer_id']) && $inputData['customer_id'] != "0") 
				$customerId = $inputData['customer_id'];
			else
				$customerId = '';

			if(isset($inputData['post_code']) && $inputData['post_code'] != "")
			{
				$PostcodeController = new PostcodeController();
				$restaurantResponse = array();
				$getPostCodeDetail = $PostcodeController->getPostCodeDetail($inputData['post_code']);
				$getPostCodeDetail = json_decode($getPostCodeDetail);
				if(!empty($getPostCodeDetail))
				{
					if($getPostCodeDetail->status)
					{
						$latitude = $getPostCodeDetail->latitude;
						$longitude = $getPostCodeDetail->longitude;
						$location = array('latitude' => $latitude,'longitude' => $longitude);
						$location = json_decode(json_encode($location), FALSE);

						$favouriteLists = 0;
						$getClientList = $restaurant->getClientListWithLimit($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists,$limit);

						if(!empty($getClientList['restaurantList'])) {
							$responseData = [
								"status" => true, 
								"message" => "Client List",
								"data" => $getClientList,
								"response_code" => 200,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
	
						} else {
							$responseData = [
								"status" => false, 
								"message" => "Empty client List",
								"data" => $restaurantResponse,
								"response_code" => 400,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
						}
					}
					else
					{
						$responseData = [
							"status" => false, 
							"message" => "Invalid PostCode",
							"response_code" => 400,
						];
						$response->getBody()->write(json_encode($responseData));
						return $response;
					}
				}
			}
			else
			{
				$responseData = [
					"status" => false, 
					"message" => "Postcode field is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		}
	}

	public function getRestaurantFiltersList(Request $request, Response $response, $args) 
	{
		$restaurant = new RestaurantPage();
		$current_time = time();
		$inputData = json_decode(file_get_contents('php://input'), true);

		if(isset($inputData['order_mode']) && $inputData['order_mode'] != "") 
			$orderMode = $inputData['order_mode'];
		else
			$orderMode = "1";

		if(isset($inputData['order_time']) && $inputData['order_time'] != "") 
			$orderTime = strtotime($inputData['order_time']);
		else
			$orderTime = $current_time;

		if(isset($inputData['favourite']) && $inputData['favourite'] == true) {
			# favourite client list datas
			if(isset($inputData['customer_id']) && $inputData['customer_id'] != "" && $inputData['customer_id'] != "0") {
				$customerId = $inputData['customer_id'];
			} else {
				$responseData = [
					"status" => false, 
					"message" => "Customer Id is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}

			# get favourite list 
			$favouriteLists = $restaurant->getFavouriteList($customerId);

			$latitude = 0;
			$longitude = 0;

			$getClientList = $restaurant->getClientListWithFilters($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists);

			if(!empty($getClientList['filter'])) {
				$restaurantResponse['restaurantFilter'] = $getClientList['filter'];
				$restaurantResponse['hygieneRatingFilter'] = $getClientList['hygieneRatingFilter'];
				$restaurantResponse['offerFilters'] = $getClientList['offerFilters'];
				$restaurantResponse['dietaryFilter'] = $getClientList['dietaryFilter'];
				$restaurantResponse['offerBanners'] = $getClientList['offerBanners'];
				$restaurantResponse['getAllActiveCuisine'] = $getClientList['getAllActiveCuisine'];

				$responseData = [
					"status" => true, 
					"data" => $restaurantResponse,
					"response_code" => 200,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;

			} else {
				$responseData = [
					"status" => false,
					"data" => [],
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		} else {
			if(isset($inputData['customer_id']) && $inputData['customer_id'] != "0") 
				$customerId = $inputData['customer_id'];
			else
				$customerId = '';

			if(isset($inputData['post_code']) && $inputData['post_code'] != "")
			{
				$PostcodeController = new PostcodeController();
				$restaurantResponse = array();
				$getPostCodeDetail = $PostcodeController->getPostCodeDetail($inputData['post_code']);
				$getPostCodeDetail = json_decode($getPostCodeDetail);
				if(!empty($getPostCodeDetail))
				{
					if($getPostCodeDetail->status)
					{
						$latitude = $getPostCodeDetail->latitude;
						$longitude = $getPostCodeDetail->longitude;
						$location = array('latitude' => $latitude,'longitude' => $longitude);
						$location = json_decode(json_encode($location), FALSE);

						$favouriteLists = 0;
						$getClientList = $restaurant->getClientListWithFilters($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists);

						if(!empty($getClientList['filter'])) {
							$restaurantResponse['restaurantFilter'] = $getClientList['filter'];
							$restaurantResponse['hygieneRatingFilter'] = $getClientList['hygieneRatingFilter'];
							$restaurantResponse['offerFilters'] = $getClientList['offerFilters'];
							$restaurantResponse['dietaryFilter'] = $getClientList['dietaryFilter'];
							$restaurantResponse['offerBanners'] = $getClientList['offerBanners'];
							$restaurantResponse['getAllActiveCuisine'] = $getClientList['getAllActiveCuisine'];
	
							$responseData = [
								"status" => true, 
								"data" => $restaurantResponse,
								"response_code" => 200,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
	
						} else {
							$responseData = [
								"status" => false, 
								"data" => $restaurantResponse,
								"response_code" => 400,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
						}
					}
					else
					{
						$responseData = [
							"status" => false, 
							"message" => "Invalid PostCode",
							"response_code" => 400,
						];
						$response->getBody()->write(json_encode($responseData));
						return $response;
					}
				}
			}
			else
			{
				$responseData = [
					"status" => false, 
					"message" => "Postcode field is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		}
	}

	public function getCuisinesList(Request $request, Response $response, $args) 
	{
		$restaurant = new RestaurantPage();
		$current_time = time();
		$inputData = json_decode(file_get_contents('php://input'), true);

		if(isset($inputData['order_mode']) && $inputData['order_mode'] != "") 
			$orderMode = $inputData['order_mode'];
		else
			$orderMode = "1";

		if(isset($inputData['order_time']) && $inputData['order_time'] != "") 
			$orderTime = strtotime($inputData['order_time']);
		else
			$orderTime = $current_time;
	
		$limit = $inputData['limit'] ?? 1;

		if(isset($inputData['favourite']) && $inputData['favourite'] == true) {
			# favourite client list datas
			if(isset($inputData['customer_id']) && $inputData['customer_id'] != "" && $inputData['customer_id'] != "0") {
				$customerId = $inputData['customer_id'];
			} else {
				$responseData = [
					"status" => false, 
					"message" => "Customer Id is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}

			# get favourite list 
			$favouriteLists = $restaurant->getFavouriteList($customerId);

			$latitude = 0;
			$longitude = 0;

			$getClientList = $restaurant->getCuisinesWithLimit($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists,$limit);

			if(!empty($getClientList)) {
				$responseData = [
					"status" => true, 
					"data" => $getClientList,
					"response_code" => 200,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			} else {
				$responseData = [
					"status" => false,
					"data" => [],
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		} else {
			if(isset($inputData['customer_id']) && $inputData['customer_id'] != "0") 
				$customerId = $inputData['customer_id'];
			else
				$customerId = '';

			if(isset($inputData['post_code']) && $inputData['post_code'] != "")
			{
				$PostcodeController = new PostcodeController();
				$restaurantResponse = array();
				$getPostCodeDetail = $PostcodeController->getPostCodeDetail($inputData['post_code']);
				$getPostCodeDetail = json_decode($getPostCodeDetail);
				if(!empty($getPostCodeDetail))
				{
					if($getPostCodeDetail->status)
					{
						$latitude = $getPostCodeDetail->latitude;
						$longitude = $getPostCodeDetail->longitude;
						$location = array('latitude' => $latitude,'longitude' => $longitude);
						$location = json_decode(json_encode($location), FALSE);

						$favouriteLists = 0;
						$getClientList = $restaurant->getCuisinesWithLimit($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists,$limit);

						if(!empty($getClientList)) {
							$responseData = [
								"status" => true, 
								"data" => $getClientList,
								"response_code" => 200,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
	
						} else {
							$responseData = [
								"status" => false, 
								"data" => $restaurantResponse,
								"response_code" => 400,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
						}
					}
					else
					{
						$responseData = [
							"status" => false, 
							"message" => "Invalid PostCode",
							"response_code" => 400,
						];
						$response->getBody()->write(json_encode($responseData));
						return $response;
					}
				}
			}
			else
			{
				$responseData = [
					"status" => false, 
					"message" => "Postcode field is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		}
	}


	public function favouriteAction(Request $request, Response $response, $args)
	{
		$restaurant = new RestaurantPage();
		$inputData = json_decode(file_get_contents('php://input'), true);
		$params = [
			'customer_id' => $inputData['customer_id'] ?? '',
			'client_id' => $inputData['client_id'] ?? '',
		];

		$errors = [];
		foreach ($params as $key => $value) {
			if (empty($value)) {
				$errors[] = ucfirst($key) . ' is required';
			}
		}

		if (!empty($errors)) {
			$responseData = [
				"status" => false, 
				"message" => implode('. ', $errors),
				"response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}

		$customerId = $params["customer_id"];
		$clientId = $params["client_id"];

		# get user's favourite list
		$getFavouriteData = $restaurant->getFavouriteById($customerId,$clientId);
		if(!empty($getFavouriteData))
		{
			# delete favourite client from user list
			$restaurant->deleteFavouriteById($customerId,$clientId);
			$responseData = [
				"status" => true, 
				"data" => "Delete to favourite successfully",
				"response_code" => 200,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}
		else
		{
			# add favourite client from user list
			$restaurant->createFavouriteById($customerId,$clientId);
			$responseData = [
				"status" => true, 
				"data" => "Add to favourite successfully",
				"response_code" => 200,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}
	}

	public function noTakeaway(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
        $params = [
            'name' => $inputData['name'] ?? '',
			'email' => $inputData['email'] ?? '',
			'restaurant_name' => $inputData['restaurant_name'] ?? '', 
			'restaurant_phone' => $inputData['restaurant_phone'] ?? '', 
			'postcode' => $inputData['postcode'] ?? '', 
			'ip' => $inputData['ip'] ?? '', 
		];

		$errors = [];
		foreach ($params as $key => $value) {
			if (empty($value)) {
				$errors[] = ucfirst($key) . ' is required';
			}
		}

		if (!empty($errors)) {
			$responseData = [
				"status" => false, 
				"message" => implode('. ', $errors),
				"response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}

		$pagesController = new PagesController();
		$validMail = new MailValidation();
		$validSms = new SmsValidation();

		# email id validation
		$mail = $validMail->checkEmail($params['email']);
		if($mail!='true') {
			$responseData = [
				"status" => false, 
				"data" => "Invalid Email",
				"response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}

		# phone number validation
		$sms = $validSms->checkUkNumber($params['restaurant_phone']);
		if($sms!='true') {
			$responseData = [
				"status" => false, 
				"data" => "Invalid phone Number",
				"response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}

        $noTakeawayMail = $pagesController->noTakeawayMail($params);

		if($noTakeawayMail == true) {
			$responseData = [
				"status" => true, 
				"message" => "form submitted",
				"response_code" => 200,
			];
		} else {
			$responseData = [
				"status" => false, 
				"message" => $noTakeawayMail,
				"response_code" => 400,
			];
		}
		$response->getBody()->write(json_encode($responseData));
		return $response;
	}

}

?>