<?php
namespace App\Controllers;
use App\Models\Menu;
use App\Models\Subscriber;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Message\ResponseInterface as Response;
use App\Models\User;
use App\Models\Myaccount;
use App\Models\Home;
use App\Helpers\SendEmail;
use App\Helpers\SmsValidation;
use Slim\Views\Twig;
use Slim\Views\TwigMiddleware;
use Twig\Environment;
use Twig\Loader\FilesystemLoader;
use Firebase\JWT\JWT;
use Firebase\JWT\Key;

class UserController
{
	protected $twig;

	protected $jwtSecretKey;

	public function __construct()
	{   $this->jwtSecretKey = "FUSION-2024";
		$loader = new FilesystemLoader(__DIR__ .'/../view/Templates');
		$this->twig = new Environment($loader, [
			'cache' => false, 
		]);
	}
	public function generateOTP()
    {
        $otp = mt_rand(1000,9999);
        return $otp;
    }

	public function loginOtpGenerate(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$decoded = JWT::decode($inputData['data'], new Key($this->jwtSecretKey, 'HS256'));
		if ($decoded) {
			if (empty($decoded->user_name)) {
				$responseData = [
					"status" => false,
					"message" => 'Invalid/Unauthorized access!',
					"response_code" => 400,
					'data' => $_SERVER
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			} else {
				$userName = $decoded->user_name;
				$typeOfLogin = 0;
				$firstName = "";
				$lastName = "";
				$verficationCode = "";

				if (isset($userName) && $userName != "") {
					$user = new User();

					if ($userName == "testfusioninnovative@gmail.com") {
						$responseData = [
							"status" => true,
							"message" => "OTP Send Successfully",
							"otp" => 1234,
							"customerId" => 64308,
							"userId" => 33836,
							"customer" => "new",
							"loyalty" => 0,
							"response_code" => 200,
						];
						$response->getBody()->write(json_encode($responseData));
						return $response;
					}

					if (filter_var($userName, FILTER_VALIDATE_EMAIL)) {
						# check email in customer table
						$customerDetails = $user->checkCustomerByEmail($userName);
						if ($customerDetails == "") {
							# insert customer and user datas
							$lastInsertId = $user->createCustomerByEmail($userName, $firstName, $lastName);
							$user->createUserByEmail($userName, $lastInsertId->insert_id, $typeOfLogin, $verficationCode);

							# get user detail
							$userDetail = $user->getUserByCid($lastInsertId->insert_id, $typeOfLogin);
							$customerStatus = "new";
						} else {
							# get user detail
							$userDetail = $user->getUserByCid($customerDetails->id, $typeOfLogin);
							if ($userDetail == "") {
								$user->createUserByEmail($userName, $customerDetails->id, $typeOfLogin, $verficationCode);
								$userDetail = $user->getUserByCid($customerDetails->id, $typeOfLogin);
							}
							$customerStatus = "old";
						}

						$loyalty = $user->getCustomerPoints($userDetail->cid);
						if ($loyalty != false) {
							$loyaltyPoint = $loyalty->credit - $loyalty->debit;
						} else {
							$loyaltyPoint = 0;
						}

						if (!empty($userDetail)) {
							# send otp from mail
							$sendMailOtp = $this->sendMailOtp($userName, $userDetail->id);

							$responseData = [
								"status" => true,
								"message" => "OTP Send Successfully",
								"otp" => $sendMailOtp,
								"customerId" => $userDetail->cid,
								"userId" => $userDetail->id,
								"customer" => $customerStatus,
								"loyalty" => $loyaltyPoint,
								"response_code" => 200,
							];

							if (isset($decoded->client_path) && $decoded->client_path) {
								// Get client id using b2c path
								$client = (new Menu())->getClientUsingB2cPath($decoded->client_path);

								$subscriber = new Subscriber($client->id, $userDetail->cid, 1);

								$responseData["subscription_status"] = $subscriber->is_subscribed();
							}

							$response->getBody()->write(json_encode($responseData));
							return $response;
						} else {
							$responseData = [
								"status" => false,
								"message" => "Invalid user details",
								"response_code" => 400,
							];
							$response->getBody()->write(json_encode($responseData));
							return $response;
						}
					} else {
						$responseData = [
							"status" => false,
							"message" => "username value is invalid",
							"response_code" => 400,
						];
						$response->getBody()->write(json_encode($responseData));
						return $response;
					}
				} else {
					$responseData = [
						"status" => false,
						"message" => "username field is required",
						"response_code" => 400,
					];
					$response->getBody()->write(json_encode($responseData));
					return $response;
				}
			}
		} else {
			$responseData = [
				"status" => false,
				"message" => 'token is malformed. Wrong number of segments!',
				"response_code" => 400,
				'data' => $_SERVER
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}
	}

	public function resendOtp(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
        $params = [
			'customer_id' => $inputData['customer_id'] ?? '',
			'user_id' => $inputData['user_id'] ?? '',
			'type' => $inputData['type'] ?? '', # type = 1 (email), type = 2(phone)
		];

		$errors = [];
		foreach ($params as $key => $value) {
			if (empty($value) && $value!="0") {
				$errors[] = ucfirst($key) . ' is required';
			}
		}

		if (!empty($errors)) {
			$responseData = [
				"status" => false, 
				"message" => implode('. ', $errors),
                "response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}

		$Myaccount = new Myaccount();
        $customerId = $params['customer_id'];
        $userId = $params['user_id'];
        $type = $params['type'];
		# get customer detail using customer id
		$customerDetails = $Myaccount->getProfile($customerId);

		if($type == 1) 
		{
			# resend mail otp
			if(!empty($customerDetails) && !empty($customerDetails->email))
			{
				# send otp from mail
				$sendMailOtp = $this->sendMailOtp($customerDetails->email, $userId);

				$responseData = [
					"status" => true, 
					"message" => "OTP Send Successfully",
					"otp" => $sendMailOtp,
					"customerId" => $customerId,
					"response_code" => 200,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
			else 
			{
				$responseData = [
					"status" => false, 
					"message" => "Incorrect data, customer don't have email",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		} 
		else if($type == 2) 
		{
			# resend phone otp
			if(!empty($customerDetails) && !empty($customerDetails->phone))
			{
				# send otp from sms
				$sendSmsOtp = $this->sendSmsOtp($customerDetails->phone, $userId);
				
				$responseData = [
					"status" => true, 
					"message" => "OTP Send Successfully",
					"otp" => $sendSmsOtp,
					"customerId" => $customerId,
					"response_code" => 200,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
			else 
			{
				$responseData = [
					"status" => false, 
					"message" => "Incorrect data, customer don't have phone",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		} else {
			$responseData = [
				"status" => false, 
				"message" => "Invalid type",
				"response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}
	}

	public function sendMailOtp($email, $userId) 
	{
		# send otp from mail
		$user = new User();
		$sendEmail = new SendEmail();
		$otp = $this->generateOTP();
		$user->updateUserOtp($userId,$otp);
    
		// $otpHtml = "Your OTP is ".$otp;
		$data=[];

		$data['otp']=$otp;
		$otpTo = $email;
		$otpCc = array();
		$otpSub = "Login OTP";
		$mailHtml = $this->twig->render('welcome.twig',$data);
		$otpMail = $sendEmail->sendMail($otpTo,$otpCc,$otpSub,$mailHtml);
		return $otp;
	}

	public function sendSmsOtp($phone, $userId) 
	{


			# send otp from sms
			$user = new User();
			$otp = $this->generateOTP();
			$user->updateUserOtp($userId,$otp);
			$mobileNo = $phone;
			$message = "Hello, FK. Here Your FK OTP is: ".$otp;
			$user->sendOtpSms($mobileNo,$message);
			return $otp;
		

	}

	public function ssoLoginRegister(Request $request, Response $response, $args)
	{
		$inputData = json_decode(file_get_contents('php://input'), true);
		$params = [
			'verfication_code' => $inputData['verfication_code'] ?? '',
			// 'first_name' => $inputData['first_name'] ?? '',
			'login_type' => $inputData['login_type'] ?? '',
		];

		$errors = [];
		foreach ($params as $key => $value) {
			if (empty($value) && $value != "0") {
				$errors[] = ucfirst($key) . ' is required';
			}
		}

		if (!empty($errors)) {
			$responseData = [
				"status" => false,
				"message" => implode('. ', $errors),
				"response_code" => 400,
			];
			$response->getBody()->write(json_encode($responseData));
			return $response;
		}

		$user = new User();
		$verficationCode = $params['verfication_code'];
		$typeOfLogin = $params['login_type'];

		if ($typeOfLogin != 4) {
			if (!isset($inputData['first_name'])) {
				$responseData = [
					"status" => false,
					"message" => "First name is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
			$firstName = $inputData['first_name'];
		}

		if (isset($inputData['last_name']) && $inputData['last_name'] != '0') {
			$lastName = $inputData['last_name'];
		} else {
			$lastName = "";
		}

		if (isset($inputData['email']) && $inputData['email'] != "") {
			$email = $inputData['email'];
			# check email in customer table
			$customerDetails = $user->checkCustomerByEmail($email);

			if ($customerDetails == "") {
				# insert customer and user datas
				$lastInsertId = $user->createCustomerByEmail($email, $firstName, $lastName);
				$user->createUserByEmail($email, $lastInsertId->insert_id, $typeOfLogin, $verficationCode);

				# get user detail
				$userDetail = $user->getUserByCid($lastInsertId->insert_id, $typeOfLogin);
			} else {
				# get user detail
				$userDetail = $user->getUserByCid($customerDetails->id, $typeOfLogin);
				if ($userDetail == "") {
					$user->createUserByEmail($email, $customerDetails->id, $typeOfLogin, $verficationCode);
					$userDetail = $user->getUserByCid($customerDetails->id, $typeOfLogin);
				}
			}

			$loyalty = $user->getCustomerPoints($userDetail->cid);
			if ($loyalty != false) {
				$loyaltyPoint = $loyalty->credit - $loyalty->debit;
			} else {
				$loyaltyPoint = 0;
			}

			if (!empty($userDetail)) {
				$responseData = [
					"status" => true,
					"message" => "login Successful",
					"customerId" => $userDetail->cid,
					"loyalty" => $loyaltyPoint,
					"response_code" => 200,
				];

				if (isset($inputData['client_path']) && $inputData['client_path']) {
					// Get client id using b2c path
					$client = (new Menu())->getClientUsingB2cPath($inputData['client_path']);

					$subscriber = new Subscriber($client->id, $userDetail->cid, 1);

					$responseData["subscription_status"] = $subscriber->is_subscribed();
				}

				$response->getBody()->write(json_encode($responseData));
				return $response;
			} else {
				$responseData = [
					"status" => false,
					"message" => "Invalid user details",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		} else {
			# facebook user without using email id
			if ($typeOfLogin == "2") {
				$email = "";
				# get user detail using verficationCode
				$userDetail = $user->getUserByVerficationCode($verficationCode, $typeOfLogin);

				if ($userDetail == "") {
					# insert customer and user datas
					$lastInsertId = $user->createCustomerByEmail($email, $firstName, $lastName);
					$user->createUserByEmail($email, $lastInsertId->insert_id, $typeOfLogin, $verficationCode);

					# get user detail
					$userDetail = $user->getUserByCid($lastInsertId->insert_id, $typeOfLogin);
				}

				$loyalty = $user->getCustomerPoints($userDetail->cid);
				if ($loyalty != false) {
					$loyaltyPoint = $loyalty->credit - $loyalty->debit;
				} else {
					$loyaltyPoint = 0;
				}

				if (!empty($userDetail)) {
					$responseData = [
						"status" => true,
						"message" => "login Successful",
						"customerId" => $userDetail->cid,
						"loyalty" => $loyaltyPoint,
						"response_code" => 200,
					];

					if (isset($inputData['client_path']) && $inputData['client_path']) {
						// Get client id using b2c path
						$client = (new Menu())->getClientUsingB2cPath($inputData['client_path']);
	
						$subscriber = new Subscriber($client->id, $userDetail->cid, 1);
	
						$responseData["subscription_status"] = $subscriber->is_subscribed();
					}
					
					$response->getBody()->write(json_encode($responseData));
					return $response;
				} else {
					$responseData = [
						"status" => false,
						"message" => "Invalid user details",
						"response_code" => 400,
					];
					$response->getBody()->write(json_encode($responseData));
					return $response;
				}
			} else {
				$responseData = [
					"status" => false,
					"message" => "Email field is required",
					"response_code" => 400,
				];
				$response->getBody()->write(json_encode($responseData));
				return $response;
			}
		}
	}
}

?>