<?php
namespace App\Helpers;
use Twilio;
require '../config/env.php';

class SendSms
{
    public function sendSms($phoneNumber,$message)
    {
        $userName = $_ENV['SMS_FROM'];
        $password = $_ENV['SMS_PASSWORD'];
        $origin = $_ENV['SMS_ORIGIN'];

        $curl = curl_init();
        curl_setopt_array($curl, array(
            CURLOPT_URL => "http://api.infobip.com/sms/1/text/single",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS =>"{ \"from\":\"$origin\", \"to\":[$phoneNumber], \"text\":\"$message\" }",
            CURLOPT_HTTPHEADER => array(
            "accept: application/json",
            "authorization: Basic ".base64_encode($userName . ":" .$password),
            "content-type: application/json"
            ),
        ));
        $response = curl_exec($curl);
        $err = curl_error($curl);
        curl_close($curl);
        return $response;

        // $accountSid = $_ENV["TWILIO_ACCOUNT_SID"];
        // $authToken = $_ENV["TWILIO_AUTH_TOKEN"];
        // $twilio = new Twilio\Rest\Client($accountSid, $authToken);
        // $twilio = $twilio->messages->create(
        //     $phoneNumber,
        //     [
        //         'from' => "+447782556546",
        //         'body' => $message,
        //     ]
        // );
        // return $twilio;
    }

    public function sendSmsClient($phoneNumber,$message,$sender = '')
    {
        $userName = $_ENV['SMS_FROM'];
        $password = $_ENV['SMS_PASSWORD'];
        $origin = !empty($sender) ? $sender : $_ENV['SMS_ORIGIN'];

        if (substr($phoneNumber, 0, 3) === "+44") {
        } else {
            if (substr($phoneNumber, 0, 2) === "44") {
                $phoneNumber = "+" . $phoneNumber;
            } else {
                $phoneNumber = "+44" . $phoneNumber;
            }
        }

        $curl = curl_init();
        curl_setopt_array($curl, [
            CURLOPT_URL => "http://api.infobip.com/sms/1/text/single",
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => "",
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 30,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => "POST",
            CURLOPT_POSTFIELDS => json_encode([
                "from" => $origin,
                "to" => [$phoneNumber],
                "text" => $message,
            ]),
            CURLOPT_HTTPHEADER => [
                "accept: application/json",
                "authorization: Basic " . base64_encode("$userName:$password"),
                "content-type: application/json",
            ],
        ]);

        $response = curl_exec($curl);

        $err = curl_error($curl);
        curl_close($curl);

        if ($err) {
            return $err;
        } else {
            return $response;
        }
    }
}