<?php
namespace App\Helpers;
use libphonenumber\PhoneNumberUtil;
use libphonenumber\PhoneNumberFormat;
use libphonenumber\NumberParseException;

class SmsValidation
{

    function checkIndianNumber($str) 
    {
        return (!preg_match("/^((\+){0,1}91(\s){0,1}(\-){0,1}(\s){0,1})?([0-9]{10})$/", $str)) ? FALSE : TRUE;
    }

    function checkUkNumber($str) 
    {
        return (!preg_match("/^\s*\(?(020[7,8]{1}\)?[ ]?[1-9]{1}[0-9{2}[ ]?[0-9]{4})|(0[1-8]{1}[0-9]{3}\)?[ ]?[1-9]{1}[0-9]{2}[ ]?[0-9]{3})\s*$/", $str)) ? FALSE : TRUE;
    }

    function validation($phoneNumber, $countryCode)
    {
        $phoneUtil = PhoneNumberUtil::getInstance();
        try {
            $parsedNumber = $phoneUtil->parse($phoneNumber, $countryCode);
            $isValidNumber = $phoneUtil->isValidNumber($parsedNumber);
            $formattedNumber = $phoneUtil->format($parsedNumber, PhoneNumberFormat::INTERNATIONAL);
    
            if ($isValidNumber) {
                // Phone number is valid
                // Do something with $formattedNumber
                // ...
                return array("status" => "true", "data" => $formattedNumber);
            } else {
                // Phone number is invalid
                // ...
                return array("status" => "false", "data" => "Phone number is invalid");
                return 'Phone number is invalid';
            }
        } catch (NumberParseException $e) {
            // Failed to parse phone number
            // ...
            return array("status" => "false", "data" => $e->getMessage());
            return $e->getMessage();
            return 'Failed to parse phone number';
        }
    }

}