<?php
namespace App\Helpers;
use Aws\S3\S3Client;
require '../config/env.php';

class s3
{
	protected $s3 = null;

	function __construct(){
		if($error = $this->s3Auth()){
			return $error;
		}
	}

    private function s3Auth(){
		try {
			$this->s3 = S3Client::factory(
				array(
					'credentials' => array(
						'key' => $_ENV['AWS_ACCESS_KEY_ID'],
						'secret' => $_ENV['AWS_SECRET_ACCESS_KEY']
					),
					'version' => 'latest',
					'region'  => $_ENV["AWS_REGION"]
				)
			);
		} catch (Exception $e) {
			return $e->getMessage();
		}
	}

    public function putFilesToObject($keyname,$file){
		try {
			return $this->s3->putObject(
				array(
					'Bucket'=> $_ENV['AWS_BUCKETNAME'],
					'Key' =>  $keyname,
					'SourceFile' => $file,
					'StorageClass' => 'STANDARD'
				)
			);

		} catch (Exception $e) {
			return $e->getMessage();
		}        
	}

    
	public function DeleteObjectFiles($keyname){
		try {
			// Delete an object from the bucket.
			$this->s3->deleteObject([
			    'Bucket' => $_ENV['AWS_BUCKETNAME'],
			    'Key'    => $keyname
			]);

		} catch (Exception $e) {
			return $e->getMessage();
		}
	}

    public function __destruct() 
	{
		$error = null;
	}
}