<?php
namespace App\Models;
use \PDO;
require '../config/env.php';
class Client extends DB
{
    private $connect;
    private $db;
    function __construct($client_id) 
    {
        $this->db = new DB();
        $databaseCredentials = $this->db->getClientDatabase($client_id);
        $host = $databaseCredentials->host;
        $dbname = $databaseCredentials->db;
        $userName = $_ENV['dbusername'];
        if($databaseCredentials->dpass == "")
            $password = "";
        else
            $password = $_ENV['dbpassword'];
        $charset = "utf8";
        $collation = "utf8_unicode_ci";

        $conn_str = "mysql:host=$host;dbname=$dbname;charset=$charset;collation=$collation";
        $conn = new PDO($conn_str, $userName, $password);
        $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        $conn->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);
        $conn->setAttribute(PDO::ATTR_STRINGIFY_FETCHES, false);
        $this->connect = $conn;
    }

    public function query($sql)
    {
        $conn = $this->connect;
        $result = $conn->prepare($sql);
        $result->execute();
        $data = $result->fetch(PDO::FETCH_OBJ);
        // $this->connectionClose();
        return $data;
    }

    public function queryAll($sql)
    {
        $conn = $this->connect;
        $result = $conn->prepare($sql);
        $result->execute();
        $data = $result->fetchAll(PDO::FETCH_OBJ);
        // $this->connectionClose();
        return $data;
    }

    public function connectionClose()
    {
        $this->connect = null;
    }

    private function decrypt($text)
    {
        if($text == "") {
            return false;
        } else {
            $salt='(^%(^@@&!^250691';
            return openssl_decrypt($text, 'AES-128-ECB', $salt);
        }  
    }

    public function lastInsertId()
    {
        return $this->connect->lastInsertId() ?? null;
    }

    public function queryCombine($sql)
    {
       
            $conn = $this->connect;
            $result = $conn->prepare($sql);
            $result->execute();
            
            $data = [];
            
            // Fetch the first result set
            $data[] = $result->fetch(PDO::FETCH_OBJ);

            // Move to the next result set and fetch the data
            while ($result->nextRowset()) {
                $data[] = $result->fetch(PDO::FETCH_OBJ);
            }
            
            return $data;
        
       
    }

    public function queryAllCombine($sql)
    {
        $conn = $this->connect;
        $result = $conn->prepare($sql);
        $result->execute();
        
        $data = [];
        
        // Fetch the first result set
        $data[] = $result->fetchAll(PDO::FETCH_OBJ);

        // Move to the next result set and fetch the data
        while ($result->nextRowset()) {
            $data[] = $result->fetchAll(PDO::FETCH_OBJ);
        }
        
        return $data;
    }

}