<?php
namespace App\Models;
use \PDO;

require '../config/env.php';

class DB
{
    private function connect()
    {

        if($_SERVER['SERVER_NAME'] == "localhost") {
            $host = "localhost";
            $user = "root";
            $password = "";
            $databaseName = "fusionaws_fusionkitchen";
        } else {
            $host = $_ENV['host'];
            $user = $_ENV['fkUser'];
            $password = $_ENV['fkPassword'];
            $databaseName = $_ENV['databaseName'];
        }
        $charset = "utf8";
        $collation = "utf8_unicode_ci";
        
        $connectionString  = "mysql:host=$host;dbname=$databaseName;charset=$charset;collation=$collation";
        $conn = new PDO($connectionString , $user, $password);
        $conn->setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
        $conn->setAttribute(PDO::ATTR_EMULATE_PREPARES, false);
        $conn->setAttribute(PDO::ATTR_STRINGIFY_FETCHES, false);
        return $conn;
    }

    public function query($sql)
    {
        $conn = $this->connect();
        $conn->exec("SET NAMES utf8mb4");
        $result = $conn->prepare($sql);
        $result->execute();
        $data = $result->fetch(PDO::FETCH_OBJ);
        $conn = null;
        return $data;
    }

    public function queryAll($sql)
    {
        $conn = $this->connect();
        $result = $conn->prepare($sql);
        $result->execute();
        $data = $result->fetchAll(PDO::FETCH_OBJ);
        $conn = null;
        return $data;
    }

    public function execute($sql, $params = [], $returnLastInsertId = false)
    {
    
        try {
            $stmt = $this->connect()->prepare($sql);
            $stmt->execute($params);

            if ($returnLastInsertId) {
                return $this->connect()->lastInsertId();
            } else {
                return $stmt->rowCount();
            }
        } catch (\PDOException $e) {
            // Log the error or handle it as needed
            return false;
        }
    }


    public function getClientDatabase($client_id)
    {
        return $this->query("CALL getBridgeDetail($client_id)");
    }
    
    public function getEmail($email)
    {
        $sql = "SELECT * from tbl_emailwebhook where email = '$email'";
        return $this->query($sql);
    }
    
    public function updateDND($email)
    {
        $eventType = 'unsubscribed'; 
        $timestamp = date('Y-m-d H:i:s'); 
        $jsonResponse = json_encode([]); 
        $sql = "CALL insert_email_webhook(
                    '{$eventType}', 
                    '{$email}', 
                    '{$timestamp}', 
                    '{$jsonResponse}'
                )";
        return $this->query($sql);
 
    }

    public function updatewebhook($data)
    {
        $sql = "CALL insert_email_webhook(
                    '{$data['event_type']}', 
                    '{$data['email']}', 
                    '{$data['created_at']}', 
                    '{$data['jsonresponse']}'
                )";
        return $this->query($sql);
    }

    public function getClientDetailsByDomain($domain)
    {
        return $this->query("CALL getClientDetailsByDomain('$domain')");
    }
}