<?php
namespace App\Models;
use App\Helpers\SendSms;
require '../config/env.php';

class Home extends DB
{
    private $db;
    function __construct() 
    {
        $this->db = new DB();
    }

    public function getHomePageDetails()
    {
        $homePageResponse = array();
        $itemImageData = array();

        # get most popular sliding image list
        $mostPopular = $this->queryAll('CALL getMostPopular');
        if(!empty($mostPopular))
        {
            foreach ($mostPopular as $key => $data) {
                $imageName = $_ENV['MOST_POPULAR'].$data->file_name;
                $homePageResponse['most_popular'][$key]['fileName'] = $imageName;
                $homePageResponse['most_popular'][$key]['sort_order'] = $data->sort_order;
            }
        }

        # get item image status and list
        $itemImageStatus = $this->query('CALL getItemImageStatus');
        if($itemImageStatus->status == 1) {
            $itemImagesList = $this->query('CALL getItemImage');
            if(!empty($itemImagesList))
            {
                $imageName = $_ENV['HOME_PAGE_BANNER'].$itemImagesList->file_name;
                $itemImagesList->file_name = $imageName;
            }
            $itemImageData= $itemImagesList;
        } else {
            $itemImageData = "";
        }
        
        $homePageResponse['item_image'] = $itemImageData;

        # get banner settings
        $bannerSetting = $this->query('CALL getBannerSetting');
        $bannerSetting = json_decode(json_encode($bannerSetting), true);
        if(!empty($bannerSetting['temp_3_item_image'])) {
            $bannerSetting['temp_3_item_image'] = $_ENV['HOME_PAGE_BANNER'].$bannerSetting['temp_3_item_image'];
        }
        $homePageResponse["banner_setting"] = $bannerSetting;

        # get background image and colors list
        if($bannerSetting['active_type'] == "1") {
            $bannerType = "2";
            $homePageResponse['banner_list'] = $this->query("CALL getBannerList($bannerType)");
            $homePageResponse = json_decode(json_encode($homePageResponse), true);
            if($homePageResponse['banner_list'] && $homePageResponse['banner_list']['file_name'] != "")
            $homePageResponse['banner_list']['file_name'] = $_ENV['HOME_PAGE_BANNER'].$homePageResponse['banner_list']['file_name'];
        } else if($bannerSetting['active_type'] == "2") {
            $bannerType = "1";
            $homePageResponse['banner_list'] = $this->query("CALL getBannerList($bannerType)");
            $homePageResponse = json_decode(json_encode($homePageResponse), true);
            if($homePageResponse['banner_list'] && $homePageResponse['banner_list']['file_name'] != "")
            $homePageResponse['banner_list']['file_name'] = $_ENV['HOME_PAGE_BANNER'].$homePageResponse['banner_list']['file_name'];
        } else {
            $homePageResponse['banner_list'] = "";
        }
        
        # get fk feedback
        $homePageResponse['feedback'] = $this->queryAll("CALL getFeedback");
        $fkappbanner = $this->queryAll("CALL getfkappbaner()");
        $img = [];
        foreach ($fkappbanner as $banner) {  // Use $banner instead of $img
            $img[] = [
                'img' =>"https://fusionbucket.co.uk/FKappbanner/". $banner->fk_Image
            ];
        }
        $homePageResponse['fk_app_banner'] = $img;
        return $homePageResponse;

    }

    public function sendAppDownloadLink($phoneNumber,$message)
    {
        $sms = new SendSms();
        $response = $sms->sendSms($phoneNumber,$message);
        return $response;
    }

    public function getBrID($clientdomanorid,$type)
    {
        if($type == 'domain'){
            $getDomain = $this->query("SELECT id from tbl_bridge where domain = '$clientdomanorid'");
        }else{
            $getDomain = $this->query("SELECT  tbl_bridge.id, tbl_domain.client_id,tbl_domain.url AS domain FROM tbl_domain INNER JOIN tbl_bridge ON tbl_domain.url = tbl_bridge.domain WHERE tbl_domain.client_id = '$clientdomanorid'");
        }
      

        return $getDomain->id;
    }
}