<?php
namespace App\Models;
use Stripe\Stripe;
use Stripe\Exception\ApiErrorException;

class Klarna extends DB
{
    public function createKlarna($getStripeConnection, $totalAmountString, $connectId, $clientTransferAmountString, $description, $currency_code = 'gbp')
    {
        Stripe::setApiKey($getStripeConnection);
        try 
        {
            $paymentIntent = \Stripe\PaymentIntent::create([
                'payment_method_types' => ['klarna'],
                'amount' => $totalAmountString,
                'currency' => $currency_code,
                'confirmation_method' => 'automatic',
                'capture_method' => 'automatic',
                'description' => $description,
                'transfer_data' => [
                    "amount" => $clientTransferAmountString,
                    'destination' => $connectId,
                ],
                // "on_behalf_of" => $connectId,
            ]);

            return $paymentIntent; 
        } 
        catch (ApiErrorException $e) 
        {
            # Handle any errors from the Stripe API
            return $e->getMessage();
        }
    }

    
}