<?php

namespace App\Models;

use App\Models\RestaurantPage;

use App\Controllers\PostcodeController;
use App\Controllers\PagesController;
use App\Controllers\MenuController;
use App\Controllers\MyAccountController;
use Stripe\Exception\ApiErrorException;
use Stripe\Stripe;
use App\Models\DB;
use App\Models\Menu;

require '../config/env.php';

class MenuPage extends Client
{
    protected $client_id;
   
    public function __construct($client_id)
    {
        parent::__construct($client_id);
        $this->client_id = $client_id;
    }

    public function getRestaurantDetails($postCode, $orderMode, $customerId, $orderTime,$clientPath,$getClientId)
    {
        
        $current_time = time();
        if ($postCode != "") {
            $googleApi = new PostcodeController();
            $getPostCodeDetail = $googleApi->getPostCodeDetail($postCode);
            $getPostCodeDetail = json_decode($getPostCodeDetail);
            if (!empty($getPostCodeDetail)) {
                if ($getPostCodeDetail->status) {
                    $latitude = $getPostCodeDetail->latitude;
                    $longitude = $getPostCodeDetail->longitude;
                } else {
                    $latitude = 0;
                    $longitude = 0;
                }
            } else {
                $latitude = 0;
                $longitude = 0;
            }
        } else {
            $latitude = 0;
            $longitude = 0;
        }
        // try 
        // {
            $menuData = array();
            $restaurantPage = new RestaurantPage();
            $Menu=new Menu();
    
    
           
            $DB=new DB();
            $client = $DB->query("call getB2cClientData($latitude,$longitude,$this->client_id)");
     
          
            $getFeedbackCollectionMinStuart=$this->queryCombine("CALL `getFeedbackCollectionMinStuart`()");
        
            $getFeedbackRate = $getFeedbackCollectionMinStuart[0];
            $getCookingTime = $this->getCookingTime($getFeedbackCollectionMinStuart[1]);
            
            $getTatStartEnd = $this->getTatStartEnd($getFeedbackCollectionMinStuart[1]);
            $getMin = $getFeedbackCollectionMinStuart[2];
            $getStuartStatus = $getFeedbackCollectionMinStuart[3];
    
            $menuData['clientId'] = $this->client_id;
            $menuData['clientPath'] = $clientPath;
            $menuData['restaurantName'] = $getClientId->takeaway_name;
           
            $shiftTimes = $this->getShiftTime($getClientId->id);
    
            $menuData['deliveryShiftTime'] = [
                'openAt' => isset($shiftTimes[0]->delivery_openat) ? $shiftTimes[0]->delivery_openat : 0,
                'closeAt' => isset($shiftTimes[0]->delivery_closeat) ? $shiftTimes[0]->delivery_closeat : 0,
            ];
    
            $menuData['collectionShiftTime'] = [
                'openAt' => isset($shiftTimes[0]->collection_openat) ? $shiftTimes[0]->collection_openat : 0,
                'closeAt' => isset($shiftTimes[0]->collection_closeat) ? $shiftTimes[0]->collection_closeat : 0,
            ];
    
            # get logo image 
            $menuData['logo'] = $client->logo
                ? $_ENV['FUSION_BUCKET'] . $client->logo
                : $_ENV['FUSION_BUCKET'] . "takeaway1.jpg";
    
            # get background image 
            $menuData['backgroundImage'] = $client->bg_image
                ? $_ENV['FUSION_BUCKET'] . $client->bg_image
                : $_ENV['FUSION_BUCKET'] . "takeaway1.jpg";
    
            # get favourite list
            $menuData['favourite'] = $customerId ? (($restaurantPage->getFavouriteById($customerId, $getClientId->id)) ? true : false) : false;
    
            # get miles and rating
            $menuData['miles'] = number_format($client->distance, 2) . ' Miles away';
            $menuData['rating'] = $getFeedbackRate;
    
            # get minimum order and tat time
            if ($orderMode == 0) {
                if ($getStuartStatus && $getStuartStatus->status == "1") {
                    if (floatval($getMin->stuart_delivery_min) >= floatval($getMin->delivery_min)) {
                        $menuData['minOrder'] = $getMin->stuart_delivery_min;
                    } else {
                        $menuData['minOrder'] = $getMin->delivery_min;
                    }
                    $menuData['stuart'] = true;
                } else {
                    $menuData['minOrder'] = $getMin->delivery_min;
                    $menuData['stuart'] = false;
                }
            } elseif ($orderMode == 1) {
                $menuData['minOrder'] = $getMin->collection_min;
                $menuData['stuart'] = false;
            }
    
            # get new minimum order and tat time
            if ($getStuartStatus && $getStuartStatus->status == "1") {
                if (floatval($getMin->stuart_delivery_min) >= floatval($getMin->delivery_min)) {
                    $menuData['newMinOrder']['deliveryMinOrder'] = $getMin->stuart_delivery_min;
                } else {
                    $menuData['newMinOrder']['deliveryMinOrder'] = $getMin->delivery_min;
                }
                $menuData['newStuart']['deliveryStuart'] = true;
            } else {
                $menuData['newMinOrder']['deliveryMinOrder'] = $getMin->delivery_min;
                $menuData['newStuart']['deliveryStuart'] = false;
            }
    
            $menuData['newMinOrder']['collectionMinOrder'] = $getMin->collection_min;
            $menuData['newStuart']['collectionStuart'] = false;
    
            $menuData['deliveryCookingTimeStart'] = $getTatStartEnd["deliveryCookingTimeStart"];
            $menuData['deliveryCookingTimeEnd'] = $getTatStartEnd["deliveryCookingTimeEnd"];
            $menuData['collectionCookingTimeStart'] = $getTatStartEnd["collectionCookingTimeStart"];
            $menuData['collectionCookingTimeEnd'] = $getTatStartEnd["collectionCookingTimeEnd"];
    
            # Check restaurant open close status functionalities
            $openCloseCollectionStatus = $restaurantPage->restaurantOpenCloseStatusOptimize($getClientId->id, $current_time, "1");
            $menuData['restaurantStatus']['Collection'] = $openCloseCollectionStatus;
            $openCloseDeliveryStatus = $restaurantPage->restaurantOpenCloseStatusOptimize($getClientId->id, $current_time, "0");
            $menuData['restaurantStatus']['Delivery'] = $openCloseDeliveryStatus;
            
            # get discount 
            //$menuData['discount'] = $this->getOfferDetails($getClientId->id, $orderMode, $orderTime, $customerId, $clientPath, false);
            
            $deliveryDiscount_arr= $this->getOfferDetails($getClientId->id, 0, $orderTime, $customerId, $clientPath, true);
            $collectionDiscount_arr = $this->getOfferDetails($getClientId->id, 1, $orderTime, $customerId, $clientPath, true);
            $menuData['discount']=$deliveryDiscount_arr;
            if($orderMode=="1" || $orderMode==1)
            {
                $menuData['discount']=$collectionDiscount_arr;
            }
            $menuData['deliveryDiscount'] = $deliveryDiscount_arr;
            $menuData['collectionDiscount'] = $collectionDiscount_arr;
            # get cuisine list
            $cuisines = explode(",", $client->cuisine);
            $menuData['cuisine'] = array();
           
            //$getAllCuisineImage=$DB->queryAll("CALL getAllCuisineImage()");
            $getAllCuisineImage=$DB->queryAll("SELECT id,cuisine_name, cuisine_image FROM `tbl_cuisines`;");
            $getAllCuisinesArr=array();
            if(count($getAllCuisineImage)>0)
            {
                foreach ($getAllCuisineImage as $key => $value) {
                    if (in_array($value->id, $cuisines)) {
                        $getAllCuisinesArr[$value->id]=[
                            'name'=>$value->cuisine_name,
                            'image'=>$value->cuisine_image
                           ];
                    } 
                  
                }
            }
            $orderedCuisines = [];
            foreach ($cuisines as $id) {
                if (isset($getAllCuisinesArr[$id])) {
                    $orderedCuisines[] = $getAllCuisinesArr[$id];
                }
            }
            
            if(count($orderedCuisines)>0)
            {
                foreach ($orderedCuisines as $key => $cuisine) 
                {
                    
                    $menuData['cuisine'][$key]['name'] = str_replace("Â", "", $cuisine['name']);
                    $menuData['cuisine'][$key]['image'] = $cuisine['image'];
                }
            }
           
           
           
    
            $menuData['timing']['Delivery'] = $this->getPreOrderTiming("0", $client->client_id,$getCookingTime,$menuData['restaurantStatus']['Delivery']);
            $menuData['timing']['Collection'] = $this->getPreOrderTiming("1", $client->client_id,$getCookingTime,$menuData['restaurantStatus']['Collection']);
    
            return $menuData;
        // } 
        // // catch (\PDOException $e) 
        // {
        //     print_r($e);
        //     $statusCode = $e->getCode() ?: 500;
        //     $errorMessage =  $e->getMessage() . 'An error occurred.';
        //     $response = new \Slim\Psr7\Response();
        //     $response->getBody()->write("Errorin: " . $errorMessage);
        //     return $response->withStatus($statusCode);
        // } 
        // catch (\Exception $e) 
        // {
        //     $statusCode = $e->getCode() ?: 500;
        //     $errorMessage =  $e->getMessage() . 'An error occurred.';
        //     $response = new \Slim\Psr7\Response();
        //     $response->getBody()->write("Errorinss: " . $errorMessage);
        //     return $response->withStatus($statusCode);
        // }
       
    } 

    public function getPreOrderTiming($orderMode, $clientId,$getCookingTime,$openCloseStatus)
    {
        
        date_default_timezone_set('Europe/London');
        $currentTime = time();
        // $currentTime = strtotime("2024-10-22 11:55");
        $getBusinessTime = array();

        # get mode of order, tat time enable status and cooking time
        $getMode = $this->getMode();
        $getTatEnableStatus = $this->getTatEnableStatus();
        $tatStatus = $getTatEnableStatus->tat_enable;
     

        if($orderMode == 0) {
            $type = "delivery";
        } elseif($orderMode == 1) {
            $type = "collection";
        }

        # check the preorder enable or not & working on 8 to 8 concept
        if ($getMode->preorder_sts == 1) {
            $pre = "1"; 

            # Get the current hour and minute
            $currentHour = date('H', $currentTime);
            $currentMinute = date('i', $currentTime);

            # Check if the current time is between 00:00 and 07:55
            if (($currentHour == '00' && $currentMinute >= '00') || ($currentHour < '08' && $currentMinute <= '55')) {
                # Call getBusinessTime
                $getBusinessTime['today'] = $this->getBusinessTime($currentTime, $getMode->mode, $clientId, $orderMode, $pre, $tatStatus, $getCookingTime);
            } else {
                # Call getBusinessTimeLater
                $getBusinessTime['today'] = $this->getBusinessTimeLater($currentTime, $getMode->mode, $clientId, $orderMode, $pre, $tatStatus, $getCookingTime);
            }
        } else {
            $getBusinessTime['today'] = "No Pre-order";
        }


     
        if($openCloseStatus['status'] == "0") {
            $getCookingTime[$type] = ($getCookingTime[$type] == "") ? "0" : $getCookingTime[$type];
            $endTatTime = intval($getCookingTime[$type])+intval(10);
            $getBusinessTime['asap'] = array(
                'tatTime' => $getCookingTime[$type] .' - '. $endTatTime,
                'time' => date('Y-m-d H:i', $currentTime),
            );
        } else {
            $getBusinessTime['asap'] = "";
        }
        
        # check the preorder later enable or not & working on 12 to 12 concept
        $emptyPreOrder = "";
        if($getMode->preorder_sts != 0 && $getMode->preorderenable != 0) {
            $preorderLaterStatus = "+".$getMode->preorder_later_status."day";
            $tomorrow = strtotime(date('d-m-Y',(strtotime ( '+1 day' , $currentTime))));
            $endDate = strtotime(date('d-m-Y',(strtotime ($preorderLaterStatus , $tomorrow))));
            $shiftDate = strtotime(date('d-m-Y', $tomorrow)." "."08:00");
            while($shiftDate < $endDate) {
                $pre = "2"; 
                $getBusinessTime['later'][date('Y-m-d', $shiftDate)] = $this->getBusinessTimeLater($shiftDate, $getMode->mode, $clientId, $orderMode, $pre, $tatStatus, $getCookingTime);
                if($getBusinessTime['later'][date('Y-m-d', $shiftDate)] != "") {
                    $emptyPreOrder = "1";
                }
                $shiftDate = strtotime('+1 day', $shiftDate);
            }
            $preorderClosedData = 1;
            foreach($getBusinessTime['later'] as $key => $data) {
                if($data == "" || $data == "Shift closed") {
                    $preorderClosedData += 1;
                }
            }
            if($getMode->preorder_later_status < $preorderClosedData) {
                $getBusinessTime['later'] = "";
            }
            if($emptyPreOrder == "") {
                $getBusinessTime['later'] = ""; 
            }
        } else {
            $getBusinessTime['later'] = "";
        }

        return $getBusinessTime;
    }
   
    public function getTatEnableStatus()
    {
      
        $tat = $this->query("call getTatEnableStatus()");
      
        return $tat;
    }
    public function getCookingTime($cooking_time)
    {
        $record = array();
       

        if ($cooking_time->collection || $cooking_time->delivery) {
            $record['delivery'] = $cooking_time->delivery;
            $record['collection'] = $cooking_time->collection;
        } else {
            $day = date('w');
            if ($day == 0) {
                $col_cooking = "collection7";
                $del_cooking = "delivery7";
            } else {
                $col_cooking = "collection" . $day;
                $del_cooking = "delivery" . $day;
            }
            $record['collection'] = $cooking_time->$col_cooking;
            $record['delivery'] = $cooking_time->$del_cooking;
        }

        // $stuart = $this->getStuartStatus($clientId);
        // if($stuart->status == 1) {
        //     if($cooking_time->stuart_time)
        //         $record['stuart_time'] = $cooking_time->stuart_time;
        //     else
        //         $record['stuart_time'] = "20";

        //     $record['extraPrepTime'] = $cooking_time->extraPrepTime;
        // }

        return $record;
    }

    public function getTatStartEnd($cooking_time)
    {
        $cooking = $this->getCookingTime($cooking_time);
        $default = 10;

        $record['deliveryCookingTimeStart'] = intval($cooking["delivery"]);
        $record['deliveryCookingTimeEnd'] = intval($cooking["delivery"]) + $default;
        $record['collectionCookingTimeStart'] = intval($cooking["collection"]);
        $record['collectionCookingTimeEnd'] = intval($cooking["collection"]) + $default;

        return $record;
    }

    public function getShiftTime($clientId, $time = "")
    {
        if ($time == "")
            $day = date('N');
        else
            $day = date('N', $time);

        # 1 - mon, 2 - tues ,3 - wed, 4 - thur, 5 - fri, 6 - sat, 7 - sun
      
        return $this->queryAll("call getShift($day)");
    }

    public function getMode()
    {
    
        $mode = $this->query("call getOrderMode()");
      
        return $mode;
    }

    function checkOpenStatus($clientId, $orderTime)
    {
        $openStatus = "";
        $getHolidayandBankHoliday=$this->queryAllCombine("CALL getHolidayandBankHoliday()");
       
        $getHoliday=$getHolidayandBankHoliday[0];
        $getBankHoliday=$getHolidayandBankHoliday[1];
        $getActiveOpenClose = $this->getOpenClose($clientId, $orderTime);
        $getActiveHoliday = $this->getHoliday($clientId, $orderTime,$getHoliday);
        $getActiveBankHoliday = $this->getBankHoliday($clientId, $orderTime,$getBankHoliday);

        if (count($getActiveOpenClose) != 0) {
            $openStatus = $getActiveOpenClose['openTime'];
        } elseif (count($getActiveHoliday) != 0) {
            $openStatus = $getActiveHoliday['message'];
        } elseif (count($getActiveBankHoliday) != 0) {
            $openStatus = $getActiveBankHoliday['message'];
        }
        return $openStatus;
    }

    public function getOpenClose($clientId, $orderTime)
    {
      
        $openTime = array();
        $open = $this->query("call getOpenClose()");
      
        if ($open == true) {
            if ($open->opentime > $orderTime) {
                $openTime['message'] = $open->info;
                $openTime['status'] = "0";
                $openTime['openTime'] = $open->opentime;
            }
        }
        return $openTime;
    }
    public function getHoliday($clientId, $orderTime,$holidayDatas)
    {
        $holidayResponse = array();
        if ($holidayDatas == true) {
            $hours = date('H', $orderTime);
            if ($hours >= 8) {
                $orderDate = $orderTime;
            } else {
                $orderDate = strtotime(date('m/d/Y', strtotime('-1 day', $orderTime)));
            }
            foreach ($holidayDatas as $holidayData) {
                $holidayDate = date('Y-m-d', $holidayData->date);
                $currentDate = date('Y-m-d', $orderDate);
                if ($currentDate == $holidayDate) {
                    $holidayResponse['message'] = $holidayData->desc;
                    $holidayResponse['status'] = "0";
                }
            }
        }
        return $holidayResponse;
    }

    public function getBankHoliday($clientId, $orderTime,$bankHolidayDatas)
    {
        $bankHolidayResponse = array();
        if ($bankHolidayDatas == true) {
            $hours = date('H', $orderTime);
            if ($hours >= 8) {
                $orderDate = $orderTime;
            } else {
                $orderDate = strtotime(date('m/d/Y', (strtotime('-1 day', $orderTime))));
            }
            foreach ($bankHolidayDatas as $bankHolidayData) {
                $holidayDate = date('Y-m-d', $bankHolidayData->date);
                $currentDate = date('Y-m-d', $orderDate);
                if ($currentDate == $holidayDate) {
                    $bankHolidayResponse['message'] = $bankHolidayData->desc;
                    $bankHolidayResponse['status'] = "0";
                }
            }
        }
        return $bankHolidayResponse;
    }
    
    public function getAutoDiscount($zeroBasedDay, $orderMode)
    {
        
        $getAutoDiscount = $this->queryAll("call getAutoDiscount($zeroBasedDay, $orderMode)");
        
        return $getAutoDiscount;
    }

    public function getOfferDetails($clientId, $orderMode, $orderTime, $customerId, $clientPath, bool $only = false)
    {
        $Menu=new Menu();
        $isPromoAvailable = false;
        $myaccount = new Myaccount();
        if ($customerId != "") {
            $getLastOrder = $myaccount->getLastOrder($customerId, $clientId, $clientPath);
            if ($getLastOrder == false) {
                $isPromoAvailable = true;
            }
        }

        $zeroBasedDay = date('w', $orderTime);

        if ($only) {
            $getOnlineDiscount = $Menu->getOnlineDiscountByOrderMode($clientId, $zeroBasedDay, $orderMode);
            $getAutoDiscount = $this->getAutoDiscount( $zeroBasedDay, $orderMode);
            $getCommonDiscount = $Menu->getCommonDiscountByOrderMode($zeroBasedDay, $orderMode);
            $getPromoDetail = $Menu->getPromoDetailByOrderMode($clientId, $orderMode);
        } else {
            $getPromoDetail = $Menu->getPromoDetail($clientId);
            $getCommonDiscount = $Menu->getCommonDiscount($zeroBasedDay);
            $collection = $this->getAutoDiscount($zeroBasedDay, 1);
            $delivery = $this->getAutoDiscount( $zeroBasedDay, 0);
            $getAutoDiscount = array_merge($collection, $delivery);
            $getOnlineDiscount = $Menu->getOnlineDiscount($clientId, $zeroBasedDay);
        }
        $DB=new DB();
        $getOfferList = $DB->query("CALL getOfferBanner($clientId)");

        $data = array();

        $checkSessionalOffer = $Menu->checkSessionalOfferCustomer($customerId);
        $getSessionalOffer = $Menu->getSessionalDetail($clientId);

        $getOnlinSeasonalDiscount = $Menu->getOnlinSeasonalDiscount($clientId);
        $orderModeCode =  ($orderMode == 0) ? "Delivery" : "Collection";
        if ($getSessionalOffer != false && $checkSessionalOffer && $getOnlinSeasonalDiscount != false && ($getSessionalOffer[0]->order_type_id == $orderMode || $getSessionalOffer[0]->order_type_id == 2)) {
            if ($getSessionalOffer != false && $checkSessionalOffer->result) {
                if ($customerId != "" && $isPromoAvailable != false) {
                    foreach ($getSessionalOffer as $key => $list) {
                        $data["promo"][$key]["code"] = $list->promo_code;
                        $data["promo"][$key]["description"] = $list->description;

                        $data["promo"][$key]["terms1"] = "Coupon code applicable only on orders above £" . $list->min_amount . ".";
                        $data["promo"][$key]["terms2"] = "Offer is valid only for this particular takeaway/restaurant.";
                        $data["promo"][$key]["terms3"] = "No maximum limit to apply the coupon code.";
                        $data["promo"][$key]["terms4"] = "";
                        $data["promo"][$key]["terms5"] = "This coupon code is applicable only for " . $orderModeCode . " orders.";

                        $data["promo"][$key]["discount"] = $list->discount;
                        $data["promo"][$key]["discountType"] = ($list->promotion_amount_type == 0) ? "%" : "£";
                        $data["promo"][$key]["orderType"] = $list->order_type_id;
                        $data["promo"][$key]["sessionalOffer"] = 1;
                        $data["promo"][$key]["minOrder"] = $list->min_amount;
                    }
                } else {
                    $data["promo"] = array();
                }

                $data["seasonal_online"][0]["code"] = $getOnlinSeasonalDiscount->discount_code;
                $data["seasonal_online"][0]["description"] = $getOnlinSeasonalDiscount->description;

                $data["seasonal_online"][0]["terms1"] = "Coupon code applicable only on orders above £" . $getOnlinSeasonalDiscount->min_order_value . ".";
                $data["seasonal_online"][0]["terms2"] = "Offer is valid only for this particular takeaway/restaurant.";
                $data["seasonal_online"][0]["terms3"] = "No maximum limit to apply the coupon code.";
                $data["seasonal_online"][0]["terms4"] = "Offer valid only till " . date('d/m/Y h:i A', $getOnlinSeasonalDiscount->to_validity) . ".";
                $data["seasonal_online"][0]["terms5"] = "This coupon code is applicable only for " . $orderModeCode . " orders.";

                $data["seasonal_online"][0]["discount"] = $getOnlinSeasonalDiscount->discount_amount;
                $data["seasonal_online"][0]["discountType"] = ($getOnlinSeasonalDiscount->discount_amount_type == 0) ? "%" : "£";
                $data["seasonal_online"][0]["orderType"] = $getOnlinSeasonalDiscount->order_type_id;
                $data["seasonal_online"][0]["paymentType"] = $getOnlinSeasonalDiscount->payment_type_id;
                $data["seasonal_online"][0]["minOrder"] = $getOnlinSeasonalDiscount->min_order_value;
                $data["seasonal_online"][0]["from"] = date("d/m/Y h:i A", $getOnlinSeasonalDiscount->from_validity);
                $data["seasonal_online"][0]["to"] = date("d/m/Y h:i A", $getOnlinSeasonalDiscount->to_validity);

                $data["online"] = array();
                $data["common"] = array();
                $data["autoDiscount"] = array();
                return $data;
            }
        } else if ($getSessionalOffer != false && !$checkSessionalOffer && $getOnlinSeasonalDiscount != false && ($getSessionalOffer[0]->order_type_id == $orderMode || $getSessionalOffer[0]->order_type_id == 2)) {
            if ($customerId != "" && $isPromoAvailable != false) {
                foreach ($getSessionalOffer as $key => $list) {
                    $data["promo"][$key]["code"] = $list->promo_code;
                    $data["promo"][$key]["description"] = $list->description;

                    $data["promo"][$key]["terms1"] = "Coupon code applicable only on orders above £" . $list->min_amount . ".";
                    $data["promo"][$key]["terms2"] = "Offer is valid only for this particular takeaway/restaurant.";
                    $data["promo"][$key]["terms3"] = "No maximum limit to apply the coupon code.";
                    $data["promo"][$key]["terms4"] = "";
                    $data["promo"][$key]["terms5"] = "This coupon code is applicable only for " . $orderModeCode . " orders.";

                    $data["promo"][$key]["discount"] = $list->discount;
                    $data["promo"][$key]["discountType"] = ($list->promotion_amount_type == 0) ? "%" : "£";
                    $data["promo"][$key]["orderType"] = $list->order_type_id;
                    $data["promo"][$key]["sessionalOffer"] = 1;
                    $data["promo"][$key]["minOrder"] = $list->min_amount;
                }
            } else {
                $data["promo"] = array();
            }
            $data["seasonal_online"][0]["code"] = $getOnlinSeasonalDiscount->discount_code;
            $data["seasonal_online"][0]["description"] = $getOnlinSeasonalDiscount->description;

            $data["seasonal_online"][0]["terms1"] = "Coupon code applicable only on orders above £" . $getOnlinSeasonalDiscount->min_order_value . ".";
            $data["seasonal_online"][0]["terms2"] = "Offer is valid only for this particular takeaway/restaurant.";
            $data["seasonal_online"][0]["terms3"] = "No maximum limit to apply the coupon code.";
            $data["seasonal_online"][0]["terms4"] = "Offer valid only till " . date('d/m/Y h:i A', $getOnlinSeasonalDiscount->to_validity) . ".";
            $data["seasonal_online"][0]["terms5"] = "This coupon code is applicable only for " . $orderModeCode . " orders.";

            $data["seasonal_online"][0]["discount"] = $getOnlinSeasonalDiscount->discount_amount;
            $data["seasonal_online"][0]["discountType"] = ($getOnlinSeasonalDiscount->discount_amount_type == 0) ? "%" : "£";
            $data["seasonal_online"][0]["orderType"] = $getOnlinSeasonalDiscount->order_type_id;
            $data["seasonal_online"][0]["paymentType"] = $getOnlinSeasonalDiscount->payment_type_id;
            $data["seasonal_online"][0]["minOrder"] = $getOnlinSeasonalDiscount->min_order_value;
            $data["seasonal_online"][0]["from"] = date("d/m/Y h:i A", $getOnlinSeasonalDiscount->from_validity);
            $data["seasonal_online"][0]["to"] = date("d/m/Y h:i A", $getOnlinSeasonalDiscount->to_validity);

            $data["online"] = array();
            $data["common"] = array();
            $data["autoDiscount"] = array();
            return $data;
        } else {
            if ($customerId != "" && $isPromoAvailable != false) {
                if ($getPromoDetail != false) {
                    foreach ($getPromoDetail as $key => $list) {
                        $data["promo"][$key]["code"] = $list->promo_code;
                        $data["promo"][$key]["description"] = $list->description;

                        $data["promo"][$key]["terms1"] = "";
                        $data["promo"][$key]["terms2"] = "Offer is valid only for this particular takeaway/restaurant.";
                        $data["promo"][$key]["terms3"] = "No maximum limit to apply the coupon code.";
                        $data["promo"][$key]["terms4"] = "";
                        $data["promo"][$key]["terms5"] = "This coupon code is applicable only for " . $orderModeCode . " orders.";

                        $data["promo"][$key]["discount"] = $list->discount;
                        $data["promo"][$key]["discountType"] = ($list->promotion_amount_type == 0) ? "%" : "£";
                        $data["promo"][$key]["orderType"] = $list->order_type_id;
                        $data["promo"][$key]["sessionalOffer"] = 0;
                    }
                } else {
                    $data["promo"] = array();
                }
            } else {
                $data["promo"] = array();
            }
            $data["seasonal_online"] = array();

            if ($getOnlineDiscount != false) {
                $onlineKey = 0;
                foreach ($getOnlineDiscount as $key => $list) {
                    if ($list->from_validity <= $orderTime && $orderTime <= $list->to_validity) {
                        $data["online"][$onlineKey]["code"] = $list->discount_code;
                        $data["online"][$onlineKey]["description"] = $list->description;

                        $data["online"][$onlineKey]["terms1"] = "Coupon code applicable only on orders above £" . $list->min_order_value . ".";
                        $data["online"][$onlineKey]["terms2"] = "Offer is valid only for this particular takeaway/restaurant.";
                        $data["online"][$onlineKey]["terms3"] = "No maximum limit to apply the coupon code.";
                        $data["online"][$onlineKey]["terms4"] = "Offer valid only till " . date('d/m/Y h:i A', $list->to_validity) . ".";
                        $data["online"][$onlineKey]["terms5"] = "This coupon code is applicable only for " . $orderModeCode . " orders.";

                        $data["online"][$onlineKey]["discount"] = $list->discount_amount;
                        $data["online"][$onlineKey]["discountType"] = ($list->discount_amount_type == 0) ? "%" : "£";
                        $data["online"][$onlineKey]["orderType"] = $list->order_type_id;
                        $data["online"][$onlineKey]["paymentType"] = $list->payment_type_id;
                        $data["online"][$onlineKey]["minOrder"] = $list->min_order_value;
                        $data["online"][$onlineKey]["from"] = date("d/m/Y h:i A", $list->from_validity);
                        $data["online"][$onlineKey]["to"] = date("d/m/Y h:i A", $list->to_validity);
                        $onlineKey++;
                    } else {
                        $data["online"] = array();
                    }
                }
                if ($getCommonDiscount != false) {
                    $commonKey = 0;
                    foreach ($getCommonDiscount as $key => $list) {
                        if ($list->from_validity <= $orderTime && $orderTime <= $list->to_validity) {
                            $data["common"][$commonKey]["code"] = str_replace("Â", "", $list->discount_code);
                            if ($list->discount_amount_type == 0) {
                                $data["common"][$commonKey]["description"] = "UPTO " . number_format($list->discount, 0) . "% exclusive offer";
                            } else {
                                $data["common"][$commonKey]["description"] = "UPTO £" . number_format($list->discount, 0) . " exclusive offer";
                            }

                            $data["common"][$commonKey]["terms1"] = "Coupon code applicable only on orders above £" . $list->min_order_value . ".";
                            $data["common"][$commonKey]["terms2"] = "Offer is valid only for this particular takeaway/restaurant.";
                            $data["common"][$commonKey]["terms3"] = "No maximum limit to apply the coupon code.";
                            $data["common"][$commonKey]["terms4"] = "Offer valid only till " . date('d/m/Y h:i A', $list->to_validity) . ".";
                            $data["common"][$commonKey]["terms5"] = "This coupon code is applicable only for " . $orderModeCode . " orders.";

                            $data["common"][$commonKey]["discount"] = $list->discount;
                            $data["common"][$commonKey]["discountType"] = ($list->discount_amount_type == 0) ? "%" : "£";
                            $data["common"][$commonKey]["orderType"] = $list->order_type_id;
                            $data["common"][$commonKey]["paymentType"] = $list->payment_type_id;
                            $data["common"][$commonKey]["minOrder"] = $list->min_order_value;
                            $data["common"][$commonKey]["from"] = date("d/m/Y h:i A", $list->from_validity);
                            $data["common"][$commonKey]["to"] = date("d/m/Y h:i A", $list->to_validity);
                            $commonKey++;
                        } else {
                            $data["common"] = array();
                        }
                    }
                } else {
                    $data["common"] = array();
                }
            } else {
                $data["online"] = array();
                $data["common"] = array();
            }

            if ($getOfferList && $getOfferList->noCode == 1) {
                if ($getAutoDiscount != false) {
                    $offlineKey = 0;
                    foreach ($getAutoDiscount as $key => $list) {
                        if ($list->discountFROM <= $orderTime && $orderTime <= $list->discountTo) {
                            $data["autoDiscount"][$offlineKey]["code"] = $list->discount_code;
                            $data["autoDiscount"][$offlineKey]["description"] = $list->description;

                            $data["autoDiscount"][$offlineKey]["terms1"] = "Coupon code applicable only on orders above £" . $list->minAmount . ".";
                            $data["autoDiscount"][$offlineKey]["terms2"] = "Offer is valid only for this particular takeaway/restaurant.";
                            $data["autoDiscount"][$offlineKey]["terms3"] = "No maximum limit to apply the coupon code.";
                            $data["autoDiscount"][$offlineKey]["terms4"] = "Offer valid only till " . date('d/m/Y h:i A', $list->discountTo) . ".";
                            $data["autoDiscount"][$offlineKey]["terms5"] = "This coupon code is applicable only for " . $orderModeCode . " orders.";

                            $data["autoDiscount"][$offlineKey]["discount"] = $list->discount;
                            $data["autoDiscount"][$offlineKey]["discountType"] = ($list->dType == "%") ? "%" : "£";
                            if ($list->discount_code == "Online Collection") {
                                $data["autoDiscount"][$offlineKey]["orderType"] = 1;
                            } else if ($list->discount_code == "Online Delivery") {
                                $data["autoDiscount"][$offlineKey]["orderType"] = 0;
                            }
                            $data["autoDiscount"][$offlineKey]["paymentType"] = $list->pType;
                            $data["autoDiscount"][$offlineKey]["minOrder"] = $list->minAmount;
                            $data["autoDiscount"][$offlineKey]["from"] = date("d/m/Y h:i A", $list->discountFROM);
                            $data["autoDiscount"][$offlineKey]["to"] = date("d/m/Y h:i A", $list->discountTo);
                            $offlineKey++;
                        } else {
                            $data["autoDiscount"] = array();
                        }
                    }
                } else {
                    $data["autoDiscount"] = array();
                }
            } else {
                $data["autoDiscount"] = array();
            }

            return $data;
        }
    }

    public function getBusinessTime($currentTime, $getMode, $clientId, $orderMode, $pre, $tatStatus, $getCookingTime )
    {
        $getOrderMode = str_split($getMode);
        
        if ($orderMode == 0) {
            $type1 = "delivery_openat";
            $type2 = "delivery_closeat";
            $type = "delivery";
        } elseif ($orderMode == 1) {
            $type1 = "collection_openat";
            $type2 = "collection_closeat";
            $type = "collection";
        }

        // Get the current date based on current time
        $currentDate = strtotime(date('d-m-Y', $currentTime));

        // Retrieve today's shift times
        $getCurrentShiftTime = $this->getShiftTime($clientId, $currentDate);

        // Retrieve previous day's shift times if needed (before 8 AM)
        $getPreviousShiftTime = [];
        if (date('H', $currentTime) < 8) {
            $previousDate = strtotime('-1 day', $currentDate);
            $getPreviousShiftTime = $this->getShiftTime($clientId, $previousDate);

            // Check if previous day contains shift data after 11:55 PM
            foreach ($getPreviousShiftTime as $shift) {
                if ($shift->$type == 1) {
                    $time_1 = $shift->$type1;
                    $time_2 = $shift->$type2;

                    if ($time_1 != "" && $time_2 != "") {
                        $startTimestamp = strtotime($time_1);
                        $endTimestamp = strtotime($time_2);

                        // Check if the previous day shift ends after 11:55 PM
                        if ($startTimestamp < strtotime('23:55') && $endTimestamp > strtotime('23:55')) {
                            // Allow the start date to be 11:55 PM of the previous day
                            $previousDayStartTime = strtotime(date('d-m-Y', $previousDate) . " 23:55");

                            // If current time is within the previous day's shift range, adjust the start time
                            if ($currentTime >= $previousDayStartTime && $currentTime < $endTimestamp) {
                                $currentTime = $previousDayStartTime;
                            }
                        }
                    }
                }
            }
        }

        // Combine today's and previous day's shifts
        $getShiftTime = array_merge($getPreviousShiftTime, $getCurrentShiftTime);

        // Adjust current time for cooking time if applicable
        if ($getCookingTime && isset($getCookingTime[$type]) && !empty($getCookingTime[$type])) {
            $currentTime += ($getCookingTime[$type] * 60);
        }

        $timing = "";
        $firstValidShift = true;

        if (count($getShiftTime) > 0) {
            foreach ($getShiftTime as $shift) {
                if ($shift->$type == 1) { // If the shift is active
                    $time_1 = $shift->$type1; // Open time
                    $time_2 = $shift->$type2; // Close time

                    if ($time_1 != "" && $time_2 != "") {
                        $startTimestamp = strtotime($time_1);
                        $endTimestamp = strtotime($time_2);

                        // Add cooking time if applicable
                        if (isset($getCookingTime[$type])) {
                            $cookingTimeInSeconds = $getCookingTime[$type] * 60;
                            $startTimestamp += $cookingTimeInSeconds;
                        }

                        // Handle shifts that span into the next day (e.g., 13:00 to 07:55)
                        if ($startTimestamp > $endTimestamp) {
                            $endDate = date('d-m-Y', strtotime('+1 day', $currentDate));
                        } else {
                            $endDate = date('d-m-Y', $currentDate);
                        }

                        $startDate = ($startTimestamp < strtotime('08:00')) ? date('d-m-Y', strtotime('-1 day', $currentDate)) : date('d-m-Y', $currentDate);

                        // Calculate the actual start and end times
                        $startTime = strtotime($startDate . " " . date('H:i', $startTimestamp));
                        $endTime = strtotime($endDate . " " . date('H:i', $endTimestamp));

                        // Skip shifts that have fully passed
                        if ($endTime < $currentTime) {
                            continue;
                        }

                        // Adjust the start time if the shift has already started
                        if ($startTime < $currentTime) {
                            $startTime = $currentTime;
                        }

                        $duration = $endTime - $startTime;

                        // Handle the first valid shift separately
                        // if ($firstValidShift) {
                        //     $timing = ""; // Clear the previous timing data
                        //     $firstValidShift = false; // Turn off the first valid shift flag
                        // }
                    
                    if (!$firstValidShift) {
                        // Generate time slots in 5-minute intervals
                        for ($i = 0; $i <= $duration; $i += 300) { // 300 seconds = 5 minutes
                            $intervalTime = $startTime + $i;
                            if ($pre == 0) {
                                $intervalTime = date('d-m-Y H:i', $intervalTime);
                            } else {
                                $intervalTime = date('H:i', $intervalTime);
                            }
                            $timing .= !empty($timing) ? ',' . $intervalTime : $intervalTime;
                        }

                    }
                    else{
                        $timing = ""; // Clear the previous timing data
                        $firstValidShift = false;
                    }
                    }
                }
            }
        }

        

        return $timing ?: "";
    }



    public function getBusinessTimeLater($currentTime, $getMode, $clientId, $orderMode, $pre, $tatStatus = "", $getCookingTime = "")
    {
        $getOrderMode = str_split($getMode);
        if ($orderMode == 0) {
            $type1 = "delivery_openat";
            $type2 = "delivery_closeat";
            $type = "delivery";
        } elseif ($orderMode == 1) {
            $type1 = "collection_openat";
            $type2 = "collection_closeat";
            $type = "collection";
        }

        # get current date
        $hours = date('H', $currentTime);
        $hourMinutes = date('H:i', $currentTime);

        // return date('d-m-Y H:i A',$currentTime);

        if ($pre == 1 || $pre == 0) {
            // $currentDate = strtotime(date('d-m-Y', $currentTime));
            // if($hours < 8) 
            // {
            //     $currentDate = strtotime(date('d-m-Y',(strtotime ( '0 day' , $currentTime))));
            // } 
            // $getShiftTime = $this->getShiftTime($clientId, $currentDate);

            if (intval($hours) < 8) {
                $currentDate = strtotime(date('d-m-Y', $currentTime));
                $previousDate = strtotime(date('d-m-Y', (strtotime('-1 day', $currentTime))));
                $getPreShiftTime = $this->getShiftTime($clientId, $previousDate);
                $getCurrentShiftTime = $this->getShiftTime($clientId, $currentDate);
                $getShiftTime = array_merge($getPreShiftTime, $getCurrentShiftTime);
            } else {
                $currentDate = strtotime(date('d-m-Y', $currentTime));
                $getShiftTime = $this->getShiftTime($clientId, $currentDate);
            }
        } else {
            $currentDate = strtotime(date('d-m-Y', $currentTime));
            $previousDate = strtotime(date('d-m-Y', (strtotime('-1 day', $currentTime))));
            $getPreShiftTime = $this->getShiftTime($clientId, $previousDate);
            $getCurrentShiftTime = $this->getShiftTime($clientId, $currentDate);
            $getShiftTime = array_merge($getPreShiftTime, $getCurrentShiftTime);
        }

        # business shift functionality
        if (count($getShiftTime) != 0) {
            $timing = "";
            foreach ($getShiftTime as $shift) {
                $time_1 = $shift->$type1;
                $time_2 = $shift->$type2;

                if ($time_1 != "" && $time_2 != "") {
                    if ($pre == 1 || $pre == 0) {
                        # get start time based on current time
                        # this if statement for preorder starting time
                        if ($hourMinutes <= $time_2) {
                            // $startTimestamp = $hourMinutes;
                            if ($hourMinutes >= $time_1) {
                                $startTimestamp = $hourMinutes;
                            } else {
                                $startTimestamp = $time_1;
                            }
                        } else if ($hourMinutes <= $time_1) {
                            $startTimestamp = $time_1;
                        } else {
                            $startTimestamp = $hourMinutes;
                        }
                      
                        if (isset($getCookingTime[$type])) {
                            $getCookingTime = $getCookingTime[$type];
                        }
                        if ($getCookingTime) {
                            $startTimestamp = date('H:i', strtotime($startTimestamp) + ($getCookingTime * 60));
                        } else {
                            $startTimestamp = date('H:i', strtotime($startTimestamp));
                        }

                        # open/close status with starting time 
                        $checkOpenStatus = $this->checkOpenStatus($clientId, $currentTime);
                        if ($checkOpenStatus != "") {
                            if (is_numeric($checkOpenStatus)) {
                                $currentDate = strtotime(date('d-m-Y', $currentTime));
                                $openDate = strtotime(date('d-m-Y', $checkOpenStatus));
                                if ($currentTime <= $checkOpenStatus && $currentDate == $openDate) {
                                    $startTimestamp = date('H:i', $checkOpenStatus);
                                } else {
                                    return "closed";
                                }
                            } else {
                                return "closed";
                            }
                        }

                        # get end time based on current time
                        $endTimestamp = $time_2;

                        # get start and end hours
                        $startHours = date('H', strtotime($time_1));
                        $endHours = date('H', strtotime($time_2));

                        # get start and end date
                        $startDate = $startHours < 8 ? date('d-m-Y', (strtotime('+1 day', $currentDate))) : date('d-m-Y', $currentDate);
                        $endDate = $endHours < 8 ? date('d-m-Y', (strtotime('+1 day', $currentDate))) : date('d-m-Y', $currentDate);
                    } else {
                        # closed status for open/close, holiday and bank holiday
                        $yesterdayTime = strtotime(date('d-m-Y', $previousDate) . " " . "08:00");
                        $todayTime = strtotime(date('d-m-Y', $currentTime) . " " . "08:00");
                        $yesterdayCheckStatus = $this->checkOpenStatus($clientId, $yesterdayTime);
                        $todayCheckStatus = $this->checkOpenStatus($clientId, $todayTime);

                        # get start time based on current time
                        $day = date('N', $currentDate);

                        if ($day > $shift->day || $day < $shift->day) {
                            # previous days start and end times
                            $startTimestamp = ("08:00" < $time_1) ? "00:00" : $time_1;
                            $endTimestamp = ("08:00" > $time_2) ? $time_2 : "";
                            // $startTimestamp = "00:00";
                            // $endTimestamp = $time_2;
                            if ($yesterdayCheckStatus != "") {
                                $startTimestamp = $time_1;
                            }
                        } else if ($day == $shift->day) {
                            # current days start and end times
                            $startTimestamp = $time_1;
                            $endTimestamp = ("08:00" < $time_2) ? $time_2 : "23:59";
                            # open/close time with start and end times 
                            if ($todayCheckStatus != "") {
                                $endTimestamp = $time_2;
                                if (is_numeric($todayCheckStatus)) {
                                    $currentDate = strtotime(date('d-m-Y', $currentTime));
                                    $openDate = strtotime(date('d-m-Y', $todayCheckStatus));
                                    if ($currentTime <= $todayCheckStatus && $currentDate == $openDate) {
                                        $startTimestamp = date('H:i', $todayCheckStatus);
                                        $endTimestamp = $time_2 < "23:59" && $time_2 > "08:00" ? $time_2 : "23:59";
                                    }
                                }
                            }
                        }
                        # get start and end date
                        $startDate = date('d-m-Y', $currentDate);
                        $endDate = date('d-m-Y', $currentDate);
                    }

                    if (in_array($orderMode, $getOrderMode)) {
                        if ($shift->$type == 1) {
                            if ($startTimestamp != "" && $endTimestamp != "") {
                                $startTime = strtotime($startDate . " " . $startTimestamp);

                                # calculation for between the start and end time
                                # adding cooking time to today orders while disable the tat time
                                $cookingTime = "";
                                if ($pre == 1 && $tatStatus == 1) {
                                    $cookingTime = " +" . $getCookingTime . " minutes";
                                }
                                $targetTime = strtotime($endDate . " " . $endTimestamp . $cookingTime);
                                $duration = $targetTime - $startTime;

                                # shift times between 5 min gap
                                for ($i = 0; $i <= $duration; $i += 300) { # 300 seconds = 5 minutes
                                    $intervalTime = $startTime + $i;
                                    if ($pre == 0) {
                                        $intervalTime = date('d-m-Y H:i', $intervalTime);
                                    } else {
                                        $intervalTime = date('H:i', $intervalTime);
                                    }
                                    # $intervalTime = date('Y-m-d H:i', $intervalTime);
                                    $timing .= !empty($timing) ? ',' . $intervalTime : $intervalTime;
                                }
                            }
                        } else {
                            // return $this->getOrderModeErrorMessage($orderMode);
                        }
                    } else {
                        // return $this->getOrderModeErrorMessage($orderMode);
                    }
                } else {
                    // return $this->getOrderModeErrorMessage($orderMode);
                }
            }
            return $timing;
        } else {
            return "";
        }
    }

   
}

