<?php

namespace App\Models;

use App\Models\User;
use App\Controllers\MyAccountController;
use App\Models\RestaurantPage;
use App\Models\Menu;

require '../config/env.php';

class Myaccount extends DB
{
    public function getProfile($customerId)
    {
        return $this->query("CALL getProfile($customerId)");
    }

    public function updateProfile($customerId, $firstName, $lastName, $email, $phone)
    {
        $this->query("CALL updateProfile('$customerId', '$firstName', '$lastName', '$email', '$phone')");
        return true;
    }

    public function getAddress($customerId)
    {
        return $this->queryAll("CALL getAddress($customerId)");
    }

    public function getAddressWithId($addressId)
    {
        return $this->query("CALL getAddressWithId($addressId)");
    }

    public function updatePrimaryAddress($customerId, $addressType)
    {
        $this->query("CALL updatePrimaryAddress($customerId, $addressType)");
        return true;
    }

    public function addAddress($data)
    {
        return $this->query("CALL createAddress('$data[customerId]', '$data[addressType]', '$data[firstName]', '$data[lastName]', '$data[phoneNumber]' ,'$data[postcode]', '$data[door]', '$data[street]', '$data[city]', '$data[primary]', @insert_id)");
    }

    public function updateAddress($data)
    {
        $this->query("CALL updateAddress('$data[addressId]', '$data[addressType]', '$data[firstName]', '$data[lastName]', '$data[phoneNumber]' ,'$data[postcode]', '$data[door]', '$data[street]', '$data[city]', '$data[primary]')");
        return true;
    }

    public function deleteAddress($addressId)
    {
        $this->query("CALL deleteAddress($addressId)");
        return true;
    }

    public function updateOrderStatus($clientId, $orderId, $status)
    {
        $client = new Client($clientId);
        $client->query("CALL updateOrderStatus($orderId, $status)");
        $client->connectionClose();
        return true;
    }

    public function getOrderedItem($clientId, $orderId)
    {
        $client = new Client($clientId);
        $getOrderedItem = $client->queryAll("CALL getOrderedItem($orderId)");
        $client->connectionClose();
        return $getOrderedItem;
    }

    public function getOrderDetail($clientId, $orderId)
    {
        $client = new Client($clientId);
        $orderDetail = array();
        $getOrderDetail = $client->query("call getOrderDetail($orderId)");

        # get bill details
        $orderDetail['order'] = $this->getBillDetails($getOrderDetail);

        # get restaurant user details
        $orderDetail['restaurant'] = $this->query("call getRestaurantDetail($clientId)");

        if ($getOrderDetail->otype == 0) {
            # get ordered user details
            $getOrderUser = $client->query("call getOrderUser($orderId)");
            if ($getOrderUser != false) {
                $orderDetail['user']['fname'] = $getOrderUser->fname;
                $orderDetail['user']['lname'] = $getOrderUser->lname;
                $orderDetail['user']['phone'] = $getOrderUser->phone;
                $orderDetail['user']['dno'] = $getOrderUser->dno;
                $orderDetail['user']['postcode'] = $getOrderUser->postcode;
                $orderDetail['user']['add1'] = $getOrderUser->add1;
                $orderDetail['user']['add2'] = $getOrderUser->add2;
            } else {
                $orderDetail['user'] = [];
            }
        }
        $client->connectionClose();
        $orderDetail['item'] = $this->getOrderItemDetail($clientId, $orderId);
        // adding gift to item list for bill
        if ($getOrderDetail->gift != "") {
            $giftData = array(
                "item_name" => $getOrderDetail->gift,
                "item_qty" => $getOrderDetail->gqty,
                "item_total" => "0.00",
                "addonList" => ""
            );
            array_push($orderDetail['item'], $giftData);
        }
        return $orderDetail;
    }

    public function getOrderItemDetail($clientId, $orderId)
    {
        $client = new Client($clientId);

        # get ordered item details
        $getOrderItem = $this->getOrderedItem($clientId, $orderId);
        $item = array();
        foreach ($getOrderItem as $key => $items) {
            $item[$key]['itemid'] = $items->itemid;
            $item[$key]['item_name'] = $items->item_name;
            $item[$key]['item_qty'] = $items->qty;
            $item[$key]['item_total'] = $items->total;
            $item[$key]['instruction'] = $items->instruction;

            # get ordered addon details
            $getOrderAddon = $client->queryAll("call getOrderAddon($items->id)");
            $addonList = array();
            $item[$key]['addonTotalAmount'] = 0;
            $item[$key]['addonTotalQty'] = 0;
            foreach ($getOrderAddon as $keys => $addon) {
                $addonList[] = $addon->addon_name;
                $item[$key]['addonTotalAmount'] += $addon->total;
                $item[$key]['addonTotalQty'] += $addon->qty;
            }
            $item[$key]['addonList'] = implode(",", $addonList);
            $item[$key]['total'] = number_format($item[$key]['addonTotalAmount'] + $item[$key]['item_total'], 2);
        }
        $client->connectionClose();
        return $item;
    }

    public function getBillDetails($getOrderDetail)
    {
        # order type
        if ($getOrderDetail->otype == 0) {
            $order['orderType'] = "Delivery";
        } else {
            $order['orderType'] = "Collection";
        }
        $order['orderId'] = $getOrderDetail->id;

        # promo discount
        if ($getOrderDetail->promo_discount != "0.00" && $getOrderDetail->promo_discount != "" && $getOrderDetail->promo_discount != null) {
            $order['promo'] = number_format($getOrderDetail->promo_discount, 2);
        }
        # voucher discount
        if ($getOrderDetail->voucher_discount != "0.00" && $getOrderDetail->voucher_discount != "" && $getOrderDetail->voucher_discount != null) {
            $order['voucherDiscount'] = number_format($getOrderDetail->voucher_discount, 2);
        }
        # discount
        if ($getOrderDetail->con != "0.00" && $getOrderDetail->con != "" && $getOrderDetail->con != null) {
            $order['discount'] = number_format($getOrderDetail->con, 2);
        }
        # gift discount
        if ($getOrderDetail->gift != "0.00" && $getOrderDetail->gift != "" && $getOrderDetail->gift != null) {
            $order['gift'] = $getOrderDetail->gift;
            $order['giftQty'] = number_format($getOrderDetail->gqty, 2);
        }
        #round amount
        if ($getOrderDetail->roundamount != "0.00" && $getOrderDetail->roundamount != "" && $getOrderDetail->roundamount != null) {
            $order['roundAmount'] = number_format($getOrderDetail->roundamount, 2);
        }
        #extra donate
        if ($getOrderDetail->extraDonate != "0.00" && $getOrderDetail->extraDonate != "" && $getOrderDetail->extraDonate != null) {
            $order['extraDonate'] = number_format($getOrderDetail->extraDonate, 2);
        }
        # delivery charge
        if ($getOrderDetail->delivery_charge != "0.00" && $getOrderDetail->delivery_charge != "" && $getOrderDetail->delivery_charge != null) {
            $order['deliveryCharge'] = number_format($getOrderDetail->delivery_charge, 2);
        }
        # driver tip for delivery order and donation for collection order 
        if ($getOrderDetail->ride_amt != "0.00" && $getOrderDetail->ride_amt != "" && $getOrderDetail->ride_amt != null) {
            if ($getOrderDetail->otype == 0) {
                $order['driverTip'] = number_format($getOrderDetail->ride_amt, 2);
            } else {
                $order['donation'] = number_format($getOrderDetail->ride_amt, 2);
            }
        }
        # service charge
        if (($getOrderDetail->bank != "0.00" || $getOrderDetail->service_charge != "0.00") && ($getOrderDetail->bank != "" || $getOrderDetail->service_charge != "") && ($getOrderDetail->bank != null || $getOrderDetail->service_charge != null)) {
            $total_service_charge  = $getOrderDetail->bank + $getOrderDetail->service_charge;
            $order['serviceCharge'] = number_format($total_service_charge, 2);
        }
        # baggage amount
        if ($getOrderDetail->bagage != "0.00" && $getOrderDetail->bagage != "" && $getOrderDetail->bagage != null) {
            $order['baggage'] = number_format($getOrderDetail->bagage, 2);
        }

        # total amount
        $order['orderSubtotalAmount'] = number_format(($getOrderDetail->sub_total), 2);

        // $promo = $getOrderDetail->promo_discount ? $getOrderDetail->promo_discount : 0;
        // $voucherDiscount = $getOrderDetail->voucher_discount ? $getOrderDetail->voucher_discount : 0;
        // $discount = $getOrderDetail->con ? $getOrderDetail->con  : 0;
        $order['orderTotalAmount'] = number_format(($getOrderDetail->total + $getOrderDetail->service_charge + $getOrderDetail->ride_amt), 2);

        # button order status tracking/reorder
        $orderStatus = $getOrderDetail->status;
        $stuart = $getOrderDetail->isstuart_enable;
        $collected = $getOrderDetail->is_collected;
        $orderType = $getOrderDetail->otype;
        $order['orderStatus'] = $this->showOrderStatusButton($orderStatus, $stuart, $collected, $orderType);

        $order['orderPlacedTime'] = date("M d,Y h:i A", $getOrderDetail->datetime);

        # payment type 
        if ($getOrderDetail->ptype == 0) {
            $order['paymentType'] = "Cash";
        } else if ($getOrderDetail->ptype == 9) {
            $order['paymentType'] = "Wallet";
        } else if ($getOrderDetail->ptype == 10) {
            $order['paymentType'] = "Klarna";
        } else if ($getOrderDetail->ptype == 14) {
            $order['paymentType'] = "Paypal";
        } else {
            if (!$getOrderDetail->refno == "") {
                $refno = json_decode($getOrderDetail->refno);
                if (isset($refno->type)) {
                    if ($refno->type == "apple_pay") {
                        $order['paymentType'] = "Apple pay";
                    } else if ($refno->type == "google_pay") {
                        $order['paymentType'] = "Google pay";
                    } else {
                        $order['paymentType'] = "Card";
                    }
                } else {
                    $order['paymentType'] = "Card";
                }
            }
        }

        return $order;
    }

    public function getOrderHistory($customerId, $clientPath = "")
    {
        $orderHistory = array();
        $orderHistory['order'] = array();
        $totalDiscountValue = 0;

        $getOrderHistory = $this->queryAll("CALL getOrderHistory($customerId, '$clientPath')");
        foreach ($getOrderHistory as $key => $orders) {
            $getClientId = $this->query("CALL getClientUsingB2cPath('$orders->client_path')");
           
            if ($getClientId != false) {
                $client = new Client($getClientId->id);
                $getOrderDetail = $client->query("call getOrderDetail($orders->order_id)");
                // print_r($orders);exit;
                $getLogo=$this->query("CALL getCuisinesBasedClientId('$getClientId->id')");
                $client_logo="";
                if(isset($getLogo->logo))
                {
                    $client_logo="https://fusionbucket.co.uk/img/".$getLogo->logo;
                }
                $client->connectionClose();
                if ($getOrderDetail != false) {
                    // print_r($getOrderDetail);
                    $order['orderId'] = $orders->order_id;
                    $order['clientId'] = $getClientId->id;
                    $order['clientPath'] = $orders->client_path;
                    $order['logo'] = $client_logo;
                    $order['orderedDate'] = date("M d,Y", $orders->datetime);
                    $order['takeawayName'] = $getClientId->takeaway_name;
                    $order_status=$getOrderDetail->status;
                    $order_status_res="";
                    if($order_status==2 || $order_status=='2')
                    {
                        $order_status_res="Rejected";
                    }
                    else if($order_status==3 || $order_status=='3')
                    {
                        $order_status_res="Delivered";
                    }
                    else if($order_status==3 || $order_status=='4')
                    {
                        $order_status_res="Cancelled";
                    }
                    # getting total discount values
                    if ($getOrderDetail->voucher_discount != null) {
                        $voucher_discount = $getOrderDetail->voucher_discount;
                    } else {
                        $voucher_discount = 0;
                    }
                    if ($getOrderDetail->con != null) {
                        $discount = $getOrderDetail->con;
                    } else {
                        $discount = 0;
                    }
                    if ($getOrderDetail->promo_discount != null) {
                        $promo_discount = $getOrderDetail->promo_discount;
                    } else {
                        $promo_discount = 0;
                    }
                    $discount = $voucher_discount + $promo_discount + $discount;
                    $totalDiscountValue += $discount;

                    $order['orderTotalAmount'] = number_format(($getOrderDetail->total + $getOrderDetail->service_charge + $getOrderDetail->ride_amt), 2);


                    # button order status tracking/reorder
                    $orderStatus = $getOrderDetail->status;
                    $stuart = $getOrderDetail->isstuart_enable;
                    $collected = $getOrderDetail->is_collected;
                    $orderType = $getOrderDetail->otype;
                    $order['orderStatus'] = $this->showOrderStatusButton($orderStatus, $stuart, $collected, $orderType);
                    $order['orderDeliveryStatus'] = $order_status_res;
                    array_push($orderHistory['order'], $order);
                }
            }
        }
        $orderHistory['totalAppliedDiscount'] = number_format($totalDiscountValue, 2);
        return $orderHistory;
    }

    public function getLastOrder($customerId, $clientId, $clientPath)
    {
        $getOrderHistory = $this->queryAll("CALL getOrderHistory($customerId, '$clientPath')");
        foreach ($getOrderHistory as $key => $orders) {
            $getClientId = $this->query("CALL getClientUsingB2cPath('$orders->client_path')");
            if ($getClientId != false && $clientId == $getClientId->id) {
                return true;
            }
        }
        return false;
    }

    public function showOrderStatusButton($orderStatus, $stuart, $collected, $orderType)
    {
        # button order status tracking/reorder
        if ($orderStatus == 2 || $orderStatus == 4) {
            return "reorder";
        } elseif ($orderStatus == 3) {
            if($orderType == 1) {
                return "reorder";
            } else {
                return ($stuart == 1) ? ($collected == "delivered" || $collected == "cancelled") ? "reorder" : "tracking" : "reorder";
            }
        } else {
            return "tracking";
        }
    }

    public function getOrderFeedback($clientId, $orderId)
    {
        return $this->query("CALL getOrderFeedback($orderId, $clientId)");
    }

    public function tatTime($getOrderDetail, $clientId)
    {
        $menu = new Menu();
        # get cooking time
        $cookingTime = $menu->getCookingTime($clientId);

        if ($cookingTime['delivery'] == "") {
            $cookingTime['delivery'] = "0";
        }

        if ($cookingTime['collection'] == "") {
            $cookingTime['collection'] = "0";
        }

        # expected time calculation
        $tatTime = $getOrderDetail->late;
        if ($getOrderDetail->otype == 0) {
            $data['estimated']['estimatedContent'] = "Expected Delivery Time";
            $tatTime += $cookingTime['delivery'];
            $data['time']['tatTime'] = $cookingTime['delivery'];
        } else {
            $data['estimated']['estimatedContent'] = "Expected Collection Time";
            $tatTime += $cookingTime['collection'];
            $data['time']['tatTime'] = $cookingTime['collection'];
        }

        if ($getOrderDetail->preorder) {
            $estimatedTime = $getOrderDetail->preorder;
            if (date("d/m/Y") == date("d/m/Y", $estimatedTime))
                $data['estimated']['tatTime'] = "Today ";
            else
                $data['estimated']['tatTime'] = date("M d,Y ", $estimatedTime);
            $data['estimated']['tatTime'] .= date("h:i A", $estimatedTime);
        } else {
            $estimatedTime = $getOrderDetail->datetime + ($tatTime * 60);
            if (date("d/m/Y") == date("d/m/Y", $estimatedTime))
                $data['estimated']['tatTime'] = "Today ";
            else
                $data['estimated']['tatTime'] = date("M d,Y ", $estimatedTime);
            $data['estimated']['tatTime'] .= date("h:i A", $estimatedTime) . " - " . date('h:i A', strtotime('+10 minutes', $estimatedTime));
        }

        return $data;
    }

    public function getOrderStatus($clientId, $orderId,$co_ordinates)
    {
        $client = new Client($clientId);
        $menu = new Menu();
        $orderDetail = array();
        $getOrderDetail = $client->query("call getOrderDetail($orderId)");
        $getOrderUser = $client->query("call getOrderUser($orderId)");
        $client->connectionClose();

        # get order feedback
        $order_feedback = $this->getOrderFeedback($clientId, $orderId);

        # get restaurant detail
        $restaurantDetail = $menu->getContacts($clientId);
        $getOrderDriverStatus = $menu->getOrderDriverStatus($clientId, $orderId);

        # get order expected time and content
        $tatTime = $this->tatTime($getOrderDetail, $clientId);
        foreach ($tatTime['estimated'] as $key => $estimated) {
            $orderDetail['order'][$key] = $estimated;
        }
        //driver details
        $orderDetail['driverDetails']=false;
       
        $stuart_driver_tracking_url= $getOrderDetail->tracking_url != false ? $getOrderDetail->tracking_url : "";
        $stuart_driver_name=$getOrderDetail->driver_name  ? $getOrderDetail->driver_name : "";
        $stuart_driver_number=$getOrderDetail->driver_number ? $getOrderDetail->driver_number : "";
        if($stuart_driver_tracking_url && $stuart_driver_tracking_url!='')
        {
            $orderDetail['driverDetails']=[];
            $orderDetail['driverDetails']['tracking_url'] =$stuart_driver_tracking_url;
            $orderDetail['driverDetails']['driver_name'] = $stuart_driver_name;
            $orderDetail['driverDetails']['driver_number'] = $stuart_driver_number;
        }
      
        # get order id
        $orderId_str = $getOrderDetail->id;
        // Ensure the order ID is at least 5 digits, padding with leading zeros if necessary
        $orderDetail['order']['orderId'] = str_pad($orderId_str, 5, '0', STR_PAD_LEFT);
        
        // If the order ID exceeds 5 digits, it will remain unchanged
        if (strlen($orderDetail['order']['orderId']) > 5) {
            $orderDetail['order']['orderId'] = $orderId_str;
        }
        $orderDetail['order']['orderId']=(string)$orderDetail['order']['orderId'];
        $tatTime = $tatTime['time']['tatTime'];

        if ($getOrderDetail->preorder) {
            $tatTime = 0;
            $time = $tatTime - round((time() - $getOrderDetail->preorder) / 60);
        } else {
            $time = $tatTime - round((time() - $getOrderDetail->datetime) / 60);
        }
        if (!empty($getOrderDetail->order_accept_time)) {
            $time = $tatTime - round((time() - $getOrderDetail->order_accept_time) / 60);
        }
        $orderStatusNote_mins=true;
        if (($time + $getOrderDetail->late) > 0)
            $getOrderDetail->tat = $time + $getOrderDetail->late;
        else
            $getOrderDetail->tat = '0';
        
        $orderDetail['order']['orderStatusShortNote']=$getOrderDetail->tat;

        # order type
        $orderDetail['order']['orderType'] = $getOrderDetail->otype == 0 ? "Delivery" : "Collection";
        $orderDetail['order']['orderType_new'] = $getOrderDetail->otype == 0 ? "Delivery" : "Collection";
        # stuart enable status
        $orderDetail['order']['isStuart'] = $getOrderDetail->isstuart_enable == 0 ? false : true;

        # feedback status
        if (!empty($order_feedback))
            $orderDetail['order']['orderFeedback'] = true;
        else
            $orderDetail['order']['orderFeedback'] = false;


        $latitude=$co_ordinates['latitude'];
        $longitude=$co_ordinates['longitude'];
        $restaurant_track_url="";
        if(!empty($latitude) && !empty($longitude))
        {
            
            $getB2cDetails=$this->query("call getCuisinesBasedClientId('$clientId')");
            if(isset($getB2cDetails->lat) && isset($getB2cDetails->lang))
            {
               $restaurant_track_url="https://www.google.com/maps/dir/?api=1&origin=$getB2cDetails->lat,$getB2cDetails->lang&destination=$latitude,$longitude";
               
            }
        }
        $orderDetail['restaurant_track']=$restaurant_track_url;
        # order status
        
        if ($getOrderDetail->isstuart_enable == 0) {
            switch ($getOrderDetail->status) {
                case 0:
                    $orderDetail['order']['orderStatusName'] = "Awaiting Confirmation";
                    $orderDetail['order']['orderStatusId'] = 0;
                    $orderDetail['order']['orderStatusShortNote']="";
                    $orderStatusNote_mins=false;
                    break;
                case 1:
                    if ($getOrderDriverStatus != false) {
                        $orderDetail['order']['orderStatusName'] = "Order Ready";
                        $orderDetail['order']['orderStatusId'] = 5;
                        $orderDetail['order']['orderStatusShortNote']="Enjoy Your Food";
                        $orderStatusNote_mins=false;
                    } else {
                        if($getOrderDetail->tat>30)
                        {
                            $orderDetail['order']['orderStatusName'] = "Scheduled";
                            $orderDetail['order']['orderStatusShortNote']=$getOrderDetail->tat;
                            $orderDetail['order']['orderStatusId'] = 1;
                        }
                        else if ($getOrderDetail->tat != 0) {
                            $orderDetail['order']['orderStatusName'] = "Being Prepared";
                            $orderDetail['order']['orderStatusId'] = 1;
                            $orderDetail['order']['orderStatusShortNote']=$getOrderDetail->tat;
                        } else {
                            $orderDetail['order']['orderStatusName'] = "Order Ready";
                            $orderDetail['order']['orderStatusId'] = 5;
                            $orderDetail['order']['orderStatusShortNote']="Enjoy Your Food";
                            $orderStatusNote_mins=false;
                        }
                    }
                    break;
                case 2:
                    $orderDetail['order']['orderStatusName'] = "Order Rejected";
                    $orderDetail['order']['orderStatusId'] = 2;
                    $push_notification_type="order_rejected";
                    $MyAccountController=new MyAccountController();
                    $push_notification=$MyAccountController->pushNotificationCurl($push_notification_type,$clientId, $orderId);
                    $orderDetail['order']['orderStatusShortNote']="Your Order has been rejected";
                    $orderStatusNote_mins=false;
                    break;
                case 3:
                    $orderDetail['order']['orderStatusShortNote']="Enjoy Your Food";
                    $orderStatusNote_mins=false;
                    if ($getOrderDetail->otype == 0)
                        $orderDetail['order']['orderStatusName'] = "Order Delivered";
                    else
                        $orderDetail['order']['orderStatusName'] = "Order Collection";
                    $orderDetail['order']['orderStatusId'] = 3;
                    break;
                case 4:
                    $orderDetail['order']['orderStatusName'] = "Order Cancelled";
                    $orderDetail['order']['orderStatusId'] = 4;
                    $orderDetail['order']['orderStatusShortNote']="Your Order has been Cancelled";
                    $orderStatusNote_mins=false;
                    break;
                default:
                    $orderDetail['order']['orderStatusName'] = "";
                    $orderDetail['order']['orderStatusId'] = "";
                    break;
            }
        } else {
           
            if ($getOrderDetail->otype == 0) {
                $orderDetail['order']['orderType_new'] = "Stuart";
                if ($getOrderDetail->status == 0) {
                    $orderDetail['order']['orderStatusName'] = "Awaiting Confirmation";
                    $orderDetail['order']['orderStatusId'] = 0;
                    $orderDetail['order']['orderStatusShortNote']="";
                    $orderStatusNote_mins=false;
                } elseif ($getOrderDetail->status == 2) {
                    $orderDetail['order']['orderStatusName'] = "Order Rejected";
                    $orderDetail['order']['orderStatusShortNote']="Your Order has been rejected";
                    $orderStatusNote_mins=false;
                    $orderDetail['order']['orderStatusId'] = 2;
                    $push_notification_type="order_rejected";
                    $MyAccountController=new MyAccountController();
                    $push_notification=$MyAccountController->pushNotificationCurl($push_notification_type,$clientId, $orderId);
                } elseif ($getOrderDetail->status == 4) {
                    $orderDetail['order']['orderStatusName'] = "Order Cancelled";
                    $orderDetail['order']['orderStatusId'] = 4;
                    $orderDetail['order']['orderStatusShortNote']="Your Order has been Cancelled";
                    $orderStatusNote_mins=false;
                } elseif (($getOrderDetail->is_collected == 1 || $getOrderDetail->is_collected == "cancelled") && $getOrderDetail->status != 2 && $getOrderDetail->status != 4) {
                    $orderDetail['order']['orderStatusName'] = "Order Confirmed";
                    $orderDetail['order']['orderStatusId'] = 1;
                } elseif ($getOrderDetail->is_collected != 1 && $getOrderDetail->status != 2 && $getOrderDetail->status != 4) {
                    if ($getOrderDetail->is_collected == 'scheduled') {
                        $orderDetail['order']['orderStatusName'] = "Order Scheduled";
                        $orderDetail['order']['orderStatusId'] = 5;
                    } elseif ($getOrderDetail->is_collected == 'pending' || $getOrderDetail->is_collected == 'searching') {
                        $orderDetail['order']['orderStatusName'] = "Being Prepared";
                        $orderDetail['order']['orderStatusId'] = 6;
                    } elseif ($getOrderDetail->is_collected == 'picking' || $getOrderDetail->is_collected == 'almost_picking' || $getOrderDetail->is_collected == 'waiting_at_pickup') {
                        $orderDetail['order']['orderStatusName'] = "Picking Your Order";
                        $orderDetail['order']['orderStatusId'] = 7;
                    } elseif ($getOrderDetail->is_collected == 'waiting_at_pickup') {
                        $orderDetail['order']['orderStatusName'] = "Waiting for pickup";
                        $orderDetail['order']['orderStatusId'] = 8;
                    } elseif ($getOrderDetail->is_collected == 'delivering') {
                        $orderDetail['order']['orderStatusName'] = "Heading Your way";
                        $orderDetail['order']['orderStatusId'] = 9;
                    } elseif ($getOrderDetail->is_collected == 'almost_delivering') {
                        $orderDetail['order']['orderStatusName'] = "Order Nearby";
                        $orderDetail['order']['orderStatusId'] = 10;
                    } elseif ($getOrderDetail->is_collected == 'delivered' || $getOrderDetail->is_collected == 'finished') {
                        $orderDetail['order']['orderStatusName'] = "Delivered";
                        $orderDetail['order']['orderStatusId'] = 11;
                        $orderDetail['order']['orderStatusShortNote']="Enjoy Your Food";
                        $orderStatusNote_mins=false;
                    } else {
                        $orderDetail['order']['orderStatusName'] = "";
                        $orderDetail['order']['orderStatusId']  = "";
                    }
                }
                $orderDetail['order']['tracking_url'] = $getOrderDetail->tracking_url != false ? $getOrderDetail->tracking_url : "";
                $orderDetail['order']['driver_name'] = $getOrderDetail->driver_name  ? $getOrderDetail->driver_name : "";
                $orderDetail['order']['driver_number'] = $getOrderDetail->driver_number ? $getOrderDetail->driver_number : "";
            } else {
                switch ($getOrderDetail->status) {
                    case 0:
                        $orderDetail['order']['orderStatusName'] = "Awaiting Confirmation";
                        $orderDetail['order']['orderStatusId'] = 0;
                        $orderDetail['order']['orderStatusShortNote']="";
                        $orderStatusNote_mins=false;
                        break;
                    case 1:
                        if($getOrderDetail->tat>30)
                        {
                            $orderDetail['order']['orderStatusName'] = "Scheduled";
                            $orderDetail['order']['orderStatusShortNote']=$getOrderDetail->tat;
                            $orderDetail['order']['orderStatusId'] = 1;
                        }
                        else if ($getOrderDetail->tat != 0) {
                            $orderDetail['order']['orderStatusName'] = "Being Prepared";
                        } else {
                            $orderDetail['order']['orderStatusName'] = "Order Ready";
                            $orderDetail['order']['orderStatusShortNote']="Enjoy Your Food";
                            $orderStatusNote_mins=false;
                        }
                        
                        $orderDetail['order']['orderStatusId'] = 1;
                        break;
                    case 2:
                        $orderDetail['order']['orderStatusName'] = "Order Rejected";
                        $orderDetail['order']['orderStatusId'] = 2;
                        $push_notification_type="order_rejected";
                        $MyAccountController=new MyAccountController();
                        $push_notification=$MyAccountController->pushNotificationCurl($push_notification_type,$clientId, $orderId);
                        $orderDetail['order']['orderStatusShortNote']="Your Order has been rejected";
                        $orderStatusNote_mins=false;
                        break;
                    case 3:
                        $orderDetail['order']['orderStatusShortNote']="Enjoy Your Food";
                        $orderStatusNote_mins=false;
                        $orderDetail['order']['orderStatusName'] = "Order Collection";
                        $orderDetail['order']['orderStatusId'] = 3;
                        break;
                    case 4:
                        $orderDetail['order']['orderStatusName'] = "Order Cancelled";
                        $orderDetail['order']['orderStatusId'] = 4;
                        $orderDetail['order']['orderStatusShortNote']="Your Order has been Cancelled";
                        $orderStatusNote_mins=false;
                        break;
                    default:
                        $orderDetail['order']['orderStatusName'] = "";
                        $orderDetail['order']['orderStatusId'] = "";
                        $orderStatusNote_mins=false;
                        break;
                }
            }
        }
       
        if($orderStatusNote_mins)
        {
          
            if($orderDetail['order']['orderStatusShortNote']=="1" || $orderDetail['order']['orderStatusShortNote']==1)
            {
                $orderDetail['order']['orderStatusShortNote'] =$orderDetail['order']['orderStatusShortNote']." Min";
            }
            else
            {
                $orderDetail['order']['orderStatusShortNote'] =$orderDetail['order']['orderStatusShortNote']." Mins";
            }
           
        }
        $payment_type_id_track=(int)$getOrderDetail->ptype;
        $payment_type_track='';
        $payment_type_array=array(
            0=>"Cash",
            1=>"Card",   // in fk and client website card reader and tap to pay not available
            2=>"Card At Shop",
            3=>"QR or Paylink",
            4=>"UnPaid",
            5=>"Motto Pay",
            7=>"Apple Pay",
            8=>"Google Pay",
            9=>"Wallet",
            10=>"klarna",
            14=>"Paypal",
        );
        if(isset($payment_type_array[$payment_type_id_track]))
        {
            $payment_type_track=$payment_type_array[$payment_type_id_track];
        }

        $payment_status="Paid";
        // echo "the status is".$getOrderDetail->status;
        if($payment_type_id_track==0)
        {
            if($getOrderDetail->status!=3)
            {
                $payment_status="UnPaid";
            }
           
        }

        
        $orderDetail['order']['payment_type']=$payment_type_track;
        $orderDetail['order']['payment_status']=$payment_status;
        $orderDetail['order']['restaurantName'] = $restaurantDetail->name;
        $orderDetail['order']['restaurantPhone'] = $restaurantDetail->phone;
        $orderDetail['order']['logo'] = $_ENV['FUSION_BUCKET'] . $restaurantDetail->image;

        # get ordered user details
        if ($getOrderUser != false) {
            $orderDetail['user']['fname'] = $getOrderUser->fname;
            $orderDetail['user']['lname'] = $getOrderUser->lname;
            $orderDetail['user']['phone'] = $getOrderUser->phone;
            $orderDetail['user']['dno'] = $getOrderUser->dno;
            $orderDetail['user']['postcode'] = $getOrderUser->postcode;
            $orderDetail['user']['add1'] = $getOrderUser->add1;
            $orderDetail['user']['add2'] = $getOrderUser->add2;
            $orderDetail['user']['email'] = $getOrderUser->email;
        } else {
            $orderDetail['user'] = [];
        }

        $orderDetail['order']['orderTotalAmount'] = number_format(($getOrderDetail->total + $getOrderDetail->service_charge + $getOrderDetail->ride_amt), 2);

        return $orderDetail;
    }

    public function getPathUsingDomain($domain)
    {
        return $this->query("CALL getPathUsingDomain('$domain')");
    }

    public function getMailOrderDetail($clientId, $orderId)
    {
        $client = new Client($clientId);
        $orderDetail = array();
        $getOrderDetail = $client->query("call getOrderDetail($orderId)");
        $contact = $client->query("CALL getContacts()");

        // Get currency info
        $location = new Location($clientId);
        $currency = $location->getCurrency();
        $orderDetail['currency'] = $currency['symbol'];

        # get bill details
        $orderDetail['order'] = $this->getBillDetails($getOrderDetail);

        # get order expected time and content
        $tatTime = $this->tatTime($getOrderDetail, $clientId);
        foreach ($tatTime['estimated'] as $key => $estimated) {
            $orderDetail['order'][$key] = $estimated;
        }

        $orderDetail['order']['otype'] = $getOrderDetail->otype;

        # get restaurant user details
        $getRestaurant = $this->query("call getRestaurantDetail($clientId)");
        $orderDetail['restaurant']['name'] = $getRestaurant->takeaway_name;
        $orderDetail['restaurant']['restaurantEmail'] =$contact->email;
        $orderDetail['restaurant']['restaurantPhone'] = $contact->phone;
        $orderDetail['restaurantLogo'] = $_ENV['FUSION_BUCKET'] . $contact->image;
        # get ordered user details
        $getOrderUser = $client->query("call getOrderUser($orderId)");
        if ($getOrderUser != false) {
            $orderDetail['user']['fname'] = $getOrderUser->fname;
            $orderDetail['user']['lname'] = $getOrderUser->lname;
            $orderDetail['user']['phone'] = $getOrderUser->phone;
            $orderDetail['user']['dno'] = $getOrderUser->dno;
            $orderDetail['user']['postcode'] = $getOrderUser->postcode;
            $orderDetail['user']['add1'] = $getOrderUser->add1;
            $orderDetail['user']['add2'] = $getOrderUser->add2;
            $orderDetail['user']['email'] = $getOrderUser->email;
        } else {
            $orderDetail['user'] = [];
        }
        $client->connectionClose();

        $orderDetail['items'] = $this->getOrderItemDetail($clientId, $orderId);

        return $orderDetail;
    }

    public function getOrderRejectDetail($clientId, $orderId)
    {
        $client = new Client($clientId);
        # get restaurant detail
        $contact = $client->query("CALL getContacts()");
        # get order's user details
        $getOrderUser = $client->query("call getOrderUser($orderId)");
        $client->connectionClose();
        $data = array(
            "restaurantEmail" => $contact->email,
            "restaurantPhone" => $contact->phone,
            "restaurantName" => $contact->name,
            "userEmail" => $getOrderUser->email,
            "orderId" => $getOrderUser->oid,
            "restaurantLogo" => $_ENV['FUSION_BUCKET'] . $contact->image,
        );
        return $data;
    }

    public function OrderacceptDetail($clientId, $orderId)
    {
        $client = new Client($clientId);
        # get restaurant detail
        $contact = $client->query("CALL getContacts()");
        # get order's user details
        $getOrderUser = $client->query("call getOrderUser($orderId)");
        $client->connectionClose();
        $data = array(
            "restaurantEmail" => $contact->email,
            "restaurantPhone" => $contact->phone,
            "restaurantName" => $contact->name,
            "userEmail" => $getOrderUser->email,
            "orderId" => $getOrderUser->oid,
            "restaurantLogo" => $_ENV['FUSION_BUCKET'] . $contact->image,
        );
        return $data;
    }

    public function getOrderSmsDetail($clientId, $orderId)
    {
        $client = new Client($clientId);
        # get restaurant detail
        $contact = $client->query("CALL getContacts()");
        # get order's user details
        $getOrderUser = $client->query("call getOrderUser($orderId)");
        # get order details
        $getOrderDetail = $client->query("call getOrderDetail($orderId)");

        $client->connectionClose();
        $data = array(
            "restaurantPhone" => $contact->phone,
            "restaurantName" => $contact->name,
            "userFirstName" => $getOrderUser->fname,
            "userLastName" => $getOrderUser->lname,
            "userPhone" => $getOrderUser->phone,
            "orderId" => $getOrderUser->oid,
            "orderType" => $getOrderDetail->otype,
            "isCollected" => $getOrderDetail->is_collected,
            "isStuartEnable" => $getOrderDetail->isstuart_enable
        );
        return $data;
    }

    public function getOrderedItemsList($clientId, $orderId)
    {
        $client = new Client($clientId);

        # get ordered item details
        $getOrderItem = $this->getOrderedItem($clientId, $orderId);
        $data['item'] = array();
        foreach ($getOrderItem as $key => $items) {
            $itemAvailability = $client->query("call getItemWithId($items->itemid)");
            if ($itemAvailability != false) {
                if ($itemAvailability->name == $items->item_name) {
                    $data['item'][$key]['itemImage'] = $itemAvailability->image
                        ? $_ENV['FUSION_BUCKET'] . 'menu/' . $itemAvailability->image
                        : "";
                    $data['item'][$key]['itemDesc'] = $itemAvailability->description;
                    $data['item'][$key]['actual_price'] = $itemAvailability->price;
                    $data['item'][$key]['price'] = number_format($itemAvailability->price * $items->qty, 2);
                    $data['item'][$key]['itemAvailability'] = true;
                } else {
                    $data['item'][$key]['itemImage'] = "";
                    $data['item'][$key]['itemDesc'] = "";
                    $data['item'][$key]['actual_price'] = "0";
                    $data['item'][$key]['price'] = "0";
                    $data['item'][$key]['itemAvailability'] = false;
                }
            } else {
                $data['item'][$key]['itemImage'] = "";
                $data['item'][$key]['itemDesc'] = "";
                $data['item'][$key]['actual_price'] = "0";
                $data['item'][$key]['price'] = "0";
                $data['item'][$key]['itemAvailability'] = false;
            }
            $data['item'][$key]['itemId'] = $items->itemid;
            $data['item'][$key]['itemName'] = $items->item_name;
            $data['item'][$key]['count'] = $items->qty;

            # get ordered addon details
            $data['item'][$key]['addonName'] = "";
            $getOrderAddon = $client->queryAll("call getOrderAddon($items->id)");
            if ($getOrderAddon != false) {
                foreach ($getOrderAddon as $keys => $addon) {
                    $getAddonItem = $client->query("call getAddonItemDetailWithId($addon->addonid)");
                    if ($getAddonItem != false) {
                        $data['item'][$key]['addon'][$keys]['addonAvailability'] = true;
                    } else {
                        $data['item'][$key]['addon'][$keys]['addonAvailability'] = false;
                    }
                    $data['item'][$key]['addon'][$keys]['id'] = $addon->addonid;
                    $data['item'][$key]['addon'][$keys]['extra'] = "";
                    $data['item'][$key]['addon'][$keys]['qty'] = 1;
                    $data['item'][$key]['addon'][$keys]['addonName'] = $addon->addon_name;
                    $data['item'][$key]['price'] = number_format($data['item'][$key]['price'] + $addon->price, 2);
                    if ($keys == 0) {
                        $data['item'][$key]['addonFirstId'] = $addon->addonid;
                    }
                    if ($data['item'][$key]['addonName'] == "") {
                        $data['item'][$key]['addonName'] = $addon->addon_name;
                    } else {
                        $data['item'][$key]['addonName'] = $data['item'][$key]['addonName'] . ", " . $addon->addon_name;
                    }
                }
            } else {
                $data['item'][$key]['addon'] = 0;
            }
            $getRestaurant = $this->query("call getRestaurantDetail($clientId)");
            $data['item'][$key]['clientId'] = $clientId;
            $data['item'][$key]['clientName'] = $getRestaurant->takeaway_name;
            $data['item'][$key]['gift'] = 0;
            $data['item'][$key]['instruction'] = "";
            $data['item'][$key]['itemAllowCoupon'] = 1;
            $data['item'][$key]['loyalty'] = 0;
        }
        $client->connectionClose();
        return $data;
    }

    public function updateAddressPopup($data)
    {
        $user = new User();
        $orderMode = $data['orderMode'];
        $firstName = $data['firstName'];
        $lastName = $data['lastName'];
        $phone = $data['phone'];
        $email = $data['email'];
        if ($orderMode == "0") {
            $door = $data['door'];
            $street = $data['street'];
            $city = $data['city'];
            $postcode = $data['postcode'];
        } else {
            $door = "";
            $street = "";
            $city = "";
            $postcode = "";
        }
        $customerId = $data['customerId'];
        $addressId = $data['addressId'];

        if (!empty($customerId)) {
            if (!empty($addressId)) {
                $getAddress = $this->getAddressWithId($addressId);
                if ($getAddress != false) {
                    $data = array(
                        "addressId" => $getAddress->id,
                        "addressType" => $getAddress->type,
                        "firstName" => $firstName,
                        "lastName" => $lastName,
                        "phoneNumber" => $phone,
                        "primary" =>  $getAddress->primary_address
                    );
                    if ($orderMode == 0) {
                        $data['door'] = $door;
                        $data['street'] = $street;
                        $data['city'] = $city;
                        $data['postcode'] = $postcode;
                    } else if ($orderMode == 1) {
                        $data['door'] = $getAddress->no;
                        $data['street'] = $getAddress->address1;
                        $data['city'] = $getAddress->address2;
                        $data['postcode'] = $getAddress->postcode;
                    }
                    $updateAddress = $this->updateAddress($data);
                    $result['customerId'] = $customerId;
                    $result['addressId'] = $addressId;
                    return $result;
                }
            } else {
                $updateOrCreateAddress = $this->updateOrCreateAddress($customerId, $firstName, $lastName, $phone, $door, $street, $city, $postcode, $orderMode);
                $result['customerId'] = $customerId;
                $result['addressId'] = $updateOrCreateAddress;
                return $result;
            }
        } else {
            $checkCustomerByEmail = $user->checkCustomerByEmail($email);
            if ($checkCustomerByEmail != false) {
                if (!empty($checkCustomerByEmail->id)) {
                    $updateOrCreateAddress = $this->updateOrCreateAddress($checkCustomerByEmail->id, $firstName, $lastName, $phone, $door, $street, $city, $postcode, $orderMode);
                    $result['customerId'] = $checkCustomerByEmail->id;
                    $result['addressId'] = $updateOrCreateAddress;
                    return $result;
                }
            } else {
                $createCustomer = $user->createCustomer($phone, $email, $firstName, $lastName);
                $data = array(
                    "customerId" => $createCustomer->insert_id,
                    "addressType" => "1",
                    "firstName" => $firstName,
                    "lastName" => $lastName,
                    "phoneNumber" => $phone,
                    "primary" => "1"
                );
                if ($orderMode == 0) {
                    $data['door'] = $door;
                    $data['street'] = $street;
                    $data['city'] = $city;
                    $data['postcode'] = $postcode;
                } else if ($orderMode == 1) {
                    $data['door'] = "";
                    $data['street'] = "";
                    $data['city'] = "";
                    $data['postcode'] = "";
                }
                $addAddress = $this->addAddress($data);
                $result['customerId'] = $createCustomer->insert_id;
                $result['addressId'] = $addAddress->insert_id;
                return $result;
            }
        }
    }

    public function updateOrCreateAddress($customerId, $firstName, $lastName, $phone, $door, $street, $city, $postcode, $orderMode)
    {
        $getAddress = $this->getAddress($customerId);
        if ($getAddress != false) {
            if (!empty($getAddress[0]->id)) {
                $data = array(
                    "addressId" => $getAddress[0]->id,
                    "addressType" => $getAddress[0]->type,
                    "firstName" => $firstName,
                    "lastName" => $lastName,
                    "phoneNumber" => $phone,
                    "primary" =>  $getAddress[0]->primary_address
                );
                if ($orderMode == 0) {
                    $data['door'] = $door;
                    $data['street'] = $street;
                    $data['city'] = $city;
                    $data['postcode'] = $postcode;
                } else if ($orderMode == 1) {
                    $data['door'] = $getAddress[0]->no;
                    $data['street'] = $getAddress[0]->address1;
                    $data['city'] = $getAddress[0]->address2;
                    $data['postcode'] = $getAddress[0]->postcode;
                }
                $updateAddress = $this->updateAddress($data);
                return $getAddress[0]->id;
            }
        } else {
            $data = array(
                "customerId" => $customerId,
                "addressType" => "1",
                "firstName" => $firstName,
                "lastName" => $lastName,
                "phoneNumber" => $phone,
                "primary" => "1",
            );
            if ($orderMode == 0) {
                $data['door'] = $door;
                $data['street'] = $street;
                $data['city'] = $city;
                $data['postcode'] = $postcode;
            } else if ($orderMode == 1) {
                $data['door'] = "";
                $data['street'] = "";
                $data['city'] = "";
                $data['postcode'] = "";
            }
            $addAddress = $this->addAddress($data);
            return $addAddress->insert_id;
        }
    }

    public function createFkFeedback($data)
    {
        $client = new Client($data['clientId']);
        $client->query("CALL createFeedback('$data[name]', '$data[comments]', '$data[rating]', '$data[email]', '', '$data[orderId]', '', @insert_id)");
        $client->connectionClose();
        return $this->query("CALL createFeedback('$data[customerId]', '$data[orderId]', '$data[clientId]', '$data[name]', '$data[email]' ,'$data[phone]', '$data[comments]', '$data[rating]', '$data[foodQuality]', @insert_id)");
    }

    public function getClientUsingB2cPath($clientPath)
    {
        return $this->query("CALL getClientUsingB2cPath('$clientPath')");
    }

    public function getClientFeedback($orderId, $clientId)
    {
        $client = new Client($clientId);
        $getOrderDetail = $client->query("call getOrderDetail($orderId)");
        $orderDetail = array();

        if ($getOrderDetail->feedback == 3) {
            $orderDetail['feedback'] = true;
        } else {
            $orderDetail['feedback'] = false;
        }

        # get restaurant user details
        $getRestaurantDetail = $this->query("call getRestaurantDetail($clientId)");
        $orderDetail['restaurantName'] = $getRestaurantDetail->takeaway_name;

        return $orderDetail;
    }

    public function getFavouriteList($userId,$orderTime)
    {
      
        $getFavouriteClientIds_query= $this->queryAll("CALL getFavouriteList($userId)");
        $client_ids='';
        foreach ($getFavouriteClientIds_query as $key => $value) 
        {
            $client_ids.=$value->client_id.",";
        }
        $client_ids = rtrim($client_ids, ',');
        $restaurant_details=array();
        if($client_ids!='' && $client_ids!=null)
        {
            $getCousines=$this->queryAll("CALL getCuisinesBasedClientId('$client_ids')");
            $getClientdetails = array();
            $getLogosClients=array();
            if(count($getCousines)>0)
            {
                foreach ($getCousines as $key => $value) 
                {
                    $getLogosClients[$value->client_id]=[
                        'logo'=>"https://fusionbucket.co.uk/img/".$value->logo,
                        'bg_image'=>"https://fusionbucket.co.uk/img/".$value->bg_image,
                        'description'=>$value->description,
                        'path'=>$value->client_menu_path,
                    ];
                    $cuisines_client = trim($value->cuisine, ',');
                   
                        $cuisineName_query = $this->queryAll("CALL getCuisineImageAll('$cuisines_client')");
                        foreach ($cuisineName_query as $key_cousine => $value_cousine) {
                           $getClientdetails[$value->client_id]['cousines'][]= $value_cousine->cuisine_name;
                          
                        }

                }
                    
            }
           
            $getRestaurantNamesArr=$this->queryAll("CALL getClientsBasedId('$client_ids')");
            $orderTime=strtotime($orderTime);
           
            if(count($getRestaurantNamesArr)>0)
            {
                foreach ($getRestaurantNamesArr as $key => $value) 
                {
                    $final_logos_array = isset($getLogosClients[$value->id]['logo']) ? $getLogosClients[$value->id]['logo']: '';
                    $final_bg_image = isset($getLogosClients[$value->id]['bg_image']) ? $getLogosClients[$value->id]['bg_image']:'' ;
                    $final_description = isset($getLogosClients[$value->id]['description']) ? $getLogosClients[$value->id]['description']: '';
                    $final_cousines_array = isset($getClientdetails[$value->id]['cousines']) ? $getClientdetails[$value->id]['cousines'] : [];
                    $final_menu_path = isset($getLogosClients[$value->id]['path']) ? $getLogosClients[$value->id]['path'] : '';
                    $menu = new Menu();
                    $customer_rating = new \stdClass();
                    $discount_favt = new \stdClass();
                    $getRestaurantStatus = new \stdClass();
                    $check_valid_client=$this->query("CALL getBridgeDetail($value->id)");  
                    if((isset($check_valid_client->host)))
                    {
                        $customer_rating= $menu->getFeedbackRate($value->id);
                        $getRestaurantStatus = $this->restaurantOpenCloseStatus($value->id, $orderTime);
                        // Get highest discount and offers
                        $discount_favt = $this->getHighestDiscount($value->id, $orderTime); 
                    }
                    else
                    {
                        continue;
                    }  
                  
                    $restaurant_details[]=[
                        'name'=>trim($value->takeaway_name),
                        'owner_name'=>trim($value->owner_name),
                        'business_address'=>trim($value->business_address),
                        'business_city'=>trim($value->business_city),
                        'business_country'=>trim($value->business_country),
                        'business_postcode'=>trim($value->business_postcode),
                        'business_phone'=>trim($value->business_phone),
                        'business_mobile'=>trim($value->business_mobile),
                        'logo'=>$final_logos_array,
                        'description'=>$final_description,
                        'bg_image'=>trim($final_bg_image),
                        'cusines'=>$final_cousines_array,
                        'rating'=>$customer_rating,
                        'discount'=>$discount_favt,
                        'path'=>$final_menu_path,
                        'restaurantStatus'=>$getRestaurantStatus
                    ];
                }
            }
        }
        
        return $restaurant_details;
    }
    private function getHighestDiscount($clientId, $orderTime) {
        $discount = $this->getListPageOnlineDiscount($clientId, $orderTime);
        if (count($discount) >= 1) {
            $max_discount = 0;
            foreach ($discount as $item) {
                $max = (float)$item["discount"];
                if ($max > $max_discount) {
                    $max_discount = $max;
                    $finalDiscount = $item;
                }
            }
            return $finalDiscount;
        } else {
            return json_decode('{}');
        }
    }

    public function getListPageOnlineDiscount($clientId, $orderTime)
    {
        $zeroBasedDay = date('w', $orderTime);
        $discount = $this->queryAll("CALL getOnlineDiscount($clientId, $zeroBasedDay)");
        $disc = array();

        // Get currency info
        $location = new Location($clientId);
        $currency = $location->getCurrency();
        
        foreach($discount as $key => $data) 
        {
            if($data->from_validity <= $orderTime && $orderTime <= $data->to_validity)
            {
                $disc[$key]['discountCode'] = $data->discount_code;
                $disc[$key]['description'] = $data->description;
                $disc[$key]["discountType"] = ($data->discount_amount_type == 0) ? "%" : $currency['symbol'];
                $disc[$key]['discount'] = $data->discount_amount ;
                $disc[$key]['minOrder'] = $data->min_order_value;
                $disc[$key]['from'] = date('Y-m-d H:i', $data->from_validity);
                $disc[$key]['to'] = date('Y-m-d H:i', $data->to_validity);
            }
        }
        return $disc;
    }
    public function restaurantOpenCloseStatus($clientId, $orderTime)
    {
        $open = array();
        $shiftStatus = 0;
        $menu = new Menu();

        $getMode = $menu->getMode($clientId);
        $checkOpenStatus = $menu->checkOpenStatus($clientId, $orderTime);
        $shiftTiming = $this->shiftTiming($clientId, $orderTime, $getMode);
        if($checkOpenStatus != "") 
        {
            $open['status'] = '2';
            $open['msg'] = "Closed for now";
        } else {
            if($shiftTiming != false) {
                $open['status'] = '0';
                $open['msg'] = "Closed at ".$shiftTiming['endAt'];
                $open['openAt'] = $shiftTiming['startAt'];
            } else {
                $getOrderMode = str_split($getMode->mode);
                if((!in_array(0, $getOrderMode)) && (!in_array(1, $getOrderMode))) {
                   
                    $open['status'] = '3';
                    $open['msg'] = "Not available";
                } elseif($getMode->preorder_sts == 1 && $getMode->preorderenable == 1) {
                    $getAllShiftTime = $this->getAllShiftTime($clientId);
                    $preOrderData = 0;
                    foreach($getAllShiftTime as $data) {
                      
                            $preOrderData = 1;
                      
                    }
                    if($preOrderData == 0) {
                        $open['status'] = '2';
                        $open['msg'] = "Closed for now";
                    } else {
                        $open['status'] = '1';
                        $open['msg'] = "Pre Order";
                    }
                } elseif($getMode->preorder_sts == 0 && $getMode->preorderenable == 0) {
                    // $open['status'] = '1';
                    // $open['msg'] = "Pre Order";
                    $open['status'] = '2';
                    $open['msg'] = "Closed for now";
                } elseif ($getMode->preorder_sts == 1 && $getMode->preorderenable == 0) {
                    $open['status'] = '1';
                    $open['msg'] = "Pre Order";
                } 
                elseif ($getMode->preorder_sts == 0 && $getMode->preorderenable == 1) {
                    $open['status'] = '1';
                    $open['msg'] = "Pre Order";
                } 
                else {
                    $open['status'] = '2';
                    $open['msg'] = "Closed for now";
                }
            }
        }


        return $open;
    }

    public function shiftTiming($clientId, $orderTime, $getMode)
    {
        $getOrderMode = str_split($getMode->mode);
        $orderDate = date('d-m-Y', $orderTime);
        $orderTimeFormatted = date('H:i', $orderTime);
        $orderTimestamp = strtotime($orderTimeFormatted);
    
       
        $type1 = "openat";
        $type2 = "closeat";
       
        // Determine the date to check based on order time
        $hours = date('H', $orderTime);
        $orderDateString = strtotime($orderDate);
        if ($hours < 8) {
            $orderDateString = strtotime(date('d-m-Y', strtotime('-1 day', $orderTime)));
        }
    
        $getShiftTime = $this->getShiftTime($clientId, $orderDateString);
      
        foreach ($getShiftTime as $shift) {

            $collection_open_at=$shift->collection_openat;
            $collection_close_at=$shift->collection_closeat;
            $delivery_open_at=$shift->delivery_openat;
            $delivery_close_at=$shift->delivery_closeat;

           
            $collection_open_at_float=strtotime($collection_open_at);
            $delivery_open_at_float=strtotime($delivery_open_at);

            $collection_close_at_float=strtotime($collection_close_at);
            $delivery_close_at_float=strtotime($delivery_close_at);

            $time_1=$delivery_open_at;
            
            if($collection_open_at_float<$delivery_open_at_float)
            {
                $time_1=$collection_open_at;
            }
            
            $time_2=$delivery_close_at;
            if($delivery_close_at_float<$collection_close_at_float)
            {
                $time_2=$collection_close_at;
               
            }

            
            if($shift->delivery!=1)
            {
                $time_1=$shift->collection_openat;
                $time_2=$shift->collection_closeat;
            }

            if($shift->collection!=1)
            {
                $time_1=$shift->delivery_openat;
                $time_2=$shift->delivery_closeat;
            }

            if($shift->delivery!=1 && $shift->collection!=1)
            {
                continue;
            }
          
    
            if ($time_1 != "" && $time_2 != "") {
                
                $startTimestamp = strtotime($time_1);
                $endTimestamp = strtotime($time_2);
    
                // Check if the shift crosses midnight
                if ($endTimestamp < $startTimestamp) {
                    // $endTimestamp = strtotime('23:59');
                    $crossesMidnight = true;
                } else {
                    $crossesMidnight = false;
                }
                
              
                // Check if the order time falls within the shift period
                if ((in_array(0, $getOrderMode)) || (in_array(1, $getOrderMode))) {
                    if ($orderTimestamp >= $startTimestamp && $orderTimestamp <= $endTimestamp) {
                        return [
                            'startAt' => date('h:i A', $startTimestamp),
                            'endAt' => date('h:i A', $crossesMidnight ? strtotime('23:59') : $endTimestamp)
                        ];
                    } elseif ($crossesMidnight && ($orderTimestamp <= $endTimestamp || $orderTimestamp >= $startTimestamp)) {
                        // print_r($crossesMidnight);
                        // die;
                        return [
                            'startAt' => date('h:i A', $startTimestamp),
                            'endAt' => date('h:i A', strtotime('23:59'))
                        ];
                    }
                }
            }
        }
    
        // If no valid shift found, return false
        return false;
    }

    public function getShiftTime($client_id, $time = "")
    {
        if($time == "")
            $day = date("N");
        else
            $day = date('N', $time);

        # 1 - mon, 2 - tues ,3 - wed, 4 - thur, 5 - fri, 6 - sat, 7 - sun
            
        $client = new Client($client_id);
        return $client->queryAll("call getShift($day)");
    }

    public function getAllShiftTime($client_id)
    {
        $client = new Client($client_id);
        return $client->queryAll("call getAllShift()");
    }
    public function getTablebookingHistory($params)
    {
        $customerId=$params['customer_id'];
        $email=$params['email'];
        $getTablebookingHistory=$this->queryAll("CALL getTablebookingHistory('$customerId','$email')");
        $result_arr=array();
       
        if(count($getTablebookingHistory)>0)
        {
            $getClientdetails=array();
            $client_ids='';
            foreach ($getTablebookingHistory as $key => $value) 
            {
                $client_ids.=$value->client_id.",";
            }
            $client_ids = rtrim($client_ids, ',');
            if($client_ids!= null && $client_ids!='')
            {
                $getCousines=$this->queryAll("CALL getCuisinesBasedClientId('$client_ids')");
                $getClientdetails = array();
                $getLogosClients=array();
                if(count($getCousines)>0)
                {
                    foreach ($getCousines as $key => $value) 
                    {
                        $getLogosClients[$value->client_id]="https://fusionbucket.co.uk/img/".$value->logo;
                        $cuisines_client = trim($value->cuisine, ',');
                    
                            $cuisineName_query = $this->queryAll("CALL getCuisineImageAll('$cuisines_client')");
                            foreach ($cuisineName_query as $key_cousine => $value_cousine) {
                            $getClientdetails[$value->client_id]['cousines'][]= $value_cousine->cuisine_name;
                            
                            }
                        
                        
                        
                    }
                        
                }
                $restaurant_details=array();
                $getRestaurantNamesArr=$this->queryAll("CALL getClientsBasedId('$client_ids')");
                if(count($getRestaurantNamesArr)>0)
                {
                    foreach ($getRestaurantNamesArr as $key => $value) 
                    {
                        $restaurant_details[$value->id]=[
                            'takeaway_name'=>trim($value->takeaway_name),
                            'owner_name'=>trim($value->owner_name),
                            'business_address'=>trim($value->business_address),
                            'business_city'=>trim($value->business_city),
                            'business_country'=>trim($value->business_country),
                            'business_postcode'=>trim($value->business_postcode),
                            'business_phone'=>trim($value->business_phone),
                            'business_mobile'=>trim($value->business_mobile),
                        ];
                    }
                }
                foreach ($getTablebookingHistory as $key => $value) 
                {
                
                    $table_status="Placed";
                    if($value->status=="1" || $value->status==1)
                    {
                        $table_status="Accepted";
                    }
                    else if($value->status=="2" || $value->status==2)
                    {
                        $table_status="Rejected";
                    }
                    $hide_status="false";
                    if($value->hide=="1" || $value->hide==1)
                    {
                        $hide_status="true";
                    }
                
                    $sno=(int)$key+1;
                    $final_cousines_array = isset($getClientdetails[$value->client_id]['cousines']) ? $getClientdetails[$value->client_id]['cousines'] : [];
                    $final_logos_array = isset($getLogosClients[$value->client_id]) ? $getLogosClients[$value->client_id]: [];
                    $final_restaurant_details = isset($restaurant_details[$value->client_id])  ? $restaurant_details[$value->client_id]: [];
                    $result_arr[]=[
                        'id'=> $value->client_table_id,
                        'client_id'=>$value->client_id, 
                        'firstname'=>$value->firstname,
                        'lastname'=>$value->lastname,
                        'email'=>$value->email,
                        'phone'=>$value->phone,
                        'datetime'=>date("M d,Y", $value->datetime),
                        'table'=>date("M d,Y", $value->table),
                        'people'=>$value->people,
                        'comments'=>$value->comments,
                        'order_status'=>$table_status,
                        'hide_status'=>$hide_status,
                        'time'=> date('g:i A', $value->table),
                        'discount'=>0,
                        'logo'=>$final_logos_array,
                        'cousines'=> $final_cousines_array,
                        'restaurant_details'=>$final_restaurant_details,
                    ];  
                }
            }
        }
      
        return $result_arr;
    }

    public function hideTblStatusFK($client_id,$order_id)
    {
        return $this->query("CALL updateTableHideStatusFK($client_id,$order_id,@new_id)");
    }

    public function updateTblOrderStatusFk($client_id,$order_id,$status)
    {
        return $this->query("CALL updateTblOrderStatusFk($client_id,$order_id,$status,@new_id)");
    }
}
