<?php
namespace App\Models;
use Stripe\Stripe;
use Stripe\Exception\ApiErrorException;

class PayPal extends DB
{
    public function createPayPalMID($getStripeConnection, $totalAmountString, $connectId, $clientTransferAmountString, $currency_code = 'gbp')
    {
        Stripe::setApiKey($getStripeConnection);
        try 
        {
            $paymentIntent = \Stripe\PaymentIntent::create([
                'amount' => $totalAmountString,
                'currency' => $currency_code,
                'payment_method_types' => ['paypal'],
                'payment_method_options' => ['paypal' => ['preferred_locale' => 'en-GB']],
                'confirmation_method' => 'automatic',
                'capture_method' => 'automatic',
                'transfer_data' => [
                    "amount" => $clientTransferAmountString,
                    'destination' => $connectId,
                ],
            ]);

            return $paymentIntent; 
        } 
        catch (ApiErrorException $e) 
        {
            return $e->getMessage();
        }
    }

    
}