<?php
namespace App\Models;
use App\Models\Client;
use App\Models\Menu;
require '../config/env.php';

class RestaurantPage extends DB
{
    public function getCuisinesWithLimit($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists,$limit)
    {
        $getAllActiveCuisine = [];
        if($favouriteLists == "0") {
            # restaurant client list query
            $b2cDatas = $this->queryAll("call getB2cActiveClientData($latitude,$longitude,$favouriteLists)");
        } else {
            # favourite client list query
            $b2cDatas = array();
            foreach ($favouriteLists as $cid) {
                $clientId = $cid->client_id;
                $client = $this->query("call getB2cActiveClientData($latitude,$longitude,$clientId)");
                array_push($b2cDatas, $client);
            }    
        }

        $getAllActiveCuisine = json_decode(json_encode($this->getActiveCuisineWithLimit($limit)), true);

        if(!empty($b2cDatas)) {
            foreach ($b2cDatas as $b2cData) {
                $getRestaurantDetails = $this->getRestaurantDetailsForFilters($b2cData, $orderMode, $orderTime, $customerId);
                if($getRestaurantDetails != false) {
                    # get active the cuisine list
                    $cuisines = explode(",",$getRestaurantDetails['cuisine']);
                    foreach ($cuisines as $data) {
                        foreach ($getAllActiveCuisine as $key => &$cuisine) {
                            $getAllActiveCuisine[$key]['name'] = str_replace("Â", "", $cuisine['cuisine_name']);
                            $getAllActiveCuisine[$key]['image'] = $cuisine['cuisine_image'];
                            $getAllActiveCuisine[$key]['url'] = $_ENV['FUSION_CRM_BUCKET']."businessImages/";
                            $getAllActiveCuisine[$key]['client'] = $data == $cuisine['id'] ? (!empty($cuisine['client']) ? $cuisine['client'].",".$b2cData->client_id : "$b2cData->client_id") : (isset($cuisine['client']) ? $cuisine['client'] : "");
                            if($getAllActiveCuisine[$key]['client'] == ""){
                                $getAllActiveCuisine[$key]['count'] = 0;
                            }else{
                                $cuisineValue = explode(",",$getAllActiveCuisine[$key]['client']);
                                $getAllActiveCuisine[$key]['count'] = count($cuisineValue);
                            }
                        }
                    }
                }
            }
        }

        if (empty($getAllActiveCuisine)) {
            return [];
        }
        return $getAllActiveCuisine;
    }

    public function getClientListWithFilters($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists)
    {
        $response = [
            'restaurantList' => [],
            'filter' => [
                'openNow' => "",
                'preOrder' => ""
            ],
            'hygieneRatingFilter' => [
                'rating1' => "",
                'rating2' => "",
                'rating3' => "",
                'rating4' => "",
                'rating5' => ""
            ],
            'offerFilters' => [
                "BOGOF" => "",
                "Meal Deal" => "",
                "Free Gift" => "",
                "Free Delivery" => "",
                "Use Code" => "",
                "No Code" => "",
                "Loyalty" => "",
                "Voucher" => "",
                "Promo" => ""
            ],
            'dietaryFilter' => [],
            'getAllActiveCuisine' => []
        ];
    
        $dietaryType = 0;
        $allDietaryList = $this->queryAll("CALL getDietariesTypes($dietaryType)");
        foreach ($allDietaryList as $item) {
            $response['dietaryFilter'][$item->dietaries_name] = "";
        }

        if($favouriteLists == "0") {
            # restaurant client list query
            $b2cDatas = $this->queryAll("call getB2cActiveClientData($latitude,$longitude,$favouriteLists)");
        } else {
            # favourite client list query
            $b2cDatas = array();
            foreach ($favouriteLists as $cid) {
                $clientId = $cid->client_id;
                $client = $this->query("call getB2cActiveClientData($latitude,$longitude,$clientId)");
                array_push($b2cDatas, $client);
            }    
        }

        $response['getAllActiveCuisine'] = json_decode(json_encode($this->getActiveCuisine()), true);

        if(!empty($b2cDatas)) {
            foreach ($b2cDatas as $b2cData) {
                $getRestaurantDetails = $this->getRestaurantDetailsForFilters($b2cData, $orderMode, $orderTime, $customerId);
                if($getRestaurantDetails != false) {
                    # get active the cuisine list
                    $cuisines = explode(",",$getRestaurantDetails['cuisine']);
                    foreach ($cuisines as $data) {
                        foreach ($response['getAllActiveCuisine'] as $key => &$cuisine) {
                            $response['getAllActiveCuisine'][$key]['name'] = str_replace("Â", "", $cuisine['cuisine_name']);
                            $response['getAllActiveCuisine'][$key]['image'] = $cuisine['cuisine_image'];
                            $response['getAllActiveCuisine'][$key]['url'] = $_ENV['FUSION_CRM_BUCKET']."businessImages/";
                            $response['getAllActiveCuisine'][$key]['client'] = $data == $cuisine['id'] ? (!empty($cuisine['client']) ? $cuisine['client'].",".$b2cData->client_id : "$b2cData->client_id") : (isset($cuisine['client']) ? $cuisine['client'] : "");
                            if($response['getAllActiveCuisine'][$key]['client'] == ""){
                                $response['getAllActiveCuisine'][$key]['count'] = 0;
                            }else{
                                $cuisineValue = explode(",",$response['getAllActiveCuisine'][$key]['client']);
                                $response['getAllActiveCuisine'][$key]['count'] = count($cuisineValue);
                            }
                        }
                    }
                    unset($getRestaurantDetails['restaurant']['cuisine']);

                    $restClientId = $getRestaurantDetails['clientId'];

                    # filter count and client list
                    switch ($getRestaurantDetails['restaurantStatus']['status']) {
                        case 0:
                            $response['filter']['openNow'] .= !empty($response['filter']['openNow']) ? ','.$restClientId : $restClientId;
                            break;
                        case 1:
                            $response['filter']['preOrder'] .= !empty($response['filter']['preOrder']) ? ','.$restClientId : $restClientId;
                            break;
                        default:
                            break;
                    }
                    
                    # hygiene rating filters count and client list
                    switch ($getRestaurantDetails['hygieneRating']) {
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                        case 5:
                            $response['hygieneRatingFilter']["rating".$getRestaurantDetails['hygieneRating']] .= !empty($response['hygieneRatingFilter']["rating".$getRestaurantDetails['hygieneRating']]) ? ','.$restClientId : $restClientId;
                            break;
                        default :
                            break;
                    }

                    # offer list filters count and client list
                    $url = $_ENV["FUSION_CRM_BUCKET"] . "FusionKitchen/offerBanners/";
                    $getBannerImages = $this->query("CALL getBannerImages()");
                    $bannerMap = [
                        "BOGOF" => "buyOneOffer",
                        "Meal Deal" => "mealDeal",
                        "Free Gift" => "freeGift",
                        "Free Delivery" => "freeDelivery",
                        "Use Code" => "useCode",
                        "No Code" => "noCode",
                        "Loyalty" => "loyalty",
                        "Voucher" => "voucher",
                        "Promo" => "promo"
                    ];

                    if (!empty($getRestaurantDetails['offers'])) {
                        foreach ($getRestaurantDetails['offers'] as $offer) {
                            if (isset($bannerMap[$offer])) {
                                $response['offerBanners'][$bannerMap[$offer]] = $url . $getBannerImages->{$bannerMap[$offer]};
                                $response['offerFilters'][$offer] .= !empty($response['offerFilters'][$offer]) ? ',' . $restClientId : $restClientId;
                            }
                        }
                    }

                    # dietary list filters count and client list
                    if(!empty($getRestaurantDetails['dietary'])) {
                        foreach($getRestaurantDetails['dietary'] as $dietary) {
                            switch ($dietary) {
                                case "Gluten Free":
                                    $response['dietaryFilter']['Gluten Free'] .= !empty($response['dietaryFilter']['Gluten Free']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Halal":
                                    $response['dietaryFilter']['Halal'] .= !empty($response['dietaryFilter']['Halal']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Vegan":
                                    $response['dietaryFilter']['Vegan'] .= !empty($response['dietaryFilter']['Vegan']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Vegan Friendly":
                                    $response['dietaryFilter']['Vegan Friendly'] .= !empty($response['dietaryFilter']['Vegan Friendly']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Vegetarian":
                                    $response['dietaryFilter']['Vegetarian'] .= !empty($response['dietaryFilter']['Vegetarian']) ? ','.$restClientId : $restClientId;
                                    break;
                                default:
                                    break;
                            }        
                        }
                    }
                    $response['restaurantList'][] = $getRestaurantDetails;
                }
            }
        }

        if (empty($response['restaurantList'])) {
            return [];
        }
        return $response;
    }

    public function getRestaurantDetailsForFilters($b2cData, $orderMode, $orderTime, $customerId) 
    {
        $clientData = $this->getClientListData($b2cData->client_id);
        if (!$clientData) {
            return false;
        }

        $menu = new Menu();
        $record = $this->constructRestaurantDetailsForFilter($b2cData, $clientData, $orderMode, $orderTime, $customerId);
        return $record;
    }
    
    private function constructRestaurantDetailsForFilter($b2cData, $clientData, $orderMode, $orderTime, $customerId)
    {
        $record = [
            'restaurantStatus' => $this->restaurantOpenCloseStatus($clientData->id, $orderTime, $orderMode),
            'hygieneRating' => $this->calculateHygieneRating($this->getHygieneRating($clientData)),
            'clientId' => $clientData->id,
        ];
    
        // Retrieve and process cuisine list
        $record['cuisineName'] = $this->getCuisineNames($clientData->cuisine);
        $record['cuisine'] = $clientData->cuisine;

        // Get highest discount and offers
        $record['discount'] = $this->getHighestDiscount($clientData->id, $orderTime);
        $record['offers'] = $this->getOfferNames($clientData->id);
        
        // Get dietary information
        $record['dietary'] = $this->getDietaryList($clientData->id);

        return $record;
    }

    public function getClientListWithLimit($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists,$limit)
    {
        $response = array();
        $restaurantList = array();

        if($favouriteLists == "0") {
            # restaurant client list query
            $b2cDatas = $this->queryAll("call getB2cClientDataWithLimit($latitude,$longitude,$favouriteLists,$limit)");
        } else {
            # favourite client list query
            $b2cDatas = array();
            foreach ($favouriteLists as $cid) {
                $clientId = $cid->client_id;
                $client = $this->query("call getB2cClientDataWithLimit($latitude,$longitude,$clientId,$limit)");
                array_push($b2cDatas, $client);
            }    
        }

        if (!empty($b2cDatas)) {
            foreach ($b2cDatas as $b2cData) {
                if ($getRestaurantDetails = $this->getRestaurantDetailsWithLimit($b2cData, $orderMode, $orderTime, $customerId) ?? false) {
                    $restaurantList[] = $getRestaurantDetails;
                }
            }
            if (!empty($restaurantList)) {
                $response['restaurantList'] = $restaurantList;
            }
        }
        
        return $response;
    }

    public function getRestaurantDetailsWithLimit($b2cData, $orderMode, $orderTime, $customerId) {
        $clientData = $this->getClientListData($b2cData->client_id);
        if (!$clientData) {
            return false;
        }

        $menu = new Menu();
        $record = $this->constructRestaurantDetails($b2cData, $clientData, $orderMode, $orderTime, $customerId);
        return $record;
    }
    
    private function getClientListData($clientId) {
        return $this->query("call getClientList($clientId)");
    }
    
    private function constructRestaurantDetails($b2cData, $clientData, $orderMode, $orderTime, $customerId) {
        $record = [
            'orderMode' => $orderMode == 0 ? "Delivery" : "Collection",
            'orderTime' => date('Y-m-d H:i', $orderTime),
            'vip' => $clientData->vip == 1,
            'restaurantStatus' => $this->restaurantOpenCloseStatus($clientData->id, $orderTime, $orderMode),
            'favourite' => $customerId ? (bool)$this->getFavouriteById($customerId, $clientData->id) : false,
            'hygieneRating' => $this->calculateHygieneRating($this->getHygieneRating($clientData)),
            'clientId' => $clientData->id,
            'path' => $clientData->path,
            'miles' => number_format($b2cData->distance, 2),
            'backgroundImage' => $clientData->bg_image ? $_ENV['FUSION_BUCKET'] . $clientData->bg_image : $_ENV['FUSION_BUCKET'] . "takeaway1.jpg",
            'name' => $this->getContacts($clientData),
            'rating' => $this->getFeedbackRate($clientData),
        ];
        // Add cooking time based on order mode
        $getTatStartEnd = $this->getTatStartEnd($clientData);
        switch ($orderMode) {
            case 0:
                $record['cookingTimeStart'] = $getTatStartEnd["deliveryCookingTimeStart"];
                $record['cookingTimeEnd'] = $getTatStartEnd["deliveryCookingTimeEnd"];
                break;
            case 1:
                $record['cookingTimeStart'] = $getTatStartEnd["collectionCookingTimeStart"];
                $record['cookingTimeEnd'] = $getTatStartEnd["collectionCookingTimeEnd"];
                break;
            default:
                break;
        }
        
        // Retrieve and process cuisine list
        $record['cuisineName'] = $this->getCuisineNames($clientData->cuisine);
        $record['cuisine'] = $clientData->cuisine;
        $record['restaurantDetails'] = $this->getRestaurantDetailsData($clientData);

        // Get highest discount and offers
        $record['discount'] = $this->getHighestDiscount($clientData->id, $orderTime);
        $record['offers'] = $this->getOfferNames($clientData->id);
        
        // Get dietary information
        $record['dietary'] = $this->getDietaryList($clientData->id);

        return $record;
    }
        
    private function getCuisineNames($cuisine) {
        $cuisines = explode(',', $cuisine);
        $cuisineNames = [];
        foreach ($cuisines as $cuisineId) {
            $cuisineName = $this->query("CALL getCuisineName($cuisineId)");
            $decodeCuisineName = utf8_decode($cuisineName->cuisine_name);
            $cuisineNames[] = $decodeCuisineName;
        }
        return $cuisineNames;
    }

    private function getRestaurantDetailsData($clientData) {
        $lat = number_format($clientData->lat, 5);
        $lang = number_format($clientData->lang, 5);
        $getRestaurantDetail = $this->query("call getRestaurantDetail($clientData->id)");
        $response['latitude'] = $lat;
        $response['longitude'] = $lang;
        $response['address'] = $getRestaurantDetail->b_hno;
        $response['city'] = $getRestaurantDetail->b_city;
        $response['postCode'] = $getRestaurantDetail->b_postcode;
        return $response;
    }

    private function getHighestDiscount($clientId, $orderTime) {
        $discount = $this->getListPageOnlineDiscount($clientId, $orderTime);
        if (count($discount) >= 1) {
            $max_discount = 0;
            foreach ($discount as $item) {
                $max = (float)$item["discount"];
                if ($max > $max_discount) {
                    $max_discount = $max;
                    $finalDiscount = $item;
                }
            }
            return $finalDiscount;
        } else {
            return json_decode('{}');
        }
    }

    private function getOfferNames($clientId) {
        $offerList = $this->query("CALL getOfferBanner($clientId)");
        $offerNames = [];
        if ($offerList != false) {
            $offers = array_keys(array_filter(json_decode(json_encode($offerList), true)));
            $offerName = array("BOGOF", "Meal Deal", "Free Gift", "Free Delivery", "Use Code", "No Code", "Loyalty", "Voucher", "Promo");
            $offerItems = array("buyOneOffer", "mealDeal", "freeGift", "freeDelivery", "useCode", "noCode", "loyalty", "voucher", "promo");
            foreach ($offers as $offer) {
                $index = array_search($offer, $offerItems);
                if ($index !== false && isset($offerName[$index])) {
                    $offerNames[] = $offerName[$index];
                }
            }
        }
        return $offerNames;
    }

    private function getDietaryList($clientId) {
        $getDietaries = $this->query("CALL getDietaries($clientId)");
        $dietaryType = 0;
        $allDietaryList = $this->queryAll("CALL getDietariesTypes($dietaryType)");
        $dietaryList = [];
        foreach ($allDietaryList as $item) {
            $dietaryList[$item->id] = $item->dietaries_name;
        }
        $dietaryItems = [];
        if ($getDietaries != false) {
            $dietary = str_split($getDietaries->dietaries_type_id);
            foreach ($dietary as $key => $list) {
                $dietaryItems[] = $dietaryList[$list];
            }
        }
        return $dietaryItems;
    }

    private function getContacts($clientData) {
        $menu = new Menu();
        $getContacts = $menu->getContacts($clientData->id);
        return $getContacts->name;
    }

    private function getFeedbackRate($clientData) {
        $menu = new Menu();
        return $menu->getFeedbackRate($clientData->id);
    }
    
    private function getHygieneRating($clientData) {
        $menu = new Menu();
        return $menu->getHygieneRating($clientData->id);
    }

    private function getTatStartEnd($clientData) {
        $menu = new Menu();
        return $menu->getTatStartEnd($clientData->id);
    }

    private function calculateHygieneRating($hygieneRatingData) {
        if (strpos($hygieneRatingData->image1, '.') === false || $hygieneRatingData->image1 !== "1" || $hygieneRatingData->image1 !== "") {
            $hygiene = $hygieneRatingData->image1;
            $position = strpos($hygiene, "rating");
            
            if ($position !== false) {
                return intval(substr($hygiene, $position + 6, 1));
            }
        }
        return 0;
    }

    public function getClientList($latitude,$longitude,$orderMode,$orderTime,$customerId,$favouriteLists,$source="")
    {
        $response = array();
        $restaurantList = array();
        $offerBanners = array();
        $restaurantFilter = array(
            // 'closed' => "",
            'openNow' => "",
            'preOrder' => ""
        );
        $hygieneRatingFilter = array(
            'rating1' => "",
            'rating2' => "",
            'rating3' => "",
            'rating4' => "",
            'rating5' => ""
        );
        $offerFilters = array(
            "BOGOF" => "",
            "Meal Deal" => "",
            "Free Gift" => "",
            "Free Delivery" => "",
            "Use Code" => "",
            "No Code" => "",
            "Loyalty" => "",
            "Voucher" => "",
            "Promo" => ""
        );

        $dietaryType = 0;
        $allDietaryList = $this->queryAll("CALL getDietariesTypes($dietaryType)");
        $dietaryFilter = [];
        foreach ($allDietaryList as $item) {
            $dietaryFilter[$item->dietaries_name] = "";
        }

        if($favouriteLists == "0") {
            # restaurant client list query
            $b2cDatas = $this->queryAll("call getB2cClientData($latitude,$longitude,$favouriteLists)");
        } else {
            # favourite client list query
            $b2cDatas = array();
            foreach ($favouriteLists as $cid) {
                $clientId = $cid->client_id;
                $client = $this->query("call getB2cClientData($latitude,$longitude,$clientId)");
                array_push($b2cDatas, $client);
            }    
        }

        $getAllActiveCuisine = json_decode(json_encode($this->getActiveCuisine()), true);

        if(!empty($b2cDatas)) {
            foreach ($b2cDatas as $b2cData) {
                $getRestaurantDetails = $this->getRestaurantDetails($b2cData, $orderMode, $orderTime, $customerId, $source);
                if($getRestaurantDetails != false) {
                    # get active the cuisine list
                    $cuisines = explode(",",$getRestaurantDetails['restaurant']['cuisine']);
                    foreach ($cuisines as $data) {
                        foreach ($getAllActiveCuisine as $key => &$cuisine) {
                            $getAllActiveCuisine[$key]['name'] = str_replace("Â", "", $cuisine['cuisine_name']);
                            $getAllActiveCuisine[$key]['image'] = $cuisine['cuisine_image'];
                            $getAllActiveCuisine[$key]['url'] = $_ENV['FUSION_CRM_BUCKET']."businessImages/";
                            $getAllActiveCuisine[$key]['client'] = $data == $cuisine['id'] ? (!empty($cuisine['client']) ? $cuisine['client'].",".$b2cData->client_id : "$b2cData->client_id") : (isset($cuisine['client']) ? $cuisine['client'] : "");
                            if($getAllActiveCuisine[$key]['client'] == ""){
                                $getAllActiveCuisine[$key]['count'] = 0;
                            }else{
                                $cuisineValue = explode(",",$getAllActiveCuisine[$key]['client']);
                                $getAllActiveCuisine[$key]['count'] = count($cuisineValue);
                            }
                        }
                    }
                    unset($getRestaurantDetails['restaurant']['cuisine']);

                    $restClientId = $getRestaurantDetails['restaurant']['clientId'];

                    # filter count and client list
                    switch ($getRestaurantDetails['restaurant']['restaurantStatus']['status']) {
                        case 0:
                            $restaurantFilter['openNow'] .= !empty($restaurantFilter['openNow']) ? ','.$restClientId : $restClientId;
                            break;
                        case 1:
                            $restaurantFilter['preOrder'] .= !empty($restaurantFilter['preOrder']) ? ','.$restClientId : $restClientId;
                            break;
                        default:
                            break;
                    }
                    
                    # hygiene rating filters count and client list
                    switch ($getRestaurantDetails['restaurant']['hygieneRating']) {
                        case 1:
                        case 2:
                        case 3:
                        case 4:
                        case 5:
                            $hygieneRatingFilter["rating".$getRestaurantDetails['restaurant']['hygieneRating']] .= !empty($hygieneRatingFilter["rating".$getRestaurantDetails['restaurant']['hygieneRating']]) ? ','.$restClientId : $restClientId;
                            break;
                        default :
                            break;
                    }

                    # offer list filters count and client list
                    if(!empty($getRestaurantDetails['restaurant']['offers'])) {
                        $getBannerImages = $this->query("CALL getBannerImages()");
                        $url = $_ENV["FUSION_CRM_BUCKET"]."FusionKitchen/offerBanners/";
                        foreach($getRestaurantDetails['restaurant']['offers'] as $offer) {
                            switch ($offer) {
                                case "BOGOF":
                                    $offerBanners['BOGOF'] = $url.$getBannerImages->buyOneOffer;
                                    $offerFilters['BOGOF'] .= !empty($offerFilters['BOGOF']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Meal Deal":
                                    $offerBanners['mealDeal'] = $url.$getBannerImages->mealDeal;
                                    $offerFilters['Meal Deal'] .= !empty($offerFilters['Meal Deal']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Free Gift":
                                    $offerBanners['freeGift'] = $url.$getBannerImages->freeGift;
                                    $offerFilters['Free Gift'] .= !empty($offerFilters['Free Gift']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Free Delivery":
                                    $offerBanners['freeDelivery'] = $url.$getBannerImages->freeDelivery;
                                    $offerFilters['Free Delivery'] .= !empty($offerFilters['Free Delivery']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Use Code":
                                    $offerBanners['useCode'] = $url.$getBannerImages->useCode;
                                    $offerFilters['Use Code'] .= !empty($offerFilters['Use Code']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "No Code":
                                    $offerBanners['noCode'] = $url.$getBannerImages->noCode;
                                    $offerFilters['No Code'] .= !empty($offerFilters['No Code']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Loyalty":
                                    $offerBanners['loyalty'] = $url.$getBannerImages->loyalty;
                                    $offerFilters['Loyalty'] .= !empty($offerFilters['Loyalty']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Voucher":
                                    $offerBanners['voucher'] = $url.$getBannerImages->voucher;
                                    $offerFilters['Voucher'] .= !empty($offerFilters['Voucher']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Promo":
                                    $offerBanners['promo'] = $url.$getBannerImages->promo;
                                    $offerFilters['Promo'] .= !empty($offerFilters['Promo']) ? ','.$restClientId : $restClientId;
                                    break;
                                default:
                                    break;
                            }        
                        }
                    }  
            
                    # dietary list filters count and client list
                    if(!empty($getRestaurantDetails['restaurant']['dietary'])) {
                        foreach($getRestaurantDetails['restaurant']['dietary'] as $dietary) {
                            switch ($dietary) {
                                case "Gluten Free":
                                    $dietaryFilter['Gluten Free'] .= !empty($dietaryFilter['Gluten Free']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Halal":
                                    $dietaryFilter['Halal'] .= !empty($dietaryFilter['Halal']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Vegan":
                                    $dietaryFilter['Vegan'] .= !empty($dietaryFilter['Vegan']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Vegan Friendly":
                                    $dietaryFilter['Vegan Friendly'] .= !empty($dietaryFilter['Vegan Friendly']) ? ','.$restClientId : $restClientId;
                                    break;
                                case "Vegetarian":
                                    $dietaryFilter['Vegetarian'] .= !empty($dietaryFilter['Vegetarian']) ? ','.$restClientId : $restClientId;
                                    break;
                                default:
                                    break;
                            }        
                        }
                    }
                    if($source != "web") {
                        $ImageUrl = $_ENV["FUSION_CRM_BUCKET"]."FusionKitchen/offerBanners/";
                        $getofferBannerImages = $this->query("CALL getBannerImages()");
                        if($getofferBannerImages->buyOneOffer == ""){
                            $buyOneOffer = "";
                        }else{
                            $buyOneOffer = $ImageUrl.$getofferBannerImages->buyOneOffer;
                        }
                        if($getofferBannerImages->mealDeal == ""){
                            $mealDeal = "";
                        }else{
                            $mealDeal = $ImageUrl.$getofferBannerImages->mealDeal;
                        }
                        if($getofferBannerImages->freeGift == ""){
                            $freeGift = "";
                        }else{
                            $freeGift = $ImageUrl.$getofferBannerImages->freeGift;
                        }
                        if($getofferBannerImages->freeDelivery == ""){
                            $freeDelivery = "";
                        }else{
                            $freeDelivery = $ImageUrl.$getofferBannerImages->freeDelivery;
                        }
                        if($getofferBannerImages->useCode == ""){
                            $useCode = "";
                        }else{
                            $useCode = $ImageUrl.$getofferBannerImages->useCode;
                        }
                        if($getofferBannerImages->noCode == ""){
                            $noCode = "";
                        }else{
                            $noCode = $ImageUrl.$getofferBannerImages->noCode;
                        }
                        if($getofferBannerImages->loyalty == ""){
                            $loyalty = "";
                        }else{
                            $loyalty = $ImageUrl.$getofferBannerImages->loyalty;
                        }
                        if($getofferBannerImages->voucher == ""){
                            $voucher = "";
                        }else{
                            $voucher = $ImageUrl.$getofferBannerImages->voucher;
                        }
                        if($getofferBannerImages->promo == ""){
                            $promo = "";
                        }else{
                            $promo = $ImageUrl.$getofferBannerImages->promo;
                        }
                        $bannerRecords  = 	array(array("id" => 1,"name" => "buyOneOffer","image"=>$buyOneOffer),
                                            array("id" => 2,"name" => "mealDeal","image"=>$mealDeal),
                                            array("id" => 3,"name" => "freeGift","image"=>$freeGift),
                                            array("id" => 4,"name" => "freeDelivery","image"=>$freeDelivery),
                                            array("id" => 5,"name" => "useCode","image"=>$useCode),
                                            array("id" => 6,"name" => "noCode","image"=>$noCode),
                                            array("id" => 7,"name" => "loyalty","image"=>$loyalty),
                                            array("id" => 8,"name" => "voucher","image"=>$voucher),
                                            array("id" => 9,"name" => "promo","image"=>$promo));
                    }
                    array_push($restaurantList, $getRestaurantDetails);
                }
            }
        }

        if(!empty($restaurantList)) {
            # sorting options top rating, hygiene rating, quickly delivery, reviews 
            $response['restaurantList'] = $restaurantList;
            $response['filter'] = $restaurantFilter;
            $response['hygieneRatingFilter'] = $hygieneRatingFilter;
            $response['offerFilters'] = $offerFilters;
            $response['dietaryFilter'] = $dietaryFilter;
            $response['offerBanners'] = $offerBanners;
            if($source != "web") {
                $response['offerBannerDetails'] = $bannerRecords;
            }
            $response['getAllActiveCuisine'] = $getAllActiveCuisine;
        }
        return $response;
    }

    public function getRestaurantDetails($b2cData,$orderMode,$orderTime,$customerId,$source)
    {
        # get client list with cuisine list
        $clientData = $this->query("call getClientList($b2cData->client_id)");
        if(!empty($clientData) || $clientData != false)
        {
            $result = array();
            $finalDiscount = array();
            $record = array();
            $menu = new Menu();

            # order mode
            if($orderMode == 0)
                $record['restaurant']['orderMode'] = "Delivery";
            elseif($orderMode == 1)
                $record['restaurant']['orderMode'] = "Collection";

            # order time
            $record['restaurant']['orderTime'] = date('Y-m-d H:i', $orderTime);

            # vip
            $record['restaurant']['vip'] = $clientData->vip == 1 ? true : false;
            
            # Check restaurant open close status functionalities
            $restaurantOpenCloseStatus = $this->restaurantOpenCloseStatus($clientData->id, $orderTime, $orderMode);
            $record['restaurant']['restaurantStatus'] = $restaurantOpenCloseStatus;

            # get contact and feedback rating data
            $contactData = $menu->getContacts($clientData->id);
            $getFeedbackRate = $menu->getFeedbackRate($clientData->id);
            $getHygieneRating = $menu->getHygieneRating($clientData->id);

            # get favourite list
            $getFavouriteData = $customerId ? $this->getFavouriteById($customerId,$clientData->id) : false;
            $record['restaurant']['favourite'] = $getFavouriteData ? true : false;

            # get hygiene rating
            if(strpos($getHygieneRating->image1, '.') == true) {
                $hygieneRating = "0";
            } else {
                if($getHygieneRating->image1 == "1" || $getHygieneRating->image1 == "") {
                    $hygieneRating = "0";
                } else {
                    $hygiene = $getHygieneRating->image1;
                    $position = strpos($hygiene, "rating");
                    if ($position !== false) {
                        $letter = substr($hygiene, $position + 6, 1);
                        $hygieneRating = $letter;
                    }
                }
            }

            $record['restaurant']['name'] = $contactData->name;
            $record['restaurant']['rating'] = $getFeedbackRate;
            $record['restaurant']['hygieneRating'] = intval($hygieneRating);
            $record['restaurant']['clientId'] = $clientData->id;
            $record['restaurant']['path'] = $clientData->path;
            $record['restaurant']['miles'] = number_format($b2cData->distance,2);

            # get background image 
            $record['restaurant']['backgroundImage'] = $clientData->bg_image 
                ? $_ENV['FUSION_BUCKET'].$clientData->bg_image 
                : $_ENV['FUSION_BUCKET']."takeaway1.jpg";

            # get tat time
            $getTatStartEnd = $menu->getTatStartEnd($clientData->id);
            switch ($orderMode) {
                case 0:
                    $record['restaurant']['cookingTimeStart'] = $getTatStartEnd["deliveryCookingTimeStart"];
                    $record['restaurant']['cookingTimeEnd'] = $getTatStartEnd["deliveryCookingTimeEnd"];
                    break;
                case 1:
                    $record['restaurant']['cookingTimeStart'] = $getTatStartEnd["collectionCookingTimeStart"];
                    $record['restaurant']['cookingTimeEnd'] = $getTatStartEnd["collectionCookingTimeEnd"];
                    break;
                default: 
                    break;
            }

            # get cuisine list
            $cuisines = explode(',', $clientData->cuisine);
            if($source != "web") {
                $record['restaurant']['cuisineId'] = $cuisines;
            }
            $record['restaurant']['cuisineName'] = array();
            // $cuisineNamesJsonArray = $this->queryAll("CALL getActiveCuisine()");
            // $cuisineNamesArray = array();
            // foreach($cuisineNamesJsonArray as $key => $cuisine) {
            //     $cuisineNamesArray[$cuisine->id] = $cuisine->cuisine_name; 
            // }
            // foreach($cuisines as $cuisineId) {
            //     $decodeCuisineName = utf8_decode($cuisineNamesArray[$cuisineId]);
            //     array_push($record['restaurant']['cuisineName'], $decodeCuisineName);
            // }

            foreach($cuisines as $cuisine) {
                $cuisineName = $this->query("CALL getCuisineName($cuisine)");
                $decodeCuisineName = utf8_decode($cuisineName->cuisine_name);
                array_push($record['restaurant']['cuisineName'], $decodeCuisineName);
            }
            
            $record['restaurant']['cuisine'] = $clientData->cuisine;
            $lat = number_format($clientData->lat,5);
            $lang = number_format($clientData->lang,5);
            $response['latitude'] = $lat;
            $response['longitude'] = $lang;
            $getRestaurantDetail = $this->query("call getRestaurantDetail($clientData->id)");
            $response['address'] = $getRestaurantDetail->b_hno;
            $response['city'] = $getRestaurantDetail->b_city;
            $response['postCode'] = $getRestaurantDetail->b_postcode;
            $record['restaurant']['restaurantDetails'] = $response;

            # get highest discount
            $discount = $this->getListPageOnlineDiscount($clientData->id, $orderTime);
            if(count($discount) >= 1) {
                $max_discount = 0;
                foreach ($discount as $item) {
                    $max = (float)$item["discount"];
                    if ($max > $max_discount) {
                        $max_discount = $max;
                        $finalDiscount = $item;
                    }
                }
                $record['restaurant']['discount'] = $finalDiscount;
            } else {
                $record['restaurant']['discount'] = json_decode('{}');
            }
            $getOfferList = $this->query("CALL getOfferBanner($clientData->id)");
            // $offers = array();
            // if($getOfferList != false) {
            //     foreach($getOfferList as $key => $list) {
            //         if($list != "0" && ($key != "id" && $key != "clientId")) {
            //             array_push($offers, $key);
            //         }
            //     }
            // }
            $record['restaurant']['offers'] = array();
            if($getOfferList != false) {
                $offers = array_keys(array_filter(json_decode(json_encode($getOfferList), true)));
                $offerName = array("BOGOF","Meal Deal","Free Gift","Free Delivery","Use Code","No Code","Loyalty","Voucher","Promo");
                $offerItems = array("buyOneOffer","mealDeal","freeGift","freeDelivery","useCode","noCode","loyalty","voucher","promo");
                foreach($offers as $offer) {
                    $index = array_search($offer, $offerItems);
                    if ($index !== false && isset($offerName[$index])) {
                        array_push($record['restaurant']['offers'], $offerName[$index]);
                    }
                }
            }
            $getDietaries = $this->query("CALL getDietaries($clientData->id)");
            $dietaryType = 0;
            $allDietaryList = $this->queryAll("CALL getDietariesTypes($dietaryType)");
            $dietaryList = [];
            foreach ($allDietaryList as $item) {
                $dietaryList[$item->id] = $item->dietaries_name;
            }
            $record['restaurant']['dietary'] = array();
            if($getDietaries != false) {
                $dietary = str_split($getDietaries->dietaries_type_id);
                foreach($dietary as $key => $list) {
                    array_push($record['restaurant']['dietary'], $dietaryList[$list]);
                }
            }
            return $record;
        }
    }

    public function restaurantOpenCloseStatus($clientId, $orderTime, $orderMode)
    {
        $open = array();
        $shiftStatus = 0;
        $menu = new Menu();

        # Check open close, holidays, bank holiday, mode of order, preorder enable and shift timing functionalities
        $getMode = $menu->getMode($clientId);
        $checkOpenStatus = $menu->checkOpenStatus($clientId, $orderTime);
        $shiftTiming = $this->shiftTiming($clientId, $orderMode, $orderTime, $getMode);


        // print_r($checkOpenStatus);
        // die;

        // return $shiftTiming;

        if($checkOpenStatus != "") 
        {
            $open['status'] = '2';
            $open['msg'] = "Closed for now";
        } else {
            if($shiftTiming != false) {
                $open['status'] = '0';
                $open['msg'] = "Closed at ".$shiftTiming['endAt'];
                $open['openAt'] = $shiftTiming['startAt'];
            } else {
                $getOrderMode = str_split($getMode->mode);
                if(!in_array($orderMode, $getOrderMode)) {
                    if($orderMode == 0) {
                        $orderMode = "Delivery";
                    } else if($orderMode == 1) {
                        $orderMode = "Collection";
                    }
                    $open['status'] = '3';
                    $open['msg'] = $orderMode." not available";
                } elseif($getMode->preorder_sts == 1 && $getMode->preorderenable == 1) {
                    $getAllShiftTime = $this->getAllShiftTime($clientId);
                    $preOrderData = 0;
                    foreach($getAllShiftTime as $data) {
                        if($orderMode == 0 && $data->delivery == 1) {
                            $preOrderData = 1;
                        } else if($orderMode == 1 && $data->collection == 1) {
                            $preOrderData = 1;
                        }
                    }
                    if($preOrderData == 0) {
                        $open['status'] = '2';
                        $open['msg'] = "Closed for now";
                    } else {
                        $open['status'] = '1';
                        $open['msg'] = "Pre Order";
                    }
                } elseif($getMode->preorder_sts == 0 && $getMode->preorderenable == 0) {
                    // $open['status'] = '1';
                    // $open['msg'] = "Pre Order";
                    $open['status'] = '2';
                    $open['msg'] = "Closed for now";
                } elseif ($getMode->preorder_sts == 1 && $getMode->preorderenable == 0) {
                    $open['status'] = '1';
                    $open['msg'] = "Pre Order";
                } 
                elseif ($getMode->preorder_sts == 0 && $getMode->preorderenable == 1) {
                    $open['status'] = '1';
                    $open['msg'] = "Pre Order";
                } 
                else {
                    $open['status'] = '2';
                    $open['msg'] = "Closed for now";
                }
            }
        }


        return $open;
    }

    public function getShiftTime($client_id, $time = "")
    {
        if($time == "")
            $day = date("N");
        else
            $day = date('N', $time);

        # 1 - mon, 2 - tues ,3 - wed, 4 - thur, 5 - fri, 6 - sat, 7 - sun
            
        $client = new Client($client_id);
        return $client->queryAll("call getShift($day)");
    }

    public function getAllShiftTime($client_id)
    {
        $client = new Client($client_id);
        return $client->queryAll("call getAllShift()");
    }

    public function shiftTiming($clientId, $orderMode, $orderTime, $getMode)
    {
        $getOrderMode = str_split($getMode->mode);
        $orderDate = date('d-m-Y', $orderTime);
        $orderTimeFormatted = date('H:i', $orderTime);
        $orderTimestamp = strtotime($orderTimeFormatted);
    
        if ($orderMode == 0) {
            $type1 = "delivery_openat";
            $type2 = "delivery_closeat";
            $type = "delivery";
        } elseif ($orderMode == 1) {
            $type1 = "collection_openat";
            $type2 = "collection_closeat";
            $type = "collection";
        }
    
        // Determine the date to check based on order time
        $hours = date('H', $orderTime);
        $orderDateString = strtotime($orderDate);
        if ($hours < 8) {
            $orderDateString = strtotime(date('d-m-Y', strtotime('-1 day', $orderTime)));
        }
    
        $getShiftTime = $this->getShiftTime($clientId, $orderDateString);
    
        foreach ($getShiftTime as $shift) {
            $time_1 = $shift->$type1;
            $time_2 = $shift->$type2;
    
            if ($time_1 != "" && $time_2 != "") {
                $startTimestamp = strtotime($time_1);
                $endTimestamp = strtotime($time_2);
    
                // Check if the shift crosses midnight
                if ($endTimestamp < $startTimestamp) {
                    // $endTimestamp = strtotime('23:59');
                    $crossesMidnight = true;
                } else {
                    $crossesMidnight = false;
                }
                
                
    
                // Check if the order time falls within the shift period
                if ($shift->$type == 1 && in_array($orderMode, $getOrderMode)) {
                    if ($orderTimestamp >= $startTimestamp && $orderTimestamp <= $endTimestamp) {
                        return [
                            'startAt' => date('h:i A', $startTimestamp),
                            'endAt' => date('h:i A', $crossesMidnight ? strtotime('23:59') : $endTimestamp)
                        ];
                    } elseif ($crossesMidnight && ($orderTimestamp <= $endTimestamp || $orderTimestamp >= $startTimestamp)) {
                        // print_r($crossesMidnight);
                        // die;
                        return [
                            'startAt' => date('h:i A', $startTimestamp),
                            'endAt' => date('h:i A', strtotime('23:59'))
                        ];
                    }
                }
            }
        }
    
        // If no valid shift found, return false
        return false;
    }

    
    public function getListPageOnlineDiscount($clientId, $orderTime)
    {
        $zeroBasedDay = date('w', $orderTime);
        $discount = $this->queryAll("CALL getOnlineDiscount($clientId, $zeroBasedDay)");
        $disc = array();

        // Get currency info
        $location = new Location($clientId);
        $currency = $location->getCurrency();
        
        foreach($discount as $key => $data) 
        {
            if($data->from_validity <= $orderTime && $orderTime <= $data->to_validity)
            {
                $disc[$key]['discountCode'] = $data->discount_code;
                $disc[$key]['description'] = $data->description;
                $disc[$key]["discountType"] = ($data->discount_amount_type == 0) ? "%" : $currency['symbol'];
                $disc[$key]['discount'] = $data->discount_amount ;
                $disc[$key]['minOrder'] = $data->min_order_value;
                $disc[$key]['from'] = date('Y-m-d H:i', $data->from_validity);
                $disc[$key]['to'] = date('Y-m-d H:i', $data->to_validity);
            }
        }
        return $disc;
    }

    public function getActiveCuisineWithLimit($limit)
    {
        return $this->queryAll("CALL getActiveCuisineWithLimit($limit)");
    }

    public function getActiveCuisine()
    {
        return $this->queryAll("CALL getActiveCuisine()");
    }
    
    public function getFavouriteList($user_id)
    {
        return $this->queryAll("CALL getFavouriteList($user_id)");
    }

    public function getFavouriteById($user_id,$client_id)
    {
        return $this->query("CALL getFavouriteById($user_id,$client_id)");
    }

    public function deleteFavouriteById($user_id,$client_id)
    {
        return $this->query("CALL deleteFavouriteById($user_id,$client_id)");
    }

    public function createFavouriteById($user_id,$client_id)
    {
        return $this->query("CALL createFavouriteById($user_id,$client_id)");
    }
    public function getOfferType($offerId)
    {
        return $this->query("CALL getOfferBannerTypes($offerId)");
    }
    public function getOfferBannerTypes($offerId)
    {
        return $this->queryAll("CALL getOfferBannerTypes($offerId)");
    }
    public function getDietariesTypes($dietariesId)
    {
        return $this->query("CALL getDietariesTypes($dietariesId)");
    }
    public function restaurantOpenCloseStatusOptimize($clientId, $orderTime, $orderMode)
    {
        $open = array();
        $shiftStatus = 0;
        $menuPage = new menuPage($clientId);
      
        # Check open close, holidays, bank holiday, mode of order, preorder enable and shift timing functionalities
        $getMode = $menuPage->getMode();
        $checkOpenStatus = $menuPage->checkOpenStatus($clientId, $orderTime);
        $shiftTiming = $this->shiftTiming($clientId, $orderMode, $orderTime, $getMode);


        // print_r($checkOpenStatus);
        // die;

        // return $shiftTiming;

        if($checkOpenStatus != "") 
        {
            $open['status'] = '2';
            $open['msg'] = "Closed for now";
        } else {
            if($shiftTiming != false) {
                $open['status'] = '0';
                $open['msg'] = "Closed at ".$shiftTiming['endAt'];
                $open['openAt'] = $shiftTiming['startAt'];
            } else {
                $getOrderMode = str_split($getMode->mode);
                if(!in_array($orderMode, $getOrderMode)) {
                    if($orderMode == 0) {
                        $orderMode = "Delivery";
                    } else if($orderMode == 1) {
                        $orderMode = "Collection";
                    }
                    $open['status'] = '3';
                    $open['msg'] = $orderMode." not available";
                } elseif($getMode->preorder_sts == 1 && $getMode->preorderenable == 1) {
                    $getAllShiftTime = $this->getAllShiftTime($clientId);
                    $preOrderData = 0;
                    foreach($getAllShiftTime as $data) {
                        if($orderMode == 0 && $data->delivery == 1) {
                            $preOrderData = 1;
                        } else if($orderMode == 1 && $data->collection == 1) {
                            $preOrderData = 1;
                        }
                    }
                    if($preOrderData == 0) {
                        $open['status'] = '2';
                        $open['msg'] = "Closed for now";
                    } else {
                        $open['status'] = '1';
                        $open['msg'] = "Pre Order";
                    }
                } elseif($getMode->preorder_sts == 0 && $getMode->preorderenable == 0) {
                    // $open['status'] = '1';
                    // $open['msg'] = "Pre Order";
                    $open['status'] = '2';
                    $open['msg'] = "Closed for now";
                } elseif ($getMode->preorder_sts == 1 && $getMode->preorderenable == 0) {
                    $open['status'] = '1';
                    $open['msg'] = "Pre Order";
                } 
                elseif ($getMode->preorder_sts == 0 && $getMode->preorderenable == 1) {
                    $open['status'] = '1';
                    $open['msg'] = "Pre Order";
                } 
                else {
                    $open['status'] = '2';
                    $open['msg'] = "Closed for now";
                }
            }
        }


        return $open;
    }
}